Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.beans
Class LibrarySession

    java.lang.Object
      oracle.ifs.beans.LibrarySession

All Implemented Interfaces:
  LibraryConstants, IfsEventHandler, LibrarySessionInterface, LogInfo, Traceable

Direct Known Subclasses:
  TieLibrarySession

    public class LibrarySession

extends java.lang.Object
implements LibrarySessionInterface, IfsEventHandler, Traceable, LibraryConstants, LogInfo

A LibrarySession is used to represent a connection-based Session with the CM SDK server.

A LibrarySession (also known as a "session") object is created by calling the connect method on LibraryService. All other persistent objects (that is, objects that are stored in the CM SDK server) are created from this class.

The public methods on this class can be divided into the following categories:

- Methods to create new persistent objects. The creation methods take the form of a `create[ObjectName]` method, and take a definition object containing creation parameters.
- Methods to free persistent objects, or to delete and undelete PublicObjects.
- Methods to get and set administration modes for the session.
- Methods to server configuration and version information.
- Methods to manage transaction state.
- Methods to get information about the connected user.
- Methods to get Collections for certain classes of objects.
- Methods to find objects by their Identifers.
- Methods to tracing and localization.
- Methods to manage events.

(Published)

Nested Class Summary
`class` | `LibrarySession.ServerSideCoordinator` ServerSideCoordinator is used to coordinate bean-side and server-side operations.

Field Summary
`static long` | `ACLD_DISCOVERER_ADMIN` Id of the permanent admin user.
`protected int` | `m_ApplicationMode` Current application mode.
`protected java.util.Stack` | `m_ApplicationModeStack` A stack of application modes, stored as Integer objects.
`protected java.lang.String` | `m_ApplicationName` Name of the application provided in the original connect options.
`protected long` | `m_AttributesRsn` The resolution sequence number at which an attribute was last added or removed.
`protected java.lang.String` | `m_AuthenticatedUserName` Name of the authenticated user.
`protected java.lang.Long` | `m_ClockOffset` The time offset between the mid tier clock and the DBMS clock.
`protected ConfigurationCategoryDescriptorMap` | `m_ConfigCategoryDescriptorMap` Map for ConfigurationCategory select operations.
`protected boolean` | `m_Connected` connection state; volatile so changes are immediately visible to all threads
`protected java.util.HashMap` | `m_CopyOperationsInProgress` An item of custom state which holds the set of copy() opeartions in progress
`protected java.util.HashMap` | `m_CreateOperationsInProgress` An item of custom state which holds the set of createXXX() opeartions in progress
`protected ContentQuota` | `m_DefaultContentQuota` the default ContentQuota object that will be used for any new Documents
`protected SortSpecification` | `m_DefaultFolderSortSpecification` default SortSpecification for Folder select operations.
`protected java.lang.String` | `m_dnSuffix` Distinguished name suffix, from the server properties.
`protected PropertyBundle` | `m_DomainPropertyBundle` The domain PropertyBundle
`protected oracle.ifs.beans.LibrarySessionEventPoller` | `m_EventPoller` The event poller.
`protected boolean` | `m_EventProcessingEnabled` Whether event processing is enabled for this LibrarySession.
`protected DirectoryUser` | `m_FeignedUser` the current impersonated user.
`protected boolean` | `m_FilterDeletedObjectsEnabled` state of the deleted object filtering.
`protected java.lang.String` | `m_FolderPathDelimiter` the folder-path delimiter for the session defaults to FolderPathResolver.FOLDER_DELIMITER
`protected java.util.HashMap` | `m_FreeOperationsInProgress` An item of custom state which holds the set of free() opeartions in progress
`protected DirectoryUser` | `m_GuestUser` The guest user (lazily set)
`protected java.lang.Long` | `m_Id` Id of the Session
`protected java.lang.Object` | `m_InvokeServerSideLock` Something on which to synchronize during our DMFoo calls and pseudo DMFoo calls.
`protected Cache` | `m_LibraryObjectCache` S_LibraryObject cache
`protected Localizer` | `m_Localizer` the Localizer for this session.
`protected java.util.Hashtable` | `m_ObjectFolderSortSpecification` object-level SortSpecifications for Folder select operations.
`protected boolean` | `m_PreventSessionTimeouts` Indication as to whether session timeouts are suppressed
`protected PrimaryUserProfile` | `m_PrimaryUserProfile` the current user's PrimaryUserProfile.
`protected java.util.Hashtable` | `m_RegisteredClassEventHandlers` Registered class event handlers (see registerEventHandler()).
`protected java.util.Hashtable` | `m_RegisteredEventHandlers` Registered event handlers (see registerEventHandler()).
`protected Folder` | `m_RootFolder` The root folder
`protected long` | `m_Sequence` The next unique sequence value for this session.
`protected LibrarySession.ServerSideCoordinator` | `m_ServerSideCoordinator` Holds server-side coordination info.
`protected java.util.Hashtable` | `m_ServiceConfigurationProperties` table of service configuration properties.
`protected java.lang.Long` | `m_ServiceId` Id of the server-side Service
`protected java.lang.String` | `m_ServiceName` Name of the service.
`protected java.util.Hashtable` | `m_SessionState` Custom state held on behalf of the session.
`protected java.util.HashMap` | `m_UpdateOperationsInProgress` An item of custom state which holds the set of update() opeartions in progress
`protected DirectoryUser` | `m_User` the authenticated user.
`static java.lang.String` | `STATEMENT_KEY_COLLECTION_POLICYLIST` Statement key to use for PolicyList collection.
`static java.lang.String` | `STATEMENT_KEY_COLLECTION_SHAREDACL` Statement key to use for Shared ACL collection.

Fields inherited from interface oracle.ifs.common.LibrarySessionInterface
`DEFAULT_CONTENTQUOTA_PROPERTY, DEFAULT_FOLDER_RELATIONSHIP_PROPERTY, EXECUTIONMODE_ADMINISTRATION, EXECUTIONMODE_DISCOVERYADMINISTRATION, EXECUTIONMODE_INSTALLADMINISTRATION, EXECUTIONMODE_PREEXISTING, EXECUTIONMODE_SYSTEMADMINISTRATION, EXECUTIONMODE_USER, FOLDER_PATH_DELIMITER_PROPERTY, PREVENT_SESSION_TIMEOUTS_PROPERTY, UPGRADE_BEHAVIOR_PROPERTY`

Fields inherited from interface oracle.ifs.beans.resources.LibraryConstants
`AUDIT_EVENT_COLUMN_APPLICATIONCONTEXT, AUDIT_EVENT_COLUMN_APPLICATIONUSER, AUDIT_EVENT_COLUMN_AUXILIARYNUMBER, AUDIT_EVENT_COLUMN_AUXILIARYSTRING, AUDIT_EVENT_COLUMN_CREATEDATE, AUDIT_EVENT_COLUMN_CREATORID, AUDIT_EVENT_COLUMN_DOMAINID, AUDIT_EVENT_COLUMN_ID, AUDIT_EVENT_COLUMN_OPERATIONSUCCEEDED, AUDIT_EVENT_COLUMN_OPERATIONTYPE, AUDIT_EVENT_COLUMN_TARGETOBJECTID, AUDIT_SPECIFICATION_CUSTOM, AUDIT_SPECIFICATION_GLOBAL, AUDIT_SPECIFICATION_OBJECT, AUDIT_SUCCESS_MODE_FAILURE_ONLY, AUDIT_SUCCESS_MODE_NONE, AUDIT_SUCCESS_MODE_SUCCESS_ONLY, AUDIT_SUCCESS_MODE_SUCCESS_OR_FAILURE, CAPABILITY_ADDITEM, CAPABILITY_ADDVERSION, CAPABILITY_ADMINISTER_CATEGORY, CAPABILITY_ADMINISTER_CONFIGURATION, CAPABILITY_ADMINISTER_CONTAINER, CAPABILITY_ADMINISTER_DOMAIN, CAPABILITY_ADMINISTER_LOCK, CAPABILITY_ADMINISTER_QUOTA, CAPABILITY_ADMINISTER_RECORD, CAPABILITY_ADMINISTER_ROLE, CAPABILITY_ADMINISTER_SECURITY, CAPABILITY_ADMINISTER_USER, CAPABILITY_ADMINISTER_WORKSPACE, CAPABILITY_COPY, CAPABILITY_CREATECONTAINER, CAPABILITY_CREATEFOLDER, CAPABILITY_CREATEWORKSPACE, CAPABILITY_DELETE, CAPABILITY_DISCOVER, CAPABILITY_GET_CONTENT, CAPABILITY_GETAUDITHISTORY, CAPABILITY_GETMETADATA, CAPABILITY_GETRELATION, CAPABILITY_LOCK, CAPABILITY_MOVE, CAPABILITY_SET_ATTR, CAPABILITY_SET_CONTENT, CAPABILITY_SETMETADATA, CAPABILITY_SETRELATION, EXCEPTION_INFO_AGGREGATE_ENTRIES, EXCEPTION_INFO_CONFLICTING_OBJECT_ID, EXCEPTION_INFO_DESCRIPTION_MAP, EXCEPTION_INFO_LIMIT, EXCEPTION_INFO_OBJECT_ID, EXCEPTION_INFO_PARAMETER_NAME, IFS_DOMAIN_ACCESSCONTROLLIST_BYPASSNAMEUNIQUENESSCHECK, IFS_DOMAIN_ACCESSCONTROLLIST_COMPOSITEACLSUPPORTED, IFS_DOMAIN_ACLINDEX_EVENTTARGET, IFS_DOMAIN_APPLICATION_INITIALIZERCLASSNAME, IFS_DOMAIN_AUDIT_AUDITINGENABLED, IFS_DOMAIN_AUDITING_GLOBALAUDITEVENTEXPIRATIONPERIOD, IFS_DOMAIN_AUDITING_GLOBALAUDITTYPELIST, IFS_DOMAIN_AUDITRULEEVALUATORCLASS, IFS_DOMAIN_CONFIGURATIONCATEGORYDESCRIPTORMAPCLASSNAME, IFS_DOMAIN_CREDENTIALMANAGER_ANONYMOUSUSER, IFS_DOMAIN_CREDENTIALMANAGER_ANONYMOUSUSERNAME, IFS_DOMAIN_CREDENTIALMANAGER_AUTOUSERPROVISIONINGENABLED, IFS_DOMAIN_CREDENTIALMANAGER_IDM, IFS_DOMAIN_CREDENTIALMANAGER_IDM_COUNT_LIMIT, IFS_DOMAIN_CREDENTIALMANAGER_IDM_EXTERNALLY_SUPPORTED_ATTRIBUTES, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_DIRECTORY_VENDOR, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_GROUP_MEMBER_ATTRIBUTES, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_GROUP_NAME_ATTRIBUTE, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_GROUP_OBJECT_CLASSES, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_GROUP_SEARCHBASES, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_HOST, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_PORT, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_SSL_ENABLED, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_USER_NAME_ATTRIBUTE, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_USER_OBJECT_CLASSES, IFS_DOMAIN_CREDENTIALMANAGER_IDM_LDAP_USER_SEARCHBASES, IFS_DOMAIN_CREDENTIALMANAGER_IDM_PAGE_SIZE, IFS_DOMAIN_CREDENTIALMANAGER_IDM_SECURITY_PROVIDER_TYPE, IFS_DOMAIN_CREDENTIALMANAGER_IDM_TIME_LIMIT, IFS_DOMAIN_CREDENTIALMANAGER_IDM_XML_FILE_PATH, IFS_DOMAIN_CREDENTIALMANAGER_IDM_XML_REALM, IFS_DOMAIN_CREDENTIALMANAGER_IDMENABLED, IFS_DOMAIN_DEFAULT_TIMEZONE_STRING, IFS_DOMAIN_DEFINITIONCLONINGREQUIRED, IFS_DOMAIN_DIRECTORYGROUP_BYPASSNAMEUNIQUENESSCHECK, IFS_DOMAIN_DOCUMENT_DEFINITIONOBJECTEXPIRATIONPERIOD, IFS_DOMAIN_FDKCONFIGURATIONCLASS, IFS_DOMAIN_FOLDERINDEX_EVENTTARGET, IFS_DOMAIN_LIBRARYOBJECT_AUDITSPECIFICATION_GLOBALAUDITHISTORY, IFS_DOMAIN_LIBRARYOBJECT_AUDITSPECIFICATION_OBJECTAUDITHISTORY, IFS_DOMAIN_LIBRARYOBJECT_CLASSACCESSCONTROLLIST_CLASSPRIVATE, IFS_DOMAIN_LIBRARYOBJECT_CLASSACCESSCONTROLLIST_CLASSPUBLIC, IFS_DOMAIN_LIBRARYOBJECT_CLASSACCESSCONTROLLIST_CLASSRESTRICTCREATION, IFS_DOMAIN_LIBRARYOBJECT_MEDIA_DEFAULTCONTENTMEDIA, IFS_DOMAIN_LIBRARYOBJECT_MEDIA_NONCONTENTMEDIA, IFS_DOMAIN_LIBRARYOBJECT_NODECONFIGURATION_DEFAULTNODECONFIGURATION, IFS_DOMAIN_LIBRARYOBJECT_SERVICECONFIGURATION_DEFAULTSERVICECONFIGURATION, IFS_DOMAIN_LIBRARYOBJECT_STORAGEGROUP_DEFAULTSTORAGEGROUP, IFS_DOMAIN_LIBRARYOBJECT_SYSTEMACCESSCONTROLLIST_PRIVATE, IFS_DOMAIN_LIBRARYOBJECT_SYSTEMACCESSCONTROLLIST_PUBLIC, IFS_DOMAIN_LIBRARYOBJECT_SYSTEMACCESSCONTROLLIST_PUBLISHED, IFS_DOMAIN_LIBRARYOBJECT_SYSTEMLOCKOBJECT_SYSTEMHARDLOCK, IFS_DOMAIN_LIBRARYOBJECT_SYSTEMLOCKOBJECT_SYSTEMSOFTLOCK, IFS_DOMAIN_LOCALIZER_DEFAULTEXTENDEDRESOURCEBUNDLENAMES, IFS_DOMAIN_LOCKOBJECT_ENABLED, IFS_DOMAIN_LOOKUP_CLUSTERING_PROPERTIES, IFS_DOMAIN_LOOKUP_CUSTOMLOCKTYPES, IFS_DOMAIN_LOOKUP_ORACLELOCKTYPES, IFS_DOMAIN_LOOKUP_SORTOBJECTCOLLECTION, IFS_DOMAIN_OIDCREDENTIALMANAGERAGENT_SUBSCRIBERS, IFS_DOMAIN_OPERATIONACTIONSPECIFICATION_GLOBALLIST, IFS_DOMAIN_PROPERTYBUNDLE_NAME, IFS_DOMAIN_PROTOCOLS_DAV_COPYMOVETHROUGHFOLDERLINKENABLED, IFS_DOMAIN_PROTOCOLS_DAV_NULLRESOURCELOCKEXPIRATIONPERIOD, IFS_DOMAIN_PROTOCOLS_DAV_USERAGENTS, IFS_DOMAIN_RANDOMACCESSOR_EXPIRATIONPERIOD, IFS_DOMAIN_SEARCH_ATTEMPTCONTEXTSEARCHREWRITE, IFS_DOMAIN_SECURITY_SYNCHRONOUSSECURITYREFRESHENABLED, IFS_DOMAIN_SHAREDSTATEFACTORY, IFS_DOMAIN_UPGRADEINPROGRESS, IFS_DOMAIN_WORKFLOW_BPEL_CREATIONENABLED, IFS_DOMAIN_WORKFLOW_BPEL_WORKLISTURL, IFS_DOMAIN_WORKFLOW_ENABLED, IFS_DOMAIN_WORKFLOW_SCHEMANAME, IFS_DOMAIN_WS_CLEARTEXTAUTHENTICATIONREQUIRESHTTPS, IFS_HANDLER_PROPERTY_BASETIMEOFDAY, IFS_HANDLER_PROPERTY_NOTIFIEDONEVENT, IFS_HANDLER_PROPERTY_TIMERPERIOD, IFS_NODE_DISABLEDINHERITEDPROPERTYNAMES, IFS_NODE_DISABLEDINHERITEDSERVERNAMES, IFS_NODE_ENABLEDINHERITEDPROPERTYNAMES, IFS_NODE_ENABLEDINHERITEDSERVERNAMES, IFS_ORACLELOCKTYPE_KEY_CHECKOUT, IFS_ORACLELOCKTYPE_KEY_DAV, IFS_ORACLELOCKTYPE_KEY_FINALIZED, IFS_ORACLELOCKTYPE_KEY_FREEZE, IFS_ORACLELOCKTYPE_KEY_HASRECORD, IFS_ORACLELOCKTYPE_KEY_LIFECYCLE, IFS_ORACLELOCKTYPE_KEY_MANUAL, IFS_ORACLELOCKTYPE_KEY_NAMEDFREEZE, IFS_ORACLELOCKTYPE_KEY_RECORD, IFS_ORACLELOCKTYPE_KEY_RETENTION, IFS_ORACLELOCKTYPE_KEY_WORKFLOW, IFS_SERVICE_ACLCACHE_EMERGENCYTRIGGER, IFS_SERVICE_ACLCACHE_NORMALTRIGGER, IFS_SERVICE_ACLCACHE_PURGETARGET, IFS_SERVICE_ACLCACHE_SIZE, IFS_SERVICE_ACLCACHE_URGENTTRIGGER, IFS_SERVICE_AUDITCERTIFICATECACHE_PURGETARGET, IFS_SERVICE_AUDITINGENABLED, IFS_SERVICE_AUDITSTRINGCACHE_PURGETARGET, IFS_SERVICE_AURORASERVICE, IFS_SERVICE_CASESENSITIVEAUTHENTICATION, IFS_SERVICE_CHECKFORORPHANSESSIONSPERIOD, IFS_SERVICE_CONNECTIONPOOL_READONLY_MAXIMUMSIZE, IFS_SERVICE_CONNECTIONPOOL_READONLY_MAXIMUMSIZETIMEOUT, IFS_SERVICE_CONNECTIONPOOL_READONLY_MINIMUMSIZE, IFS_SERVICE_CONNECTIONPOOL_READONLY_STATEMENTCACHESIZETRIGGER, IFS_SERVICE_CONNECTIONPOOL_READONLY_STATEMENTCACHETARGET, IFS_SERVICE_CONNECTIONPOOL_READONLY_STATEMENTRESETLIMIT, IFS_SERVICE_CONNECTIONPOOL_READONLY_TARGETSIZE, IFS_SERVICE_CONNECTIONPOOL_READONLY_TARGETSIZETIMEOUT, IFS_SERVICE_CONNECTIONPOOL_WRITEABLE_MAXIMUMSIZE, IFS_SERVICE_CONNECTIONPOOL_WRITEABLE_MAXIMUMSIZETIMEOUT, IFS_SERVICE_CONNECTIONPOOL_WRITEABLE_MINIMUMSIZE, IFS_SERVICE_CONNECTIONPOOL_WRITEABLE_STATEMENTCACHESIZETRIGGER, IFS_SERVICE_CONNECTIONPOOL_WRITEABLE_STATEMENTCACHETARGET, IFS_SERVICE_CONNECTIONPOOL_WRITEABLE_STATEMENTRESETLIMIT, IFS_SERVICE_CONNECTIONPOOL_WRITEABLE_TARGETSIZE, IFS_SERVICE_CONNECTIONPOOL_WRITEABLE_TARGETSIZETIMEOUT, IFS_SERVICE_CONTENTBUFFERSIZE, IFS_SERVICE_CREDENTIALMANAGER, IFS_SERVICE_CREDENTIALMANAGER_CREDENTIALNAMETOKENIZER, IFS_SERVICE_CREDENTIALMANAGER_NAMES, IFS_SERVICE_DATACACHE_EMERGENCYTRIGGER, IFS_SERVICE_DATACACHE_NORMALTRIGGER, IFS_SERVICE_DATACACHE_PURGETARGET, IFS_SERVICE_DATACACHE_SIZE, IFS_SERVICE_DATACACHE_URGENTTRIGGER, IFS_SERVICE_DEFAULTCHARACTERSET, IFS_SERVICE_DEFAULTLANGUAGE, IFS_SERVICE_EVENTEXCHANGER, IFS_SERVICE_EVENTSTATEMENTRESETLIMIT, IFS_SERVICE_JDBC_DEFAULTROWPREFETCH, IFS_SERVICE_JDBC_DRIVER, IFS_SERVICE_JDBC_DRIVERTYPE, IFS_SERVICE_JDBC_TRACINGENABLED, IFS_SERVICE_LOCKTIMEOUTPERIOD, IFS_SERVICE_MAXIMUMCONCURRENTSESSIONS, IFS_SERVICE_MAXIMUMPOOLEDCONTENTBUFFERSPERSESSION, IFS_SERVICE_ORPHANSESSIONTIMEOUTPERIOD, IFS_SERVICE_POLLFOREVENTSFROMOTHERSERVICESPERIOD, IFS_SERVICE_QUOTACHECKFREQUENCYINBYTES, IFS_SERVICE_SERVICEKEEPALIVEEVENTPERIOD, IFS_SERVICE_SESSION_BEANSOBJECTCACHE_SIZE, IFS_SERVICE_SESSION_BEANSSESSION, IFS_SERVICE_SESSION_DATACACHE_EMERGENCYTRIGGER, IFS_SERVICE_SESSION_DATACACHE_NORMALTRIGGER, IFS_SERVICE_SESSION_DATACACHE_PURGETARGET, IFS_SERVICE_SESSION_DATACACHE_SIZE, IFS_SERVICE_SESSION_DATACACHE_URGENTTRIGGER, IFS_SERVICE_SESSION_DEFAULTSEARCHTIMEOUTPERIOD, IFS_SERVICE_SESSION_EVENTPOLLER, IFS_SERVICE_SESSION_EVENTPOLLERPERIOD, IFS_SERVICE_SESSION_FOLDERITEM_CACHING_ENABLED, IFS_SERVICE_SESSION_FOLDERPATHCACHE_ENABLED, IFS_SERVICE_SESSION_FOLDERPATHCACHE_NORMALTRIGGER, IFS_SERVICE_SESSION_FOLDERPATHCACHE_PURGETARGET, IFS_SERVICE_SESSION_FOLDERPATHCACHE_SIZE, IFS_SERVICE_SESSION_FOLDERPATHCACHE_URGENTTRIGGER, IFS_SERVICE_SESSION_SERVEROBJECTCACHE_EMERGENCYTRIGGER, IFS_SERVICE_SESSION_SERVEROBJECTCACHE_ISUNBOUNDED, IFS_SERVICE_SESSION_SERVEROBJECTCACHE_NORMALTRIGGER, IFS_SERVICE_SESSION_SERVEROBJECTCACHE_PURGETARGET, IFS_SERVICE_SESSION_SERVEROBJECTCACHE_SIZE, IFS_SERVICE_SESSION_SERVEROBJECTCACHE_URGENTTRIGGER, IFS_SERVICE_SESSION_SERVERSESSION, IFS_SERVICE_SESSION_TRANSACTIONSTACKSIZE, IFS_SERVICE_SESSIONOPERATIONTIMEOUTPERIOD, IFS_SERVICE_TRACING_BEANSSESSIONTRACETYPE, IFS_SERVICE_TRACING_CHANNELCOUNT, IFS_SERVICE_TRACING_CHANNELLEVEL, IFS_SERVICE_TRACING_DEFAULTTRACELEVEL, IFS_SERVICE_TRACING_SERVERSESSIONTRACETYPE, IFS_SERVICE_TRACING_SERVICETRACETYPE, IFS_SERVICE_TRANSPORTBATCHSIZE, IFS_SERVICE_TRANSPORTEVENTSTOOTHERSERVICESPERIOD, IFS_SESSIONSTATE_APPLICATION_SESSIONID, IFS_SESSIONSTATE_AUDIT_DOMAIN_DEFAULT, IFS_SESSIONSTATE_OPERATIONS_COPYTABLE, IFS_SESSIONSTATE_OPERATIONS_FREETABLE, IFS_SESSIONSTATE_OPERATIONS_UPDATETABLE, LOCKTYPE_CHECKOUT, LOCKTYPE_CUSTOM, LOCKTYPE_DAV, LOCKTYPE_FAMILYHASRECORD, LOCKTYPE_FINALIZED, LOCKTYPE_FREEZE, LOCKTYPE_HAS_RECORD, LOCKTYPE_LIFECYCLE, LOCKTYPE_MANUAL, LOCKTYPE_NAMEDFREEZE, LOCKTYPE_RECORD, LOCKTYPE_RETENTION, LOCKTYPE_WORKFLOW, PUBLIC_SESSIONSTATE_APPLICATION_CONTEXT, PUBLIC_SESSIONSTATE_APPLICATION_USERIDENTIFER, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_CHECKOUT, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_DAV, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_FINALIZED, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_FREEZE, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_HASRECORD, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_LIFECYCLE, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_MANUAL, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_NAMEDFREEZE, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_RECORD, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_RETENTION, RESOURCEKEY_IFS_ORACLELOCKTYPE_DESCRIPTION_WORKFLOW, SYSTEMLOCK_NAME_FINALIZED, SYSTEMLOCK_NAME_FREEZE, SYSTEMLOCK_NAME_HAS_RECORD, SYSTEMLOCK_NAME_LIFECYCLE, SYSTEMLOCK_NAME_RECORD, SYSTEMLOCK_NAME_RETENTION`

Constructor Summary
`protected` | `LibrarySession(S_LibrarySessionInterface ssess, Credential credential, ConnectOptions options, java.lang.String serviceName)` Construct a LibrarySession object.

Method Summary
`void` | `abortImplicitTransaction(Transaction transaction)` Aborts an implicit transaction.
`void` | `abortTransaction(Transaction transaction)` Aborts a transaction.
`void` | `abortTransaction(Transaction transaction, IfsException originalException)` Aborts a transaction in response to the specified IfsException.
`void` | `applyAclIndexDeferredUpdate(AccessControlListDeferredUpdate entry, boolean deleteAfterProcessing)` Apply an ACL index deferred update
`void` | `applyFolderIndexDeferredUpdate(FolderIndexDeferredUpdate entry)` Apply a Folder index deferred update
`Transaction` | `beginImplicitTransaction()` Starts a writeable transaction implicitly at the beginning of an operation.
`Transaction` | `beginTransaction()` Starts a writeable transaction.
`void` | `blockBackgroundProcessing()` Blocks any background event processing.
`protected LibraryObject` | `cacheInstance(java.lang.Long id, LibraryObject obj)` Put a LibraryObject Instance in the session's object cache.
`void` | `cancel()` Cancel any server-side operation in progress for this session.
`java.util.Hashtable` | `captureSessionState()` Capture the current session state for the session.
`void` | `clearCopyContext(java.lang.Long id)` Remove the context of a copy operation for the specified object.
`void` | `clearCreateContext(java.lang.Long id)` Remove the context of a create operation for the specified object.
`void` | `clearFreeContext(java.lang.Long id)` Remove the context of a free operation for the specified object.
`void` | `clearRaciSessionContext(RandomAccessContentInterface raci)` Deprecated. CMSDK 10gR2: use RandomAccessor
`void` | `clearUpdateContext(java.lang.Long id)` Remove the context of an update operation for the specified object.
`void` | `commit()` Makes all pending changes for all in-progress Transactions for this LibrarySession visible to all other LibrarySessions.
`void` | `completeImplicitTransaction(Transaction transaction)` Completes an implicit transaction.
`void` | `completeTransaction(Transaction transaction)` Completes a transaction.
`LibraryObject` | `constructInstance(java.lang.Long id, java.lang.Long class_id, S_ClassObjectData classData)` construct a LibraryObject Instance
`protected LibraryObject` | `constructInstance(S_LibraryObjectData data)` construct a LibraryObject Instance
`Credential` | `createCredential(DirectoryUser user)` Return a credential that can be used to create a new session for the specified user, using the current session's service.
`Credential` | `createCredential(LibraryService service, DirectoryUser user)` Return a credential that can be used to create a new session for the specified user.
`Credential` | `createGuestCredential()` Create a new credential based on the "guest" user.
`LibrarySession` | `createGuestSession()` Create a new session based on the "guest" user.
`LibrarySession` | `createGuestSession(ConnectOptions options)` Create a new session based on the "guest" user.
`PublicObject` | `createPublicObject(PublicObjectDefinition def)` Create a new public object.
`void` | `createRetainedEventDatabaseObjects(RetainedEvent event)` Create tables for a RetainedEvent type.
`SchemaObject` | `createSchemaObject(SchemaObjectDefinition def)` Create a new schema object.
`LibrarySession` | `createSession()` Create a new session based on the user of the current session.
`LibrarySession` | `createSession(DirectoryUser user)` Create a new session for the specified user.
`LibrarySession` | `createSession(DirectoryUser user, ConnectOptions options)` Create a new session for the specified user.
`SystemObject` | `createSystemObject(SystemObjectDefinition def)` Create a new system object.
`void` | `createView(ViewSpecification vsp)` Creates a database view from a View specification.
`void` | `delete(PublicObject[] items)` Deletes all the passed PublicObjects.
`void` | `deleteAclIndexDeferredUpdates(java.lang.Long[] ids)` Deletes a set of Deferred ACL Resolution Entries
`void` | `deleteRepositoryParameter(java.lang.String name)` Deletes the specified repository parameter.
`void` | `deleteRetainedEvent(RetainedEvent event)` delete a RetainedEvent.
`void` | `deregisterClassEventHandler(ClassObject co, boolean includeSubclasses, IfsEventHandler handler)` Deregisters the specified IfsEventHandler for the specified class.
`void` | `deregisterCollection(Collection collection, java.lang.String classname)` Deregisters a collection, cancelling the event registration.
`void` | `deregisterEventHandler(LibraryObject lo, IfsEventHandler handler)` Deregisters the specified IfsEventHandler for the specified LibraryObject.
`void` | `deregisterServiceEventHandler(IfsEventHandler handler)` Deregisters the specified IfsEventHandler.
`boolean` | `disconnect()` Disconnects the session, effectively disposing the instance.
`void` | `disconnectBestEffort()` Disconnects the session, effectively disposing the instance.
`protected void` | `DMAbortTransaction(Transaction transaction)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMaddAccessControlEntry(java.lang.Long id, java.lang.Long classId, S_LibraryObjectDefinition sdef)` Invokes the identically-named remote S_LibrarySession method.
`java.lang.Long` | `DMAddAttributeToClassObject(java.lang.Long id, S_LibraryObjectDefinition def)` Adds an Attribute to an existing ClassObject.
`protected void` | `DMAddFolderRelationship(java.lang.Long id, java.lang.Long classId, S_LibraryObjectDefinition def)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMAddMembersToDirectoryGroup(java.lang.Long group_id, java.lang.Long classid, java.lang.Long[] rightObjIds, java.lang.Long[] rightObjClassids)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMAddMemberToDirectoryGroup(java.lang.Long group_id, java.lang.Long classid, java.lang.Long rightObj, java.lang.Long rightObjClassid)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMAddRelationship(java.lang.Long id, java.lang.Long classId, S_LibraryObjectDefinition def)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMAddToFolder(java.lang.Long folder_id, java.lang.Long classid, java.lang.Long rightObj, java.lang.Long rightObjClassid)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMApplyAclIndexDeferredUpdate(AccessControlListDeferredUpdate entry, boolean deleteAfterProcessing)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMApplyFolderIndexDeferredUpdate(FolderIndexDeferredUpdate entry)` Invokes the identically-named remote S_LibrarySession method.
`protected Transaction` | `DMBeginTransaction(boolean writeable)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMCalculateConsumedStorage(java.lang.Long id, java.lang.Long classid)` Invokes the identically-named remote S_LibrarySession method.
`protected boolean` | `DMCheckExistenceOfPublicObjectByPath(java.lang.Long folder_id, java.lang.Long classid, java.lang.String path)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMCloseFolder(java.lang.Long folder_id, java.lang.Long classid)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMCloseSearch(java.lang.Long id)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMCloseSelector(long cursorId)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMCommit()` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMCompleteTransaction(Transaction transaction)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMConvertToPrivateACL(java.lang.Long id, java.lang.Long classId, S_LibraryObjectDefinition sdef)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMCopyLibraryObject(java.lang.Long id, java.lang.Long classId, S_LibraryObjectDefinition sdef)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMCreateDefaultPolicyPropertyBundle(java.lang.Long id, java.lang.Long classId)` Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework
`protected S_LibraryObjectData` | `DMCreateDefaultPropertyBundle(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`void` | `DMCreateRetainedEventDatabaseObjects(RetainedEvent event)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMCreateView(ViewSpecification vsp)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMDelete(java.lang.Long id, java.lang.Long classId, S_LibraryObjectDefinition def)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMDeleteAclIndexDeferredUpdates(java.lang.Long[] ids)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMDeleteRepositoryParameter(java.lang.String name)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMDeleteRetainedEvent(RetainedEvent event)` Invokes the identically-named remote S_LibrarySession method.
`protected oracle.sql.ORAData` | `DMDequeueMessage(java.lang.Long id, java.lang.Long classId, java.lang.String subscriberName)` Invokes the identically-named remote S_LibrarySession method.
`protected oracle.sql.ORAData` | `DMDequeueMessageFromExceptionQueue(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`void` | `DMDeregisterClassEventHandler(java.lang.Long classId)` Notify server-side that previously registered event handlers for the specified ClassObject have been de-registered.
`void` | `DMDeregisterEventHandler(java.lang.Long id)` Notify server-side that previously registered event handlers for the specified object have been de-registered.
`protected void` | `DMDeregisterServiceEventHandler(IfsEventHandler handler)` Notify server-side to de-register a Service event handler.
`protected void` | `DMDisconnect()` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMDisposeSearch(java.lang.Long id)` Invokes the identically-named remote S_LibrarySession method.
`void` | `DMDropRetainedEventDatabaseObjects(RetainedEvent event)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMEmptyWastebasket()` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMEnqueueMessage(java.lang.Long id, java.lang.Long classId, oracle.sql.ORAData message)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMEnqueueMessage(java.lang.Long id, java.lang.Long classId, oracle.sql.ORAData message, java.lang.String correlation)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMFeignUser(java.lang.Long id, java.lang.Long classid)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long[]` | `DMfetchACEs(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMFetchPolicyListElements(java.lang.Long policyListId, java.lang.Long policyListClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMFetchProperties(java.lang.Long propertyBundleId, java.lang.Long propertyBundleClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long[]` | `DMfetchRevisions(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long[]` | `DMfetchVersionSerieses(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMFilterContent(java.lang.Long contentId, java.lang.Long contentClassId, boolean plaintext, java.lang.Long refObjId, java.lang.Long refObjClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMFilterDeletedObjects(boolean mode)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMFindPublicObjectByPath(java.lang.Long folder_id, java.lang.Long classid, java.lang.String path)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMFlushEvents()` Invokes the identically-named remote S_LibrarySession method.
`boolean` | `DMFolderHasSubFolders(java.lang.Long folder_id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMForceReadEvents()` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMFree(java.lang.Long id, java.lang.Long classId, S_LibraryObjectDefinition def)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMGenerateSummary(java.lang.Long contentId, java.lang.Long contentClassId, java.lang.String pointOfView, long sizeAsPercent, long sizeAsNumParagraphs, java.lang.String summaryLevel, java.lang.Long refObjId, java.lang.Long refObjClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMGenerateThemes(java.lang.Long contentId, java.lang.Long contentClassId, boolean fullThemes, java.lang.Long refObjId, java.lang.Long refObjClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected AccessLevel` | `DMGetAccessLevel(java.lang.Long id, java.lang.Long classId, java.lang.Long userId)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMGetAclIndexDeferredUpdates(int maxItems)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long[]` | `DMGetAllAncestorsOfDirectoryObject(java.lang.Long id, java.lang.Long userid)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.String[]` | `DMGetAllFolderPaths(java.lang.Long id, java.lang.Long classid, java.lang.Long folderRefId, java.lang.Long folderRefClassid, FolderPathOptions fpo, SortSpecification sort)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long[]` | `DMGetAllMembersOfDirectoryGroup(java.lang.Long id, java.lang.Long classid, boolean filterForDiscoverability)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.String` | `DMGetAnyFolderPath(java.lang.Long id, java.lang.Long classid, java.lang.Long folderRefId, java.lang.Long folderRefClassid, FolderPathOptions fpo, SortSpecification sort)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMGetArrayReferencingObjects(java.lang.Long attributeId, AttributeValue referencedValue, SortSpecification sort)` Invokes the identically-named remote S_LibrarySession method.
`protected AttributeValue` | `DMGetArrayTypeAttributeValue(long objectId, long attributeId, long auditId, int count)` Invokes the identically-named remote S_LibrarySession method.
`protected long` | `DMGetAttributesRsn()` Invokes the identically-named remote S_LibrarySession method.
`protected AuditCertificate[]` | `DMGetAuditCertificates(java.lang.Long[] objectIds)` Invokes the identically-named remote S_LibrarySession method.
`protected AttributeValue[]` | `DMGetAuditTypesForClass(java.lang.String className, boolean includeNested)` Invokes the identically-named remote S_LibrarySession method.
`protected AttributeValue[]` | `DMGetAuditTypesForCreateOperations()` Invokes the identically-named remote S_LibrarySession method.
`protected AttributeValue[]` | `DMGetAuditTypesForFreeOperations()` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long[]` | `DMGetCategoryIds(java.lang.Long id, java.lang.Long classid)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long` | `DMGetClockOffset()` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long[]` | `DMGetCompositeAclIds(java.lang.Long id, java.lang.Long classid, SortSpecification sort)` Invokes the identically-named remote S_LibrarySession method.
`protected long` | `DMGetConsumedStorage(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected RandomAccessor` | `DMGetContentByRandomAccess(java.lang.Long coId, java.lang.Long coClassId, java.lang.Long refObjId, java.lang.Long refObjClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected ContentStreamSerializer` | `DMGetContentReader(java.lang.Long id, java.lang.Long classId, java.lang.Long refObjId, java.lang.Long refObjClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected ContentStreamSerializer` | `DMGetContentStream(java.lang.Long id, java.lang.Long classId, java.lang.Long refObjId, java.lang.Long refObjClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected AttributeValue[]` | `DMGetCustomAuditTypes()` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long[]` | `DMGetDirectAncestorsOfDirectoryObject(java.lang.Long id, java.lang.Long userid)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long[]` | `DMGetDirectMembersOfDirectoryGroup(java.lang.Long id, java.lang.Long userid, boolean filterForDiscoverability)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMGetDirectoryUserData()` Invokes the identically-name remote S_LibrarySession method.
`protected java.lang.Long[]` | `DMGetDiscoverabilityOfPublicObjectsIds(java.lang.Long[] ids)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMGetEffectiveClassPolicyListElements(java.lang.Long id, java.lang.Long classId, java.lang.String operation)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMGetEffectivePolicyListElements(java.lang.Long id, java.lang.Long classId, java.lang.String operation)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.String` | `DMGetEncryptedRepositoryParameter(java.lang.String name)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMGetExpiredTimedLocks(int maxItems, int offset)` Invokes the identically-named remote S_LibrarySession method.
`protected ContentStreamSerializer` | `DMGetFilteredContent(java.lang.Long contentId, java.lang.Long contentClassId, java.lang.Long refObjId, java.lang.Long refObjClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMGetFolderIndexDeferredUpdates(int maxItems)` Invokes the identically-named remote S_LibrarySession method.
`protected long` | `DMGetFolderItemCount(java.lang.Long folder_id, java.lang.Long classId, java.lang.String folderRelClassname)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long[]` | `DMGetFolderItemList(java.lang.Long folder_id, java.lang.Long classid, SortSpecification sort)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long[]` | `DMGetFolderReferences(java.lang.Long publicObject_id, java.lang.Long classid, SortSpecification sort)` Invokes the identically-named remote S_LibrarySession method.
`protected long` | `DMGetHighestAuditId()` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long[]` | `DMGetIdsForNewObjects(int length)` Invokes the identically-named remote S_LibrarySession method.
`java.util.Date` | `DMGetLastAccessDate(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMGetLeftwardRelationshipObjects(java.lang.Long id, java.lang.Long classId, java.lang.Long relClassId, SortSpecification sort)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMGetLeftwardRelationships(java.lang.Long id, java.lang.Long classId, java.lang.Long relClassId, SortSpecification sort)` Invokes the identically-named remote S_LibrarySession method.
`protected long` | `DMGetLeftwardRelationshipsCount(java.lang.Long id, java.lang.Long classId, java.lang.Long relClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMgetLibraryObjectData(java.lang.Long id, java.lang.Long classId, java.lang.String attributeName, boolean selectFully)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long[]` | `DMGetLinks(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMGetLockedForSessionObjects()` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.String` | `DMGetNLSDatabaseParameterValue(java.lang.String parameter)` Invokes the identically-named remote S_LibrarySession method.
`protected ObjectReferenceAttributeValue` | `DMGetObjectReferenceAttribute(java.lang.Long id, java.lang.Long classId, java.lang.String attrName)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMGetOurPrimaryUserProfile()` Invokes the identically-named remote S_LibrarySession method.
`java.lang.Long` | `DMGetPartitionValue(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected int` | `DMGetPreparedSelectorItemCount(java.lang.String statementKey, boolean distinct, AttributeValue searchTarget, AttributeValue[] auxSearchTargets, java.lang.String searchDefinition, boolean recursive, java.lang.String hint, AttributeValue[] bindValues)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMGetPrimaryUserProfile(java.lang.Long id)` Invokes the identically-named remote S_LibrarySession method.
`protected AttributeValue` | `DMGetProperty(java.lang.Long propertyBundleId, java.lang.Long propertyBundleClassId, java.lang.String propertyName)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMGetPublicObjectData(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMGetPublicObjectsReferringToLockObject(java.lang.Long id, java.lang.Long classid, SortSpecification sort)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.String` | `DMGetRepositoryParameter(java.lang.String name)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.String[]` | `DMGetRepositoryParameterNames(java.lang.String prefix)` Invokes the identically-named remote S_LibrarySession method.
`protected S_ClassObjectData` | `DMGetResolvedClassObjectData(java.lang.Long id)` Invokes the identically-named remote S_LibrarySession method.
`protected RetainedEvent[]` | `DMGetRetainedEvents(RetainedEvent event, int maxItems)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMGetRightwardRelationshipObjects(java.lang.Long id, java.lang.Long classId, java.lang.Long relClassId, SortSpecification sort)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMGetRightwardRelationships(java.lang.Long id, java.lang.Long classId, java.lang.Long relClassId, SortSpecification sort)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMGetSchemaObjectData(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected int` | `DMgetSearchItemCount(java.lang.Long id, java.util.Vector bindValues, java.lang.String language, int timeout)` Invokes the identically-named remote S_LibrarySession method.
`protected SearchSpecification` | `DMGetSearchSpecification(java.lang.Long srchId)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.String` | `DMgetSearchSQLString(java.lang.Long id)` Invokes the identically-named remote S_LibrarySession method.
`protected long` | `DMGetSelectorItemCount(java.lang.String searchClass, java.lang.String searchDefinition, boolean recursive)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Hashtable` | `DMGetServiceConfigurationProperties()` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long` | `DMGetServiceId()` Invokes the identically-named remote S_LibrarySession method.
`protected int[]` | `DMGetServiceTraceLoggerLevels()` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long` | `DMGetSessionId()` Invokes the identically-named remote S_LibrarySession method.
`protected int[]` | `DMGetSessionTraceLoggerLevels()` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectDefinition` | `DMGetSLibraryObjectDefinition(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected long` | `DMGetSubfolderCount(java.lang.Long folder_id, java.lang.Long classId, java.lang.String folderRelClassname)` Invokes the identically-named remote S_LibrarySession method.
`protected ContentStreamSerializer` | `DMGetSummary(java.lang.Long contentId, java.lang.Long contentClassId, java.lang.String pointOfView, java.lang.Long refObjId, java.lang.Long refObjClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMGetSystemObjectData(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected ContextTheme[]` | `DMGetThemes(java.lang.Long contentId, java.lang.Long contentClassId, java.lang.Long refObjId, java.lang.Long refObjClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected int` | `DMGetTotalFolderItemCount(java.lang.Long folder_id, java.lang.Long classid)` Invokes the identically-named remote S_LibrarySession method.
`protected long` | `DMGetWastebasketSelectorItemCount(java.lang.String searchClass, java.lang.String searchDefinition, boolean recursive)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMGrantAdmin(java.lang.Long userid)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMHandleAuditEventDispatchRequests(java.util.ArrayList reqList, java.lang.String tableName)` Invokes the identically-named remote S_LibrarySession method.
`void` | `DMInsertRetainedEvent(RetainedEvent event)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMIntegrateIntoVersionSeries(java.lang.Long sid, java.lang.Long sclassId, java.lang.Long tid, java.lang.Long tclassId)` Invokes the identically-named remote S_LibrarySession method.
`void` | `DMInvalidateTokenCredentials(java.lang.Long userId)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Object` | `DMInvokeOperation(java.lang.Long id, java.lang.Long classId, OperationContext op)` Invokes the identically-named remote S_LibrarySession method.
`protected java.io.Serializable` | `DMInvokeServerMethod(java.lang.Long id, java.lang.Long classId, java.lang.String methodName, java.io.Serializable payload)` Invokes the identically-named remote S_LibrarySession method.
`protected boolean` | `DMIsAclIndexUpdateModeSynchronous()` Invokes the identically-named remote S_LibrarySession method.
`protected boolean` | `DMIsAttributeValueInValueDomain(java.lang.Long id, java.lang.Long classId, AttributeValue av)` Invokes the identically-named remote S_LibrarySession method.
`protected boolean` | `DMIsContentReadByUser(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected boolean` | `DMIsContextIndexEnabled()` Invokes the identically-named remote S_LibrarySession method.
`protected boolean` | `DMIsDirectMemberOfDirectoryGroup(java.lang.Long groupId, java.lang.Long groupClassId, java.lang.Long userId, java.lang.Long userClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected boolean` | `DMIsExecutionMode(int mode)` Invokes the identically-named remote S_LibrarySession method.
`protected boolean` | `DMIsInstanceOfClassVersionable(java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected boolean` | `DMIsLockObjectShared(java.lang.Long id, java.lang.Long classid)` Invokes the identically-named remote S_LibrarySession method.
`protected boolean` | `DMIsMemberOfDirectoryGroup(java.lang.Long groupId, java.lang.Long groupClassId, java.lang.Long userId, java.lang.Long userClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected boolean` | `DMIsTransactionInProgress()` Invokes the identically-named remote S_LibrarySession method.
`protected boolean` | `DMIsVersionable(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMListItems(java.lang.Long folder_id, java.lang.Long classid, java.lang.String folderRelClassname, SortSpecification sort)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMListPreparedSelectorItems(java.lang.String statementKey, boolean distinct, AttributeValue searchTarget, AttributeValue[] auxSearchTargets, java.lang.String searchDefinition, boolean recursive, java.lang.String language, int maxItemCount, int rowNumber, java.lang.String hint, SortSpecification sort, AttributeValue[] bindValues)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMListSelectorItems(java.lang.String searchClass, java.lang.String searchDefinition, boolean recursive, int maxItemCount, SortSpecification sort)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMListWastebasketSelectorItems(java.lang.String searchClass, java.lang.String searchDefinition, boolean recursive, SortSpecification sort)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMLockRows(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.String[]` | `DMLookupAuditEventOperationTypeKeys(int[] opTypes)` Invokes the identically-named remote S_LibrarySession method.
`protected int[]` | `DMLookupAuditEventOperationTypes(java.lang.String[] keys)` Invokes the identically-named remote S_LibrarySession method.
`AuditTargetCode` | `DMLookupAuditTargetCode(java.lang.String className)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMNewBranchedVersionSeries(java.lang.Long id, java.lang.Long classId, S_LibraryObjectDefinition def)` Invokes the identically-named remote S_LibrarySession method.
`protected ContentStreamSerializer` | `DMNewContentStreamSerializer()` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMNewPublicObject(S_LibraryObjectDefinition def)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMNewRevision(java.lang.Long id, java.lang.Long classId, S_LibraryObjectDefinition def)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMNewSchemaObject(S_LibraryObjectDefinition def)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long` | `DMNewSearch()` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long` | `DMNewSearchFromObject(java.lang.Long srchObjId)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMNewSystemObject(S_LibraryObjectDefinition def)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMNewVersionSeries(java.lang.Long id, java.lang.Long classId, S_LibraryObjectDefinition def)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMNextFolderItem(java.lang.Long folder_id, java.lang.Long classid)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMNextSearchItems(java.lang.Long id, int batchCount)` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMNextSelectorBatch(long cursorId, int batchSize)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectData` | `DMNextSelectorItem(long cursorId)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMOpenFolder(java.lang.Long folder_id, java.lang.Long classid, java.lang.String folderRelClassname, SortSpecification sort)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMOpenSearch(java.lang.Long id, java.util.Vector bindValues, java.lang.String language, int timeout)` Invokes the identically-named remote S_LibrarySession method.
`protected long` | `DMOpenSelector(java.lang.String searchClass, java.lang.String searchDefinition, boolean recursive, SortSpecification sort)` Invokes the identically-named remote S_LibrarySession method.
`protected long` | `DMOpenWastebasketSelector(java.lang.String searchClass, java.lang.String searchDefinition, boolean recursive, SortSpecification sort)` Invokes the identically-named remote S_LibrarySession method.
`void` | `DMPersistTokenCredential(TokenCredential credential)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMPopTemporaryAccessCheckMode()` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMPopTemporaryExecutionMode()` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMPostAuditEvent(AuditEvent event, int mode)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMPostEvent(IfsEvent event)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMProcessEvents()` Invokes the identically-named remote S_LibrarySession method.
`protected java.util.Vector` | `DMProcessEventsInBackground()` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMPushTemporaryAccessCheckMode(boolean mode)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMPushTemporaryExecutionMode(int mode)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMRandomAccessorClose(S_RandomAccessorImpl ra)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMRandomAccessorDispose(S_RandomAccessorImpl ra)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long` | `DMRandomAccessorGetContentObjectId(S_RandomAccessorImpl ra)` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.Long` | `DMRandomAccessorGetDocumentId(S_RandomAccessorImpl ra)` Invokes the identically-named remote S_LibrarySession method.
`protected boolean` | `DMRandomAccessorIsWriteable(S_RandomAccessorImpl ra)` Invokes the identically-named remote S_LibrarySession method.
`protected long` | `DMRandomAccessorLength(S_RandomAccessorImpl ra)` Invokes the identically-named remote S_LibrarySession method.
`protected int` | `DMRandomAccessorRead(S_RandomAccessorImpl ra, long pos, byte[] b, int off, int len)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMRandomAccessorSetSession(S_RandomAccessorImpl ra)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMRandomAccessorTruncate(S_RandomAccessorImpl ra, long len)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMRandomAccessorWrite(S_RandomAccessorImpl ra, long pos, byte[] b, int off, int len)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMReassociateLinks(java.lang.Long oldId, java.lang.Long oldClassId, java.lang.Long newId, java.lang.Long newClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected boolean` | `DMReauthenticate(Credential credential, ConnectOptions options)` Invokes the identically-named remote S_LibrarySession method.
`protected int` | `DMRegisterAuditEventOperationType(java.lang.String opTypeKey, int targetCode, java.lang.String targetClass, int opCode, java.lang.Boolean createOrFree)` Invokes the identically-named remote S_LibrarySession method.
`void` | `DMRegisterClassEventHandler(java.lang.Long classId)` Notify server-side of a registered event handler for the specified ClassObject.
`protected int` | `DMRegisterCustomAuditEventOperationCodeKey(java.lang.String opCodeKey)` Invokes the identically-named remote S_LibrarySession method.
`void` | `DMRegisterEventHandler(java.lang.Long id)` Notify server-side of a registered event handler for the specified object.
`protected void` | `DMRegisterServiceEventHandler(IfsEventHandler handler)` Notify server-side of a new registered Service event handler.
`protected int` | `DMReleaseExpiredLockObject(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMRemoveAccessControlEntry(java.lang.Long id, java.lang.Long classId, java.lang.Long aceId, java.lang.Long aceClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMremoveAllAccessControlEntries(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`void` | `DMRemoveAttributeFromClassObject(java.lang.Long id, S_LibraryObjectDefinition def)` Removes an Attribute from an existing ClassObject.
`protected void` | `DMRemoveAuditEvents(long[] eventIds, java.lang.String tableName)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMRemoveAuditEventsForTarget(java.lang.Long specId, java.lang.Long targetId)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMRemoveFromFolder(java.lang.Long folder_id, java.lang.Long classid, java.lang.Long rightObj, java.lang.Long rightObjClassid, S_LibraryObjectDefinition def)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMRemoveMemberFromDirectoryGroup(java.lang.Long group_id, java.lang.Long classid, java.lang.Long rightObj, java.lang.Long rightObjClassid)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMRemoveMembersFromDirectoryGroup(java.lang.Long group_id, java.lang.Long classid, java.lang.Long[] rightObjIds, java.lang.Long[] rightObjClassids)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMRemoveRawAuditEvents(RawAuditEvent[] rawEvents)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMRemoveRelationship(java.lang.Long id, java.lang.Long classId, java.lang.Long relId, java.lang.Long relClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected ContentStreamSerializer` | `DMRender(java.lang.Long id, java.lang.Long classId, java.lang.String rendererType, java.lang.String rendererName, java.util.Hashtable options, boolean reader)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMReserveNext(java.lang.Long id, java.lang.Long classId, java.lang.String contentPath, java.lang.String comment)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMResolveObjects(java.lang.Long[] ids, java.lang.Long[] classIds, ObjectResolverSpecification spec)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMRollback()` Invokes the identically-named remote S_LibrarySession method.
`protected long` | `DMSchemaVersionNumber()` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.String` | `DMSchemaVersionString()` Invokes the identically-named remote S_LibrarySession method.
`protected AttributeValue[]` | `DMSelectAggregateAuditEventColumns(java.lang.Long auditSpec, java.lang.String aggFuncName, java.lang.String[] columnNames, java.lang.String[] aggColumnNames, java.lang.String filterClause, java.lang.String sortClause)` Invokes the identically-named remote S_LibrarySession method.
`protected AuditEvent[]` | `DMSelectAuditEvents(java.lang.Long auditSpec, java.lang.String filterClause, java.lang.String sortClause, int maxItems)` Invokes the identically-named remote S_LibrarySession method.
`protected RawAuditEvent[]` | `DMSelectRawAuditEvents(java.lang.String filterClause, int maxItems)` Invokes the identically-named remote S_LibrarySession method.
`protected AuditFolderPath` | `DMSelectSpecificAuditFolderPath(long folderPathId)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMSendClientVersionInformation(long versionNumber, java.lang.String versionString)` Invokes the identically-named remote S_LibrarySession method.
`protected S_LibraryObjectDefinition` | `DMSetAttributes(java.lang.Long id, java.lang.Long classId, S_LibraryObjectDefinition def)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMSetContentReadByUser(java.lang.Long id, java.lang.Long classId, boolean readState, java.lang.Long refObjId, java.lang.Long refObjClassId)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMSetEncryptedRepositoryParameter(java.lang.String name, java.lang.String value)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMSetExecutionMode(int mode)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMSetLibrarySession(LibrarySession session)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMSetRepositoryParameter(java.lang.String name, java.lang.String value)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMSetSearchSpecification(java.lang.Long srchId, SearchSpecification sp)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMSetServiceTraceLoggerLevels(int[] levels)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMSetSessionTraceLoggerLevels(int[] levels)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMTrace(int channel, int level, java.lang.Long serviceId, java.lang.Long sessionId, java.lang.Long id, java.lang.String classname, java.lang.String payload)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMUndelete(java.lang.Long id, java.lang.Long classId, S_LibraryObjectDefinition def)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMUnregisterAuditEventOperationType(java.lang.String opTypeKey)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMUnReserve(java.lang.Long id, java.lang.Long classId)` Invokes the identically-named remote S_LibrarySession method.
`protected void` | `DMupdateAccessControlEntry(java.lang.Long id, java.lang.Long classId, java.lang.Long aceId, java.lang.Long aceClassId, S_LibraryObjectDefinition sdef)` Invokes the identically-named remote S_LibrarySession method.
`protected RandomAccessor` | `DMUpdateContentByRandomAccess(java.lang.Long docId, java.lang.Long docClassId, S_LibraryObjectDefinition sdocdef, java.lang.Long expirationPeriod)` Invokes the identically-named remote S_LibrarySession method.
`void` | `DMUpdateLocalizer(java.util.Hashtable properties)` Updates the S_LibrarySession Localizer to reflect the Localizer properties specified as name/value pairs.
`void` | `DMUpdateSessionDefaults(java.util.Hashtable properties)` Invokes the identically-named remote S_LibrarySession method.
`protected long` | `DMVersionNumber()` Invokes the identically-named remote S_LibrarySession method.
`protected java.lang.String` | `DMVersionString()` Invokes the identically-named remote S_LibrarySession method.
`void` | `dropRetainedEventDatabaseObjects(RetainedEvent event)` Drop tables for a RetainedEvent type.
`void` | `emptyWastebasket()` Empty the wastebasket.
`boolean` | `equals(LibrarySession otherSession)` Compares whether two LibrarySessions are the same by comparing IDs.
`java.util.Hashtable` | `establishSessionState(java.util.Hashtable stateMap)` Establish session state for the session.
`void` | `flushEvents()` Flushes any outgoing events to the database.
`void` | `forceReadEvents()` Forces a read and processing of incoming events from other services.
`void` | `free(LibraryObject[] items)` Free all the passed objects.
`java.util.Vector` | `getAclIndexDeferredUpdates(int maxItems)` Gets a set of Deferred ACL Resolution Entries
`int` | `getApplicationMode()` Gets the application mode for the session.
`java.lang.String` | `getApplicationName()` Gets the name of the application that created this session.
`AttributeValue` | `getArrayTypeAttributeValue(AttributeValueArray av, long objectId, long attributeId, long auditId, int count)` Gets a fully resolved array-type AttributeValue with non-transient elements that is a copy of the specified array-type AttributeValue.
`java.lang.String` | `getAttributeSortName(java.lang.String classname, java.lang.String attributename)` return the Database object name that corresponds to an Attribute of a specified ClassObject.
`long` | `getAttributesRsn()` Gets the resolution sequence number at which an attribute was last added or removed.
`AuditCertificate[]` | `getAuditCertificates(java.lang.Long[] objectIds)` Select AuditCertificates for the specified object IDs.
`AttributeValue[]` | `getAuditTypesForClass(java.lang.String className, boolean includeNested)` Gets the audit operation type values for a specified class name, optionally including any types that are applicable to a class that is considered a descendent of the specified class.
`AttributeValue[]` | `getAuditTypesForCreateOperations()` Gets the audit operation type values that correspond to "CREATED" operations.
`AttributeValue[]` | `getAuditTypesForFreeOperations()` Gets the audit operation type values that correspond to "FREE" operations.
`CachePerformance` | `getBeanLibraryObjectDataCachePerformance()` Gets the cache performance object for the bean LibraryObjectData cache.
`Collection` | `getClassAccessControlListCollection()` Gets a reference to the ClassAccessControlList collection.
`Collection` | `getClassDomainCollection()` Gets a reference to the ClassDomain collection.
`ClassObject` | `getClassObjectByName(java.lang.String classname)` Returns a class object given a class name.
`Collection` | `getClassObjectCollection()` Gets a reference to the ClassObject collection.
`AttributeValue` | `getClassObjectValueByName(java.lang.String name)` Gets an AttributeValue representation of a CLASSOBJECT that has the specified name.
`java.lang.Long` | `getClockOffset()` Gets the clock offset, representing the number of milliseconds the DBMS clock is ahead of this mid tier.
`ConfigurationCategoryDescriptor` | `getConfigurationCategoryDescriptor(java.lang.String className)` Gets the ConfigurationCategoryDescriptor for the specified ConfigurationCategory class name.
`LibraryObjectDefinition` | `getCopyContext(java.lang.Long id)` Get the context of a copy operation, if a copy is in progress for the specified object.
`LibraryObjectDefinition` | `getCreateContext(java.lang.Long id)` Get the context of a create operation, if a create is in progress for the specified object.
`Folder` | `getCurrentAuditDomainContext()` Gets the current "Audit Domain" context for the session's user.
`java.util.Date` | `getCurrentDate()` Gets the current Date, with the clock offset applied.
`Folder` | `getCurrentOrDefaultAuditDomainContext()` Gets the current or default "Audit Domain" context for the session's user.
`long` | `getCurrentTimeMillis()` Gets the current time in milliseconds, with the clock offset applied.
`AttributeValue[]` | `getCustomAuditTypes()` Gets the custom audit operation type values.
`java.lang.String` | `getDatabaseCharacterSet()` Returns the Iana character set of the database.
`Media` | `getDefaultContentMedia()` Get the default content Media instance.
`ContentQuota` | `getDefaultContentQuota()` Gets the session's default ContentQuota, set via setDefaultContentQuota().
`java.lang.String` | `getDefaultFolderRelationshipClassname()` Deprecated. CM SDK 10g: no replacement functionality; FolderPathRelationship is now used as the class name
`SortSpecification` | `getDefaultFolderSortSpecification()` get the default SortSpecification that is used by default for all Folder selection operations.
`DirectoryObject` | `getDirectoryObject(java.lang.Long id)` Lookup a DirectoryObject by its id.
`DirectoryObjectInterface` | `getDirectoryObjectInterface(java.lang.Long id)` Gets the DirectoryObjectInterface for the specified id.
`DirectoryObjectInterface[]` | `getDirectoryObjectInterfaces(java.lang.Long[] ids)` Gets the DirectoryObjectInterfaces for the specified ids.
`DirectoryUser` | `getDirectoryUser()` Return the user associated with the current session.
`Collection` | `getDirectoryUserCollection()` Gets a reference to the DirectoryUser collection.
`java.lang.Long[]` | `getDiscoverabilityOfPublicObjectsIds(java.lang.Long[] ids)` Return indication as to which PublicObject objects specified (by ID) the current user can discover.
`PropertyBundle` | `getDomainPropertyBundle()` Gets the domain PropertyBundle.
`AttributeValue` | `getDomainPropertyValue(java.lang.String name)` Gets the value of a domain property, by name.
`java.lang.String` | `getEncryptedRepositoryParameter(java.lang.String name)` Gets the value of the specified repository parameter.
`oracle.ifs.beans.LibrarySessionEventPoller` | `getEventPoller()` Gets the event poller for this LibrarySession.
`Collection` | `getExtendedPermissionCollection()` Gets a reference to the ExtendedPermission collection.
`Collection` | `getExtendedUserProfileCollection()` Gets a reference to the ExtendedUserProfile collection.
`java.util.Vector` | `getFolderIndexDeferredUpdates(int maxItems)` Gets a set of Deferred Folder Index Updates
`java.lang.String` | `getFolderPathDelimiter()` Gets the current session's folder path delimiter.
`protected SortSpecification` | `getFolderSortSpecification(PublicObject po)` get the SortSpecification for a particular object.
`Collection` | `getFormatCollection()` Gets a reference to the Format (by name) collection.
`Collection` | `getFormatExtensionCollection()` Gets a reference to the FormatExtension collection.
`LibraryObjectDefinition` | `getFreeContext(java.lang.Long id)` Get the context of a free operation, if a free is in progress for the specified object.
`OperationActionSpecification[]` | `getGlobalOperationActionSpecifications()` Gets the "global" OperationActionSpecifications.
`DirectoryUser` | `getGuestUser()` Gets the DirectoryUser who is the guest user.
`long` | `getHighestAuditId()` Get the highest Audit Id in use.
`java.lang.Long` | `getId()` Gets the id of this session.
`java.lang.Long` | `getIdForNewObject()` Return an Id that can be used to create a new LibraryObject.
`java.lang.Long[]` | `getIdsForNewObjects(int length)` Return a set of Ids that can be used to import a set of objects.
`IfsConnection` | `getIfsConnection()` Returns an IfsConnection for this LibrarySession.
`LibraryObject` | `getLibraryObject(java.lang.Long id)` Lookup a LibraryObject by its id.
`LibraryObject` | `getLibraryObject(java.lang.Long id, java.lang.Long classId)` Lookup a LibraryObject by its id and classId.
`LibraryObject` | `getLibraryObject(S_LibraryObjectData data)` getLibraryObject - lookup a LibraryObject by its data.
`CachePerformance` | `getLibraryObjectCachePerformance()` Gets the cache performance object for the LibraryObject cache.
`S_LibraryObjectData` | `getLibraryObjectData(java.lang.Long id, java.lang.Long classId, java.lang.String attributeName, boolean selectFully)` Gets the S_LibraryObjectData for the specified id and class id.
`Localizer` | `getLocalizer()` Gets the localizer used by this session.
`Collection` | `getMediaCollection()` Gets a reference to the Media collection.
`java.lang.String` | `getName()` Gets the name of the session.
`long` | `getNextSequence()` Gets the next unique sequence with respect to this session.
`Media` | `getNonContentMedia()` Get the non content Media instance.
`protected SortSpecification` | `getObjectFolderSortSpecification(PublicObject po)` get the SortSpecification for a particular object.
`PublicObject[]` | `getObjectsLockedForSession()` Gets the array of PublicObjects that the current session holds session locks on.
`Collection` | `getPermissionBundleCollection()` Gets a reference to the PermissionBundle collection.
`Collection` | `getPolicyCollection()` Gets a reference to the Policy collection.
`Collection` | `getPolicyListCollection()` Gets a reference to the PolicyList collection.
`PrimaryUserProfile` | `getPrimaryUserProfile()` Return the current user's primary UserProfile.
`PrimaryUserProfile` | `getPrimaryUserProfile(DirectoryUser user)` Return the a specified user's primary UserProfile.
`PublicObject` | `getPublicObject(java.lang.Long id)` Lookup a PublicObject by its id.
`PublicObject` | `getPublicObject(java.lang.Long id, java.lang.Long classId)` Lookup a PublicObject by its id and classId.
`PublicObjectInterface` | `getPublicObjectInterface(java.lang.Long id)` Gets the PublicObjectInterface for the specified id.
`PublicObjectInterface[]` | `getPublicObjectInterfaces(java.lang.Long[] ids)` Gets the PublicObjectInterfaces for the specified ids.
`java.lang.String` | `getRepositoryParameter(java.lang.String name)` Gets the value of the specified repository parameter.
`java.lang.String[]` | `getRepositoryParameterNames(java.lang.String prefix)` Gets the repository parameter names that start with the specified prefix.
`S_ClassObjectData` | `getResolvedClassObjectData(java.lang.Long id)` Gets the fully-resolved S_ClassObjectData.
`java.lang.String` | `getResourceString(java.lang.String key)` Gets the resource string for the specified key.
`java.lang.String` | `getResourceString(java.lang.String key, java.lang.Object[] params)` Gets the resource string for the specified key, and substitutes the specified parameters into that resource string.
`RetainedEvent[]` | `getRetainedEvents(RetainedEvent event, int maxItems)` get a set of RetainedEvents, using a specified RetainedEvent to indicate the type of RetainedEvent desired.
`Folder` | `getRootFolder()` Return the top-most Folder in the CM SDK folder hierarchy.
`SchemaObject` | `getSchemaObject(java.lang.Long id)` Lookup a SchemaObject by its id.
`SchemaObject` | `getSchemaObject(java.lang.Long id, java.lang.Long classId)` Lookup a SchemaObject by its id and classId.
`SchemaObjectInterface` | `getSchemaObjectInterface(java.lang.Long id)` Gets the SchemaObjectInterface for the specified id.
`SchemaObjectInterface[]` | `getSchemaObjectInterfaces(java.lang.Long[] ids)` Gets the SchemaObjectInterfaces for the specified ids.
`long` | `getSchemaVersionNumber()` Returns the version number for the CM SDK schema on which this session is connected.
`java.lang.String` | `getSchemaVersionString()` Returns the version String for the CM SDK schema on which this session is connected.
`java.lang.String` | `getServerProperty(java.lang.String key, java.lang.String defaultValue)` Gets the String value for the specified key in the server properties file.
`java.lang.Object` | `getServerSideLockObject()` Gets the Object used by LibrarySession to synchronize invocations to the server-side class, mainly the invocations of the methods defined by the S_LibrarySessionInterface.
`long` | `getServerVersionNumber()` Returns the CM SDK server-side version number, as a long value.
`java.lang.String` | `getServerVersionString()` Returns the version String for the CM SDK server-side software.
`AttributeValue` | `getServiceConfigurationProperty(java.lang.String name)` Gets the specified service configuration property.
`boolean` | `getServiceConfigurationProperty(java.lang.String name, boolean defaultValue)` Gets the value of the specified service configuration property, as a boolean.
`int` | `getServiceConfigurationProperty(java.lang.String name, int defaultValue)` Gets the value of the specified service configuration property, as an integer.
`java.lang.String` | `getServiceConfigurationProperty(java.lang.String name, java.lang.String defaultValue)` Gets the value of the specified service configuration property, as a string.
`java.lang.Long` | `getServiceId()` Gets the id of this session's service.
`java.lang.String` | `getServiceName()` Gets the name of the CM SDK service to which this session is connected.
`int[]` | `getServiceTraceLoggerLevels()` Gets the trace levels of the S_LibraryServiceTraceLogger.
`protected S_LibrarySessionInterface` | `getSessionContext()` Gets the server-side session context.
`java.lang.String` | `getSessionIdentifier()` Gets a session identifier.
`java.lang.Object` | `getSessionState(java.lang.String key)` Get a session state item.
`int[]` | `getSessionTraceLoggerLevels()` Gets the trace levels of the S_LibrarySessionTraceLogger.
`Collection` | `getSharedAccessControlListCollection()` Gets a reference to the SharedAccessControlList collection.
`protected S_LibraryObjectDataSharedStateFactory` | `getSharedStateFactory()` Returns the Shared State factory in effect for the session.
`Collection` | `getSystemAccessControlListCollection()` Gets a reference to the SystemAccessControlList collection.
`DirectoryUser` | `getSystemDirectoryUser()` Gets the DirectoryUser who is the permanent admin user.
`Collection` | `getSystemLockObjectCollection()` Gets a reference to the SystemLockObject collection.
`SystemObject` | `getSystemObject(java.lang.Long id)` Lookup a SystemObject by its id.
`SystemObject` | `getSystemObject(java.lang.Long id, java.lang.Long classId)` Lookup a SystemObject by its id and classId.
`SystemObjectInterface` | `getSystemObjectInterface(java.lang.Long id)` Gets the SystemObjectInterface for the specified id.
`SystemObjectInterface[]` | `getSystemObjectInterfaces(java.lang.Long[] ids)` Gets the SystemObjectInterfaces for the specified ids.
`java.lang.Object` | `getSystemUserToken()` Gets the system token that can be used to efficiently clone system sessions.
`TraceLogger` | `getTraceLogger()` Gets the trace logger used by this session.
`LibraryObjectDefinition` | `getUpdateContext(java.lang.Long id)` Get the context of an update operation, if an update is in progress for the specified object.
`DirectoryUser` | `getUser()` Return the user associated with the current session.
`java.lang.Long` | `getUserId()` Gets the id of the current user.
`java.lang.String` | `getUserIdentifier()` Return the identifer for the user associated with the current session.
`Collection` | `getValueDefaultCollection()` Gets a reference to the ValueDefault collection.
`Collection` | `getValueDomainCollection()` Gets a reference to the ValueDomain collection.
`long` | `getVersionNumber()` Returns the CM SDK bean-side software version number, as a long value.
`java.lang.String` | `getVersionString()` Returns the version String for the CM SDK bean-side software.
`DirectoryGroup` | `getWorldDirectoryGroup()` Gets the DirectoryGroup that represents World access.
`void` | `grantAdministration(DirectoryUser user)` Grant the Administrator Mode state for the specified Directory User.
`void` | `handleAuditEventDispatchRequests(java.util.ArrayList reqList, java.lang.String tableName)` Handle a list of AuditEvent dispatch requests.
`void` | `handleEvent(IfsEvent event)` Handles the specified event.
`void` | `impersonateUser(DirectoryUser newuser)` Assume the identity of another user.
`protected void` | `initialize()` Initializes connection with CM SDK.
`void` | `insertRetainedEvent(RetainedEvent event)` insert a RetainedEvent.
`void` | `invalidateTokenCredentials(DirectoryUser user)` Invalidates all the token credentials for the given user.
`java.io.Serializable` | `invokeServerMethod(java.lang.String methodName, java.io.Serializable payload)` Invokes a custom server-side method.
`boolean` | `isAclIndexUpdateModeSynchronous()` Check if ACL Index update mode is synchronous
`boolean` | `isAdministrationMode()` Return indication as to whether this session has enabled administrator mode.
`boolean` | `isBusy()` Return busy state of this LibrarySession.
`boolean` | `isConnected()` Return connection state of this LibrarySession
`boolean` | `isDefinitionCloningRequired()` Gets whether the current session requires user-specified instances of LibraryObjectDefinition (or one of its subclasses) to be cloned prior to using it server-side.
`boolean` | `isDiscoverablePublicObjectId(java.lang.Long id)` Return indication as to whether the PublicObject ID specified represents an object that the current user can discover.
`boolean` | `isExecutionMode(int mode)` Checks whether current session is in at least the execution mode specified.
`boolean` | `isFilterDeletedObjectsEnabled()` Return indication as to whether this session has deleted object filtering enabled.
`boolean` | `isFolderItemCachingEnabled()` Gets whether the server supports folder item caching.
`boolean` | `isFullTextIndexingEnabled()` Gets whether full-text indexing is enabled.
`boolean` | `isGuestUser()` Returns true if the session's current user is the guest user.
`boolean` | `isImplicitTransactionInProgress()` Return indication as to whether there is an implicit transaction in progress.
`boolean` | `isInstallationMode()` Return indication as to whether this session is set in installation mode.
`boolean` | `isOuterOperation()` Return indication as to whether the outer most operation (of a potentially nested operation) is currently in progress.
`boolean` | `isPreventSessionTimeouts()` Gets whether the current session prevents any session or operation timeouts.
`boolean` | `isPublicObjectIdDiscoverable(java.lang.Long id)` Return indication as to whether the PublicObject matching the specified object ID is discoverable.
`boolean` | `isSystemAdministrationMode()` Return indication as to whether this session is set in system administration mode.
`boolean` | `isSystemDirectoryUser()` Returns true if the session's current user is the permanent admin user.
`boolean` | `isTraced(int channel, int level)` Gets whether tracing is enabled for the specified channel and level.
`boolean` | `isTransactionInProgress()` Gets whether this LibrarySession is in a transaction, explicit or implicit.
`boolean` | `isUpgradeInProgress()` See if the session behaves as though an upgrade is in progress.
`java.lang.String[]` | `lookupAuditEventOperationTypeKeys(int[] opTypes)` Looks up audit event operation type keys by their numeric values, returning the string keys.
`int[]` | `lookupAuditEventOperationTypes(java.lang.String[] opTypeKeys)` Looks up audit event operation types by their string key, returning the corresponding numeric equivalents.
`AuditTargetCode` | `lookupAuditTargetCode(java.lang.String className)` Looks up an audit target code structure from the specified Class name or other registered alias for the desired type.
`java.lang.String` | `lookupInverseInstanceLabel(java.lang.String classname, java.lang.String label)` Gets the name of an uniquely-named instance by its label.
`ContentStreamSerializer` | `newContentStreamSerializer()` Return the Content stream serializer.
`void` | `popApplicationMode()` Resets any temporary application mode back to the previous temporary application mode setting.
`void` | `popTemporaryAccessCheckMode()` Resets any temporary access check mode back to the previous temporary access check mode.
`void` | `popTemporaryExecutionMode()` Resets any temporary execution state back to the previous temporary execution mode.
`protected void` | `postAdminModeChange()` Post intra-session admin mode change.
`void` | `postAuditEvent(AuditEvent event)` Create a new audit event.
`void` | `postAuditEvent(AuditEvent event, int mode)` Create a new audit event.
`void` | `postAuditEvent(LibraryObject target, AuditEvent event)` Create a new audit event.
`void` | `postAuditEvent(LibraryObject target, AuditEvent event, int mode)` Create a new audit event.
`void` | `postCustomAuditEvent(AuditEvent event)` Create a new custom audit event.
`void` | `postCustomAuditEvent(LibraryObject target, AuditEvent event)` Create a new custom audit event.
`protected void` | `postDefaultFolderOptionChange()` Post intra-session change to default Folder options, such as default sort order or FolderRelationship class.
`protected void` | `postEvent(IfsEvent event)` Post the specified event.
`void` | `processEvent(IfsEvent event)` Processes the specified event.
`void` | `processEvents()` Polls the server for any events queued for transport to this LibrarySession and immediately processes them.
`protected void` | `processEventsInBackground()` Polls the server for any events queued for transport to this LibrarySession and immediately processes them.
`void` | `pushApplicationMode(int mode)` Establishes a new temporary Application mode for the session.
`void` | `pushTemporaryAccessCheckMode(boolean mode)` Establishes a temporary access check mode for the session.
`void` | `pushTemporaryExecutionMode(int mode)` Establishes a temporary execution mode for the session.
`java.lang.Object` | `putSessionState(java.lang.String key, java.lang.Object value)` Add a session state item.
`boolean` | `reauthenticate(Credential credential, ConnectOptions options)` Reauthenticates the DIRECTORYUSER for which this LibrarySession was originally created (as opposed to the DIRECTORYUSER specified by a subsequent call to `impersonateUser`).
`void` | `reestablishRaciSessionContext(RandomAccessContentInterface raci)` Deprecated. CMSDK 10gR2: use RandomAccessor
`int` | `registerAuditEventOperationType(java.lang.String opTypeKey, int targetCode, java.lang.String targetClass, int opCode, java.lang.Boolean createOrFree)` Register a new audit event operation type.
`void` | `registerClassEventHandler(ClassObject co, boolean includeSubclasses, IfsEventHandler handler)` Registers the specified IfsEventHandler to receive events for all objects in the specified class.
`void` | `registerCollection(Collection collection, java.lang.String classname)` Registers a collection so that it can be automatically reset by handleEvent as needed when new LibraryObjects are created, updated, or freed.
`int` | `registerCustomAuditEventOperationCodeKey(java.lang.String opCodeKey)` Register a new custom operation code key.
`void` | `registerCustomAuditEventOperationType(java.lang.String opTypeKey, java.lang.String opCodeKey, int targetCode, java.lang.String targetClass)` Register a new custom audit event operation type.
`void` | `registerEventHandler(LibraryObject lo, IfsEventHandler handler)` Registers the specified IfsEventHandler to receive events for the specified LibraryObject.
`void` | `registerServiceEventHandler(IfsEventHandler handler)` Registers the specified IfsEventHandler to receive events for all committed events processed by the current service.
`void` | `removeAuditEvents(long[] eventIds, java.lang.String tableName)` Free audit events.
`void` | `removeAuditEventsForTarget(java.lang.Long specId, java.lang.Long targetId)` Free audit events from a specific Audit history, by target ID.
`void` | `removeRawAuditEvents(RawAuditEvent[] rawEvents)` Free raw audit events.
`java.lang.Object` | `removeSessionState(java.lang.String key)` Remove a session state item.
`void` | `resolveObjects(LibraryObject[] objs, ObjectResolverSpecification spec)` Force resolution of a set of LibraryObjects
`void` | `resumeBackgroundProcessing()` Resumes any background event processing.
`void` | `rollback()` Discards all pending changes for all in-progress Transactions for this LibrarySession.
`AttributeValue[]` | `selectAggregateAuditEventColumns(java.lang.Long auditSpec, java.lang.String aggFuncName, java.lang.String[] columnNames, java.lang.String[] innerColNames, java.lang.String filterClause, java.lang.String sortClause)` Returns the list of distinct values of the specified AuditEvent columns, along with an optional aggregate function.
`AuditEvent[]` | `selectAuditEvents(java.lang.Long auditSpec, java.lang.String filterClause, java.lang.String sortClause, int maxItems)` Select audit events.
`RawAuditEvent[]` | `selectRawAuditEvents(java.lang.String filterClause, int maxItems)` Select raw audit events.
`AuditFolderPath` | `selectSpecificAuditFolderPath(long folderPathId)` Select the specific AuditFolderPath for a given primary key.
`void` | `setAdministrationMode(boolean mode)` Set the administrator mode state for this session.
`void` | `setApplicationName(java.lang.String name)` Sets the name of the application that is using this session.
`void` | `setCopyContext(java.lang.Long id, LibraryObjectDefinition def)` Set the context of a copy operation for the specified object.
`void` | `setCreateContext(java.lang.Long id, LibraryObjectDefinition def)` Set the context of a create operation for the specified object.
`void` | `setCurrentAuditDomainContext(Folder domain)` Sets the current "Audit Domain" context.
`void` | `setDefaultContentQuota(ContentQuota quota)` Sets the session's default ContentQuota.
`void` | `setDefaultFolderRelationshipClassName(java.lang.String classname)` Deprecated. CM SDK 10g: no replacement functionality; FolderPathRelationship is now used as the class name
`void` | `setDefaultFolderSortSpecification(SortSpecification sort)` Sets the default SortSpecification that is used by default for all Folder selection operations.
`void` | `setDefinitionCloningRequired(boolean option)` Sets whether the current session requires user-specified instances of LibraryObjectDefinition (or one of its subclasses) to be cloned prior to using it server-side.
`void` | `setEncryptedRepositoryParameter(java.lang.String name, java.lang.String value)` Sets the value of the specified repository parameter.
`void` | `setExecutionMode(int mode)` Set the execution mode for this LibrarySession.
`void` | `setFilterDeletedObjectsEnabled(boolean mode)` Set deleted object filtering state for this session.
`void` | `setFolderPathDelimiter(java.lang.String delim)` Sets the current session's Folder path delimiter.
`void` | `setFreeContext(java.lang.Long id, LibraryObjectDefinition def)` Set the context of a free operation for the specified object.
`void` | `setInstallationMode(boolean mode)` Set the Installation Mode state for this LibrarySession.
`protected void` | `setObjectFolderSortSpecification(PublicObject po, SortSpecification sort)` Sets an object-level SortSpecification that is to be used for all Folder selection operations for a particular object.
`void` | `setPreventSessionTimeouts(boolean value)` Sets whether the current session should prevent any session or operation timeouts.
`void` | `setRepositoryParameter(java.lang.String name, java.lang.String value)` Sets the value of the specified repository parameter.
`void` | `setServiceTraceLoggerLevels(int[] levels)` Sets the trace levels of the S_LibraryServiceTraceLogger.
`void` | `setSessionTraceLoggerLevels(int[] levels)` Sets the trace levels of the S_LibrarySessionTraceLogger.
`void` | `setSystemAdministrationMode(boolean mode)` Set the System admin Mode state for this LibrarySession.
`void` | `setUpdateContext(java.lang.Long id, LibraryObjectDefinition def)` Set the context of an update operation for the specified object.
`void` | `setUpgradeInProgress(boolean value)` Sets indication of whether the session behaves as though an upgrade is in progress.
`void` | `trace(int channel, int level, java.lang.String payload)` Issues a trace request to the trace logger.
`void` | `undelete(PublicObject[] items)` Undeletes all the passed PublicObjects.
`void` | `unlockForSession(PublicObject[] items)` Release session locks on a set of PublicObjects.
`void` | `unregisterAuditEventOperationType(java.lang.String opTypeKey)` Unregister an audit event operation type.
`void` | `unregisterCustomAuditEventOperationType(java.lang.String opTypeKey)` Unregister a custom audit event operation type.
`void` | `verifyAdministrationMode()` Verify that the effective execution mode for the session is at least administration mode.
`void` | `verifyExecutionMode(int mode)` Verify that the effective execution mode for the session is at least the mode specified.
`protected void` | `verifyInstallationMode()` Verify that the effective execution mode for the session is at least installation mode.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ACLD_DISCOVERER_ADMIN

    public static final long ACLD_DISCOVERER_ADMIN

  Description copied from class: `LibrarySession`
  Id of the permanent admin user.

  See Also:
    Constant Field Values
  (Unpublished)

### STATEMENT_KEY_COLLECTION_POLICYLIST

    public static final java.lang.String STATEMENT_KEY_COLLECTION_POLICYLIST

  Description copied from class: `LibrarySession`
  Statement key to use for PolicyList collection.

  See Also:
    Constant Field Values
  (Unpublished)

### STATEMENT_KEY_COLLECTION_SHAREDACL

    public static final java.lang.String STATEMENT_KEY_COLLECTION_SHAREDACL

  Description copied from class: `LibrarySession`
  Statement key to use for Shared ACL collection.

  See Also:
    Constant Field Values
  (Unpublished)

### m_User

    protected DirectoryUser m_User

  Description copied from class: `LibrarySession`
  the authenticated user.

  (Unpublished)

### m_FeignedUser

    protected DirectoryUser m_FeignedUser

  Description copied from class: `LibrarySession`
  the current impersonated user.

  (Unpublished)

### m_PrimaryUserProfile

    protected PrimaryUserProfile m_PrimaryUserProfile

  Description copied from class: `LibrarySession`
  the current user's PrimaryUserProfile.

  (Unpublished)

### m_DomainPropertyBundle

    protected PropertyBundle m_DomainPropertyBundle

  Description copied from class: `LibrarySession`
  The domain PropertyBundle

  (Unpublished)

### m_GuestUser

    protected DirectoryUser m_GuestUser

  Description copied from class: `LibrarySession`
  The guest user (lazily set)

  (Unpublished)

### m_RootFolder

    protected Folder m_RootFolder

  Description copied from class: `LibrarySession`
  The root folder

  (Unpublished)

### m_Connected

    protected volatile boolean m_Connected

  Description copied from class: `LibrarySession`
  connection state; volatile so changes are immediately visible to all threads

  (Unpublished)

### m_Id

    protected java.lang.Long m_Id

  Description copied from class: `LibrarySession`
  Id of the Session

  (Unpublished)

### m_AttributesRsn

    protected long m_AttributesRsn

  Description copied from class: `LibrarySession`
  The resolution sequence number at which an attribute was last added or removed.

  (Unpublished)

### m_Sequence

    protected long m_Sequence

  Description copied from class: `LibrarySession`
  The next unique sequence value for this session.

  (Unpublished)

### m_ServiceId

    protected java.lang.Long m_ServiceId

  Description copied from class: `LibrarySession`
  Id of the server-side Service

  (Unpublished)

### m_ClockOffset

    protected java.lang.Long m_ClockOffset

  Description copied from class: `LibrarySession`
  The time offset between the mid tier clock and the DBMS clock.

  (Unpublished)

### m_AuthenticatedUserName

    protected java.lang.String m_AuthenticatedUserName

  Description copied from class: `LibrarySession`
  Name of the authenticated user.

  (Unpublished)

### m_ServiceName

    protected java.lang.String m_ServiceName

  Description copied from class: `LibrarySession`
  Name of the service.

  (Unpublished)

### m_ApplicationName

    protected java.lang.String m_ApplicationName

  Description copied from class: `LibrarySession`
  Name of the application provided in the original connect options.

  (Unpublished)

### m_dnSuffix

    protected java.lang.String m_dnSuffix

  Description copied from class: `LibrarySession`
  Distinguished name suffix, from the server properties.

  (Unpublished)

### m_ServiceConfigurationProperties

    protected java.util.Hashtable m_ServiceConfigurationProperties

  Description copied from class: `LibrarySession`
  table of service configuration properties.

  (Unpublished)

### m_FilterDeletedObjectsEnabled

    protected boolean m_FilterDeletedObjectsEnabled

  Description copied from class: `LibrarySession`
  state of the deleted object filtering.

  (Unpublished)

### m_DefaultFolderSortSpecification

    protected SortSpecification m_DefaultFolderSortSpecification

  Description copied from class: `LibrarySession`
  default SortSpecification for Folder select operations.

  (Unpublished)

### m_ObjectFolderSortSpecification

    protected java.util.Hashtable m_ObjectFolderSortSpecification

  Description copied from class: `LibrarySession`
  object-level SortSpecifications for Folder select operations.

  (Unpublished)

### m_ConfigCategoryDescriptorMap

    protected ConfigurationCategoryDescriptorMap m_ConfigCategoryDescriptorMap

  Description copied from class: `LibrarySession`
  Map for ConfigurationCategory select operations.

  (Unpublished)

### m_PreventSessionTimeouts

    protected boolean m_PreventSessionTimeouts

  Description copied from class: `LibrarySession`
  Indication as to whether session timeouts are suppressed

  (Unpublished)

### m_EventProcessingEnabled

    protected boolean m_EventProcessingEnabled

  Description copied from class: `LibrarySession`
  Whether event processing is enabled for this LibrarySession.

  (Unpublished)

### m_InvokeServerSideLock

    protected java.lang.Object m_InvokeServerSideLock

  Description copied from class: `LibrarySession`
  Something on which to synchronize during our DMFoo calls and pseudo DMFoo calls.

  (Unpublished)

### m_ServerSideCoordinator

    protected LibrarySession.ServerSideCoordinator m_ServerSideCoordinator

  Description copied from class: `LibrarySession`
  Holds server-side coordination info.

  (Unpublished)

### m_EventPoller

    protected oracle.ifs.beans.LibrarySessionEventPoller m_EventPoller

  Description copied from class: `LibrarySession`
  The event poller.

  (Unpublished)

### m_RegisteredEventHandlers

    protected java.util.Hashtable m_RegisteredEventHandlers

  Description copied from class: `LibrarySession`
  Registered event handlers (see registerEventHandler()).

  (Unpublished)

### m_RegisteredClassEventHandlers

    protected java.util.Hashtable m_RegisteredClassEventHandlers

  Description copied from class: `LibrarySession`
  Registered class event handlers (see registerEventHandler()).

  (Unpublished)

### m_LibraryObjectCache

    protected Cache m_LibraryObjectCache

  Description copied from class: `LibrarySession`
  S_LibraryObject cache

  (Unpublished)

### m_Localizer

    protected Localizer m_Localizer

  Description copied from class: `LibrarySession`
  the Localizer for this session.

  (Unpublished)

### m_FolderPathDelimiter

    protected java.lang.String m_FolderPathDelimiter

  Description copied from class: `LibrarySession`
  the folder-path delimiter for the session defaults to FolderPathResolver.FOLDER_DELIMITER

  (Unpublished)

### m_DefaultContentQuota

    protected ContentQuota m_DefaultContentQuota

  Description copied from class: `LibrarySession`
  the default ContentQuota object that will be used for any new Documents

  (Unpublished)

### m_SessionState

    protected java.util.Hashtable m_SessionState

  Description copied from class: `LibrarySession`
  Custom state held on behalf of the session.

  (Unpublished)

### m_CreateOperationsInProgress

    protected java.util.HashMap m_CreateOperationsInProgress

  Description copied from class: `LibrarySession`
  An item of custom state which holds the set of createXXX() opeartions in progress

  (Unpublished)

### m_FreeOperationsInProgress

    protected java.util.HashMap m_FreeOperationsInProgress

  Description copied from class: `LibrarySession`
  An item of custom state which holds the set of free() opeartions in progress

  (Unpublished)

### m_UpdateOperationsInProgress

    protected java.util.HashMap m_UpdateOperationsInProgress

  Description copied from class: `LibrarySession`
  An item of custom state which holds the set of update() opeartions in progress

  (Unpublished)

### m_CopyOperationsInProgress

    protected java.util.HashMap m_CopyOperationsInProgress

  Description copied from class: `LibrarySession`
  An item of custom state which holds the set of copy() opeartions in progress

  (Unpublished)

### m_ApplicationModeStack

    protected java.util.Stack m_ApplicationModeStack

  Description copied from class: `LibrarySession`
  A stack of application modes, stored as Integer objects.

  (Unpublished)

### m_ApplicationMode

    protected int m_ApplicationMode

  Description copied from class: `LibrarySession`
  Current application mode.

  (Unpublished)

Constructor Detail

### LibrarySession

    protected LibrarySession(S_LibrarySessionInterface ssess,
                             Credential credential,
                             ConnectOptions options,
                             java.lang.String serviceName)
                      throws IfsException

  Construct a LibrarySession object.

  Parameters:
    `ssess` - the S_LibrarySession
    `credential` - the user's credentials
    `options` - connect options
    `serviceName` - the LibraryServiceName
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

Method Detail

### initialize

    protected void initialize()
                       throws IfsException

  Description copied from class: `LibrarySession`
  Initializes connection with CM SDK.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getServiceName

    public java.lang.String getServiceName()
                                    throws IfsException

  Description copied from class: `LibrarySession`
  Gets the name of the CM SDK service to which this session is connected.

  Returns:
    the service name
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getAttributesRsn

    public long getAttributesRsn()

  Description copied from class: `LibrarySession`
  Gets the resolution sequence number at which an attribute was last added or removed.

  Returns:
    the attributes RSN
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getNextSequence

    public long getNextSequence()

  Description copied from class: `LibrarySession`
  Gets the next unique sequence with respect to this session.

  Used to generate unique values within the context of a single session.

  Returns:
    the next sequence
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getLocalizer

    public final Localizer getLocalizer()
                                 throws IfsException

  Description copied from class: `LibrarySession`
  Gets the localizer used by this session.

  Specified by:
    `getLocalizer` in interface `LibrarySessionInterface`
  Returns:
    the localizer
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getId

    public java.lang.Long getId()
                         throws IfsException

  Description copied from class: `LibrarySession`
  Gets the id of this session.

  Returns:
    the id
  Throws:
    `IfsException` - if the operation fails
  (Published)

### equals

    public boolean equals(LibrarySession otherSession)

  Description copied from class: `LibrarySession`
  Compares whether two LibrarySessions are the same by comparing IDs.

  Returns:
    true if the LibrarySessions have the same Id.
  (Published)

### getSessionIdentifier

    public java.lang.String getSessionIdentifier()

  Description copied from class: `LibrarySession`
  Gets a session identifier.

  Specified by:
    `getSessionIdentifier` in interface `LogInfo`
  Returns:
    a String containing the id of the session
  (Unpublished)

### getApplicationName

    public java.lang.String getApplicationName()
                                        throws IfsException

  Description copied from class: `LibrarySession`
  Gets the name of the application that created this session.

  The application name is specified by the ConnectOptions passed to `LibraryService.connect`. The value is not used internally; it is purely informational.

  Returns:
    the application name
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setApplicationName

    public void setApplicationName(java.lang.String name)
                            throws IfsException

  Description copied from class: `LibrarySession`
  Sets the name of the application that is using this session.

  Parameters:
    `name` - the application name.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getServiceId

    public java.lang.Long getServiceId()
                                throws IfsException

  Description copied from class: `LibrarySession`
  Gets the id of this session's service.

  Returns:
    the id
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getSessionContext

    protected S_LibrarySessionInterface getSessionContext()

  Description copied from class: `LibrarySession`
  Gets the server-side session context.

  Returns:
    the server-side session context.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### isFullTextIndexingEnabled

    public boolean isFullTextIndexingEnabled()
                                      throws IfsException

  Description copied from class: `LibrarySession`
  Gets whether full-text indexing is enabled.

  Returns:
    whether full-text indexing is enabled
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getTraceLogger

    public final TraceLogger getTraceLogger()
                                     throws IfsException

  Description copied from class: `LibrarySession`
  Gets the trace logger used by this session.

  Specified by:
    `getTraceLogger` in interface `Traceable`
  Returns:
    the trace logger
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setSessionTraceLoggerLevels

    public final void setSessionTraceLoggerLevels(int[] levels)
                                           throws IfsException

  Description copied from class: `LibrarySession`
  Sets the trace levels of the S_LibrarySessionTraceLogger.

  Parameters:
    `levels` - an array of levels. The array index corresponds to the channel number.
  Throws:
    `IfsException` -
    11204: if the size of the array does not equal the number of channels
    11200: if a level is invalid
  (Unpublished)

### getSessionTraceLoggerLevels

    public final int[] getSessionTraceLoggerLevels()
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Gets the trace levels of the S_LibrarySessionTraceLogger.

  Returns:
    an array of levels. The array index corresponds to the channel number.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setServiceTraceLoggerLevels

    public final void setServiceTraceLoggerLevels(int[] levels)
                                           throws IfsException

  Description copied from class: `LibrarySession`
  Sets the trace levels of the S_LibraryServiceTraceLogger.

  Parameters:
    `levels` - an array of levels. The array index corresponds to the channel number.
  Throws:
    `IfsException` - (IFS-11204) if the size of the array does not equal the number of channels
    `IfsException` - (IFS-11200) if a level is invalid
    `IfsException` - (IFS-FIXME) if not in administration mode
  (Unpublished)

### getServiceTraceLoggerLevels

    public final int[] getServiceTraceLoggerLevels()
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Gets the trace levels of the S_LibraryServiceTraceLogger.

  Returns:
    an array of levels. The array index corresponds to the channel number.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getLibraryObjectCachePerformance

    public final CachePerformance getLibraryObjectCachePerformance()

  Description copied from class: `LibrarySession`
  Gets the cache performance object for the LibraryObject cache.

  Returns:
    the cache performance object
  (Unpublished)

### getBeanLibraryObjectDataCachePerformance

    public final CachePerformance getBeanLibraryObjectDataCachePerformance()

  Description copied from class: `LibrarySession`
  Gets the cache performance object for the bean LibraryObjectData cache.

  Returns:
    the cache performance object
  (Unpublished)

### disconnectBestEffort

    public void disconnectBestEffort()

  Description copied from class: `LibrarySession`
  Disconnects the session, effectively disposing the instance.

  Throws:
    `IfsException` - if operation fails.
  (Published)

### disconnect

    public boolean disconnect()
                       throws IfsException

  Description copied from class: `LibrarySession`
  Disconnects the session, effectively disposing the instance.

  Returns:
    status of the disconnect operation (always true)
  Throws:
    `IfsException` - if operation fails.
  (Published)

### createSession

    public LibrarySession createSession(DirectoryUser user)
                                 throws IfsException

  Description copied from class: `LibrarySession`
  Create a new session for the specified user.

  Current session must be in admin mode if the user specified is not the current user or the "guest" user.

  Parameters:
    `user` - the user for which to make a new session
  Returns:
    the new session context for the specified user
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### createSession

    public LibrarySession createSession(DirectoryUser user,
                                        ConnectOptions options)
                                 throws IfsException

  Description copied from class: `LibrarySession`
  Create a new session for the specified user.

  Current session must be in admin mode if the user specified is not the current user or the "guest" user.

  Parameters:
    `user` - the user for which to make a new session
    `options` - the connection options
  Returns:
    the new session context for the specified user
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### createCredential

    public Credential createCredential(LibraryService service,
                                       DirectoryUser user)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Return a credential that can be used to create a new session for the specified user.

  Current session must be in admin mode if the user specified is not the current user or the "guest" user.

  Parameters:
    `service` - the current session's service
    `user` - the user for which to make a new session
  Returns:
    a credential that can be used to create a new session context for the specified user
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### createCredential

    public Credential createCredential(DirectoryUser user)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Return a credential that can be used to create a new session for the specified user, using the current session's service.

  Current session must be in admin mode if the user specified is not the current user or the "guest" user.

  Parameters:
    `user` - the user for which to make a new session
  Returns:
    a credential that can be used to create a new session context for the specified user
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### createSession

    public LibrarySession createSession()
                                 throws IfsException

  Description copied from class: `LibrarySession`
  Create a new session based on the user of the current session.

  Returns:
    the new session context for the current user
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### createGuestSession

    public LibrarySession createGuestSession()
                                      throws IfsException

  Description copied from class: `LibrarySession`
  Create a new session based on the "guest" user.

  Returns:
    the new session context for the "guest" user
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### createGuestSession

    public LibrarySession createGuestSession(ConnectOptions options)
                                      throws IfsException

  Description copied from class: `LibrarySession`
  Create a new session based on the "guest" user.

  Parameters:
    `options` - the connection options
  Returns:
    the new session context for the "guest" user
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### createGuestCredential

    public Credential createGuestCredential()
                                     throws IfsException

  Description copied from class: `LibrarySession`
  Create a new credential based on the "guest" user.

  Returns:
    Credential for the "guest" user
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getSystemUserToken

    public java.lang.Object getSystemUserToken()
                                        throws IfsException

  Description copied from class: `LibrarySession`
  Gets the system token that can be used to efficiently clone system sessions.

  Returns:
    the system user token
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getUser

    public DirectoryUser getUser()
                          throws IfsException

  Description copied from class: `LibrarySession`
  Return the user associated with the current session. If this session is impersonating a user that is not the same user who authenticated, this method returns the impersonating user.

  Returns:
    the current user
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getUserId

    public java.lang.Long getUserId()
                             throws IfsException

  Description copied from class: `LibrarySession`
  Gets the id of the current user.

  Returns:
    the id
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getUserIdentifier

    public java.lang.String getUserIdentifier()

  Description copied from class: `LibrarySession`
  Return the identifer for the user associated with the current session.

  Specified by:
    `getUserIdentifier` in interface `LogInfo`
  Returns:
    a String that identifes the current user
  (Unpublished)

### getDirectoryUser

    public DirectoryUser getDirectoryUser()
                                   throws IfsException

  Description copied from class: `LibrarySession`
  Return the user associated with the current session. If this session is impersonating a user that is not the same user who authenticated, this method returns the impersonating user.

  Returns:
    the current user
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getPrimaryUserProfile

    public PrimaryUserProfile getPrimaryUserProfile()
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Return the current user's primary UserProfile. If this session is impersonating a user that is not the same user who authenticated, this method returns the impersonating user's primary UserProfile.

  Returns:
    the current user's primary UserProfile.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getPrimaryUserProfile

    public PrimaryUserProfile getPrimaryUserProfile(DirectoryUser user)
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Return the a specified user's primary UserProfile.

  Parameters:
    `user` - the specified user.
  Returns:
    the specified user's primary UserProfile.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getVersionString

    public final java.lang.String getVersionString()
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Returns the version String for the CM SDK bean-side software. For example, version 1.0.8.3.2 would be returned as the string "1.0.8.3.2".

  This value is potentially different from the other two version Strings for the server-side software and the CM SDK schema.

  Returns:
    the bean-side software version String.
  Throws:
    `IfsException`
  (Published)

### getVersionNumber

    public final long getVersionNumber()
                                throws IfsException

  Description copied from class: `LibrarySession`
  Returns the CM SDK bean-side software version number, as a long value. Each digit in the version string is represented by two digits in the long value. For example, version 1.0.8.4.18 would be returned as the long value 0100080418L.

  This value is potentially different from the other two version Strings for the server-side software and the CM SDK schema.

  Returns:
    the bean-side software version number.
  Throws:
    `IfsException`
  (Published)

### getServerVersionNumber

    public long getServerVersionNumber()
                                throws IfsException

  Description copied from class: `LibrarySession`
  Returns the CM SDK server-side version number, as a long value. Each digit in the version string is represented by two digits in the long value. For example, version 1.0.8.4.18 would be returned as the long value 0100080418L.

  This value is potentially different from the other two version Strings for the bean-side software and the CM SDK schema.

  Returns:
    the server-side software version number.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getServerVersionString

    public java.lang.String getServerVersionString()
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Returns the version String for the CM SDK server-side software. For example, version 1.0.8.3.2 would be returned as the string "1.0.8.3.2".

  This value is potentially different from the other two version Strings for the bean-side software and the CM SDK schema.

  Returns:
    the server-side software version String.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getSchemaVersionString

    public java.lang.String getSchemaVersionString()
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Returns the version String for the CM SDK schema on which this session is connected. For example, version 1.0.8.3.2 would be returned as the string "1.0.8.3.2".

  This value is potentially different from the other two version Strings for the bean-side software and the server-side software.

  Returns:
    the schema version string
  Throws:
    `IfsException` - (IFS-20001) if the operation fails
  (Published)

### getSchemaVersionNumber

    public long getSchemaVersionNumber()
                                throws IfsException

  Description copied from class: `LibrarySession`
  Returns the version number for the CM SDK schema on which this session is connected. Each digit in the version string is represented by two digits in the long value. For example, version 1.0.8.4.18 would be returned as the long value 0100080418L.

  This value is potentially different from the other two version Strings for the bean-side software and the server-side software.

  Returns:
    the schema version number.
  Throws:
    `IfsException` - (IFS-20001) if the operation fails
  (Published)

### getDatabaseCharacterSet

    public java.lang.String getDatabaseCharacterSet()
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Returns the Iana character set of the database.

  Returns:
    the character set
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### emptyWastebasket

    public void emptyWastebasket()
                          throws IfsException

  Description copied from class: `LibrarySession`
  Empty the wastebasket. This frees all object's deleted by the current user.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### isFilterDeletedObjectsEnabled

    public boolean isFilterDeletedObjectsEnabled()

  Description copied from class: `LibrarySession`
  Return indication as to whether this session has deleted object filtering enabled. By default, a session filters deleted objects from searches, selectors, folder operations, etc. This can be overridden by `setFilterDeletedObjectsEnabled(false)` .

  Returns:
    whether this LibrarySession has deleted object filtering enabled.
  (Unpublished)

### setFilterDeletedObjectsEnabled

    public void setFilterDeletedObjectsEnabled(boolean mode)
                                        throws IfsException

  Description copied from class: `LibrarySession`
  Set deleted object filtering state for this session.

  Parameters:
    `mode` - new state of FilterDeletedObjectsEnabled.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getDefaultFolderRelationshipClassname

    public java.lang.String getDefaultFolderRelationshipClassname()
                                                           throws IfsException

  Deprecated. CM SDK 10g: no replacement functionality; FolderPathRelationship is now used as the class name

  Description copied from class: `LibrarySession`
  Gets the default class name of the relationship class used to represent folder relationships. This always returns "FOLDERPATHRELATIONSHIP".

  Returns:
    the default Relationship subclass name
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setDefaultFolderRelationshipClassName

    public void setDefaultFolderRelationshipClassName(java.lang.String classname)
                                               throws IfsException

  Deprecated. CM SDK 10g: no replacement functionality; FolderPathRelationship is now used as the class name

  Description copied from class: `LibrarySession`
  Sets the default class name that is used for folder relationships. There is no longer a need for this option, and it is now deprecated.

  Parameters:
    `classname` - name of the default Relationship class to be used in Folder selection operations.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getDefaultFolderSortSpecification

    public SortSpecification getDefaultFolderSortSpecification()
                                                        throws IfsException

  Description copied from class: `LibrarySession`
  get the default SortSpecification that is used by default for all Folder selection operations. Returns null if no default has been set.

  Returns:
    default SortSpecification used for Folder select operations.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getObjectFolderSortSpecification

    protected SortSpecification getObjectFolderSortSpecification(PublicObject po)
                                                          throws IfsException

  Description copied from class: `LibrarySession`
  get the SortSpecification for a particular object. This will return the SortSpecification that was specified explicitly for an object, or return the session's default SortSpecification otherwise.

  Returns:
    SortSpecification to be used for Folder select operations.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getFolderSortSpecification

    protected SortSpecification getFolderSortSpecification(PublicObject po)
                                                    throws IfsException

  Description copied from class: `LibrarySession`
  get the SortSpecification for a particular object. This will return the SortSpecification that was specified explicitly for an object, or return the session's default SortSpecification otherwise.

  Returns:
    SortSpecification to be used for Folder select operations.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### setDefaultFolderSortSpecification

    public void setDefaultFolderSortSpecification(SortSpecification sort)
                                           throws IfsException

  Description copied from class: `LibrarySession`
  Sets the default SortSpecification that is used by default for all Folder selection operations.

  Parameters:
    `sort` - default SortSpecification used for Folder select operations.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setObjectFolderSortSpecification

    protected void setObjectFolderSortSpecification(PublicObject po,
                                                    SortSpecification sort)
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Sets an object-level SortSpecification that is to be used for all Folder selection operations for a particular object.

  Parameters:
    `po` - object for which the SortSpecification applies
    `sort` - SortSpecification to be used for Folder select operations.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### setFolderPathDelimiter

    public void setFolderPathDelimiter(java.lang.String delim)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Sets the current session's Folder path delimiter. By default, this is set to "/".

  Parameters:
    `delim` - the delimiter
  Throws:
    `IfsException` - if delim is illeagal
  (Published)

### getFolderPathDelimiter

    public java.lang.String getFolderPathDelimiter()
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Gets the current session's folder path delimiter. The value will be "/" unless changed by a call to setFolderPathDelimiter.

  Returns:
    the delimiter
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getConfigurationCategoryDescriptor

    public ConfigurationCategoryDescriptor getConfigurationCategoryDescriptor(java.lang.String className)
                                                                       throws IfsException

  Description copied from class: `LibrarySession`
  Gets the ConfigurationCategoryDescriptor for the specified ConfigurationCategory class name.

  Parameters:
    `className` - the ConfigurationCategory class name.
  Returns:
    the ConfigurationCategoryDescriptor
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setPreventSessionTimeouts

    public void setPreventSessionTimeouts(boolean value)
                                   throws IfsException

  Description copied from class: `LibrarySession`
  Sets whether the current session should prevent any session or operation timeouts. If a value of true is specified, no operations will time out except ones that have an explicit timeout mechanism (for example, Searches).

  Parameters:
    `value` - true indicates that session timeouts are disabled; false indicates that session timeouts are enabled
  Throws:
    `IfsException` - if delim is illeagal
  (Published)

### isPreventSessionTimeouts

    public boolean isPreventSessionTimeouts()
                                     throws IfsException

  Description copied from class: `LibrarySession`
  Gets whether the current session prevents any session or operation timeouts.

  Returns:
    true indicates that session timeout's are disabled; false indicates that session timeouts are enabled
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getGlobalOperationActionSpecifications

    public OperationActionSpecification[] getGlobalOperationActionSpecifications()
                                                                          throws IfsException

  Description copied from class: `LibrarySession`
  Gets the "global" OperationActionSpecifications.

  Returns:
    the global OperationActionSpecifications
  Throws:
    `IfsException` - if operation fails
  (Published)

### isFolderItemCachingEnabled

    public boolean isFolderItemCachingEnabled()
                                       throws IfsException

  Description copied from class: `LibrarySession`
  Gets whether the server supports folder item caching.

  Returns:
    true if folder item caching is enabled
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### isDefinitionCloningRequired

    public boolean isDefinitionCloningRequired()
                                        throws IfsException

  Description copied from class: `LibrarySession`
  Gets whether the current session requires user-specified instances of LibraryObjectDefinition (or one of its subclasses) to be cloned prior to using it server-side. This is a compatibility mode option; to be compatible with 9.0.4 and earlier versions of the CM SDK, this option should be set to true. The value of this option is stored as a domain property, "IFS.DOMAIN.DefinitionCloningRequired". It can be overridden for a particular session using the setDefinitionCloningRequired() method.

  Returns:
    true indicates that definition cloning is required; false indicates that definition cloning is required
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setDefinitionCloningRequired

    public void setDefinitionCloningRequired(boolean option)
                                      throws IfsException

  Description copied from class: `LibrarySession`
  Sets whether the current session requires user-specified instances of LibraryObjectDefinition (or one of its subclasses) to be cloned prior to using it server-side. This is a compatibility mode option; to be compatible with 9.0.4 and earlier versions of the CM SDK, this option should be set to true. This will override the default value for the session, stored as a domain property, "IFS.DOMAIN.DefinitionCloningRequired".

  Parameters:
    `option` - true indicates that definition cloning is required; false indicates that definition cloning is required
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setDefaultContentQuota

    public void setDefaultContentQuota(ContentQuota quota)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Sets the session's default ContentQuota. This ContentQuota object will be used for every Document that this session creates. If the specified value is null, then the user's ContentQuota object will be used by default.

  Parameters:
    `quota` - the quota object to use by default
  Throws:
    `IfsException` - if the current user cannot use the specified quota
  (Published)

### getDefaultContentQuota

    public ContentQuota getDefaultContentQuota()
                                        throws IfsException

  Description copied from class: `LibrarySession`
  Gets the session's default ContentQuota, set via setDefaultContentQuota().

  Returns:
    the quota object being used by the session, or null if the user's quota is being used.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setUpgradeInProgress

    public void setUpgradeInProgress(boolean value)
                              throws IfsException

  Description copied from class: `LibrarySession`
  Sets indication of whether the session behaves as though an upgrade is in progress.

  Overrides the default behavior as indicated by a domain property. See `isUpgradeInProgress` for a description of the semantics of the session with this indication set to true.

  Parameters:
    `value` - true if session behaves as though an upgrade is in progress
  Throws:
    `IfsException`

### isUpgradeInProgress

    public boolean isUpgradeInProgress()
                                throws IfsException

  Description copied from class: `LibrarySession`
  See if the session behaves as though an upgrade is in progress.

  Indicates the default setting (stored as a domain property) if not explicitly set on the session.

  When this behavior is set to true, operations performed on behalf of that session differ from those occuring on normal sessions in the following ways:

  - Quota is not checked during document creation/update.
  - Last modification date and last modifier are not updated when updating system-set attributes.
  - Last modification date and last modifier are not updated on folders when an item is added or removed from that folder.

  Returns:
    true if session behaves as though an upgrade is in progress
  Throws:
    `IfsException` - if operation fails

### isExecutionMode

    public boolean isExecutionMode(int mode)
                            throws IfsException

  Description copied from class: `LibrarySession`
  Checks whether current session is in at least the execution mode specified.

  Parameters:
    `mode` - the execution mode being checked
  Returns:
    true if the session is in at least the execution mode specified
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setExecutionMode

    public void setExecutionMode(int mode)
                          throws IfsException

  Description copied from class: `LibrarySession`
  Set the execution mode for this LibrarySession.

  Parameters:
    `mode` - new execution mode
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### pushTemporaryExecutionMode

    public void pushTemporaryExecutionMode(int mode)

  Description copied from class: `LibrarySession`
  Establishes a temporary execution mode for the session.

  The caller must guarantee that `popTemporaryExecutionMode` is called to clear this temporary execution mode once it is no longer needed, typically in try/finally blocks.

  If the specified mode is less than the regular mode of the session, any previous temporary execution mode is cancelled.

  Parameters:
    `mode` - new temporary execution mode
  (Unpublished)

### popTemporaryExecutionMode

    public void popTemporaryExecutionMode()

  Description copied from class: `LibrarySession`
  Resets any temporary execution state back to the previous temporary execution mode.

  (Unpublished)

### isAdministrationMode

    public boolean isAdministrationMode()

  Description copied from class: `LibrarySession`
  Return indication as to whether this session has enabled administrator mode. By default, a session is not in Administrator mode, unless explicitly set by invoking the setAdministrationMode(true) method.

  Returns:
    whether this session is in administrator mode.
  (Published)

### isSystemAdministrationMode

    public boolean isSystemAdministrationMode()
                                       throws IfsException

  Description copied from class: `LibrarySession`
  Return indication as to whether this session is set in system administration mode.

  Returns:
    whether this session is in "system administration" mode.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### isInstallationMode

    public boolean isInstallationMode()
                               throws IfsException

  Description copied from class: `LibrarySession`
  Return indication as to whether this session is set in installation mode. By default, a session is not in installation mode, unless explicitly set invoking the setInstallationMode(true) method.

  Returns:
    whether this session is in "installation" mode.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setAdministrationMode

    public void setAdministrationMode(boolean mode)
                               throws IfsException

  Description copied from class: `LibrarySession`
  Set the administrator mode state for this session. The semantics of a LibrarySession in admin mode are very different from a session that is not in admin mode.

  This list describes what a user in administration mode can do.

  1. Create, update, free any SchemaObject. Updates include any mutation such as adding an Attribute to a ClassObject.

  2. Directly create, update, or free any SystemObject; ordinary sessions can perform some of these operations on some subclasses of SystemObject provided that they are executed in the context of some other PublicObject (e.g. adding a Relationship to a PublicObject)

  3. Create, free, update any DirectoryUser object

  4. Create, free, or modify any SystemAccessControlList

  5. Create, free, or modify any ClassAccessControlList

  6. Create, free, or modify any ContentQuota

  7. Free a PublicObject that has an ExtendedPreFreePolicy of ExtendedPreFreePolicyRequireAdmin or ExtendedPreFreePolicyIgnoreOwnership (e.g. to free your own home folder)

  8. Impersonate another user

  9. Change the password of another user

  10. Delete users from the "credential manager" store

  11. Bypass "required attribute" check in creating or updating any CMSDK object.

  12. Embed SQL syntax referencing CMSDK tables/views in any Selector or Search

  13. Unreserve any PublicObject checked out by another user

  14. Use any defined ContentQuota

  15. Declare to use no ContentQuota even if one is assigned to that user

  16. Set the ContentQuota attribute on DirectoryGroup

  17. Set the ContentQuota attribute on PrimaryUserProfile

  18. Bypass the name.owner uniqueness policy for DirectoryGroup and AccessControlList

  19. Directly get or set the content from a ContentObject without providing a Document context

  20. Force re-creation of CMSDK views

  21. Promote a Folder in the Folder index

  22. Move content from LOB to BFILE

  Parameters:
    `mode` - new state of administrator mode; true to enable administration mode
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setSystemAdministrationMode

    public void setSystemAdministrationMode(boolean mode)
                                     throws IfsException

  Description copied from class: `LibrarySession`
  Set the System admin Mode state for this LibrarySession.

  Parameters:
    `mode` - new state of Installation mode
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### setInstallationMode

    public void setInstallationMode(boolean mode)
                             throws IfsException

  Description copied from class: `LibrarySession`
  Set the Installation Mode state for this LibrarySession.

  Parameters:
    `mode` - new state of Installation mode
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### pushTemporaryAccessCheckMode

    public void pushTemporaryAccessCheckMode(boolean mode)

  Description copied from class: `LibrarySession`
  Establishes a temporary access check mode for the session.

  The caller must guarantee that `popTemporaryAccessCheckMode` is called to clear this temporary access check mode once it is no longer needed, typically in try/finally blocks.

  Parameters:
    `mode` - new temporary access check mode; false indicates that access checks are disabled; true indicates that they are enabled (the normal mode for the session)
  (Unpublished)

### popTemporaryAccessCheckMode

    public void popTemporaryAccessCheckMode()

  Description copied from class: `LibrarySession`
  Resets any temporary access check mode back to the previous temporary access check mode.

  (Unpublished)

### pushApplicationMode

    public void pushApplicationMode(int mode)

  Description copied from class: `LibrarySession`
  Establishes a new temporary Application mode for the session.

  The caller must guarantee that `popApplicationMode` is called to clear this temporary application mode once it is no longer needed, typically in try/finally blocks.

  The mode specified will be logically ORed with the previous mode to establish the new mode. It is up to the application to manage the semantics of the varous mode settings.

  Parameters:
    `mode` - new application mode settings; current mode will be the previous mode logically ORed with this setting.
  (Unpublished)

### popApplicationMode

    public void popApplicationMode()

  Description copied from class: `LibrarySession`
  Resets any temporary application mode back to the previous temporary application mode setting.

  (Unpublished)

### getApplicationMode

    public final int getApplicationMode()

  Description copied from class: `LibrarySession`
  Gets the application mode for the session.

  Normally this returns 0, but can be overridden temporarily via `pushApplicationMode`

  Returns:
    the application mode
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### reauthenticate

    public boolean reauthenticate(Credential credential,
                                  ConnectOptions options)
                           throws IfsException

  Description copied from class: `LibrarySession`
  Reauthenticates the DIRECTORYUSER for which this LibrarySession was originally created (as opposed to the DIRECTORYUSER specified by a subsequent call to `impersonateUser`).

  This does not create a new session or change the existing session in any way. It simply determines the whether the supplied credential is a valid credential for the previously authenticated DIRECTORYUSER.

  Parameters:
    `credential` - the credential to authenticate; this must be a credential for the authenticated user of this LibrarySession
    `options` - the ConnectOptions supplied by the user
  Returns:
    whether `credential` is a valid credential
  Throws:
    `IfsException` - (IFS-10162) if the operation fails (other than the supplied credential simply being invalid)
  (Unpublished)

### invalidateTokenCredentials

    public void invalidateTokenCredentials(DirectoryUser user)
                                    throws IfsException

  Description copied from class: `LibrarySession`
  Invalidates all the token credentials for the given user. If the current session user does not match the passed in user, then the current session has to be in admin mode to perform this operation succesfully.

  Parameters:
    `user` - user whose all token credentials need to be invalidated
  Throws:
    `IfsException` - if the operation fails
  (Published)

### impersonateUser

    public void impersonateUser(DirectoryUser newuser)
                         throws IfsException

  Description copied from class: `LibrarySession`
  Assume the identity of another user. New objects created will be owned by this impersonated user. This operation requires that the authenticated user has the ability to enable administration mode, but will also work if the user is currently in not in administration mode. In this case, the impersonation will also not be in administration mode. Also note that since admin mode is required for this operation, admin mode can be enabled while impersonating the new user (who may not normally have admin privileges).

  Parameters:
    `newuser` - new User to impersonate, or null to cancel a previous impersonation.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getName

    public java.lang.String getName()
                             throws IfsException

  Description copied from class: `LibrarySession`
  Gets the name of the session. If connected, this string is returned as username@servicename.

  Returns:
    the session name.
  Throws:
    `IfsException` - if the operation fails.
  (Unpublished)

### getRootFolder

    public Folder getRootFolder()
                         throws IfsException

  Description copied from class: `LibrarySession`
  Return the top-most Folder in the CM SDK folder hierarchy.

  Returns:
    the top-most root folder
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getDefaultContentMedia

    public Media getDefaultContentMedia()
                                 throws IfsException

  Description copied from class: `LibrarySession`
  Get the default content Media instance.

  Returns:
    the default Media instance.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getNonContentMedia

    public Media getNonContentMedia()
                             throws IfsException

  Description copied from class: `LibrarySession`
  Get the non content Media instance.

  Returns:
    the default Media instance.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### lookupInverseInstanceLabel

    public java.lang.String lookupInverseInstanceLabel(java.lang.String classname,
                                                       java.lang.String label)
                                                throws IfsException

  Description copied from class: `LibrarySession`
  Gets the name of an uniquely-named instance by its label. Return null if no inverse Label is specified in the ResourceBundle or extended ResourceBundles.

  Parameters:
    `classname` - The class name of the requested instance
    `label` - The label
  Returns:
    the name registered as an inverse to the specified label
  Throws:
    `IfsException` - if operation fails.
  (Published)

### newContentStreamSerializer

    public ContentStreamSerializer newContentStreamSerializer()
                                                       throws IfsException

  Description copied from class: `LibrarySession`
  Return the Content stream serializer.

  Returns:
    the Content stream serializer.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getClassObjectCollection

    public final Collection getClassObjectCollection()
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Gets a reference to the ClassObject collection.

  Specified by:
    `getClassObjectCollection` in interface `LibrarySessionInterface`
  Returns:
    the CachedSelectorCollection
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getClassDomainCollection

    public final Collection getClassDomainCollection()
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Gets a reference to the ClassDomain collection.

  Specified by:
    `getClassDomainCollection` in interface `LibrarySessionInterface`
  Returns:
    the Collection
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getValueDefaultCollection

    public final Collection getValueDefaultCollection()
                                               throws IfsException

  Description copied from class: `LibrarySession`
  Gets a reference to the ValueDefault collection.

  Specified by:
    `getValueDefaultCollection` in interface `LibrarySessionInterface`
  Returns:
    the UncachedPreparedSelectorCollection
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getValueDomainCollection

    public final Collection getValueDomainCollection()
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Gets a reference to the ValueDomain collection.

  Specified by:
    `getValueDomainCollection` in interface `LibrarySessionInterface`
  Returns:
    the Collection
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getExtendedUserProfileCollection

    public final Collection getExtendedUserProfileCollection()
                                                      throws IfsException

  Description copied from class: `LibrarySession`
  Gets a reference to the ExtendedUserProfile collection.

  Specified by:
    `getExtendedUserProfileCollection` in interface `LibrarySessionInterface`
  Returns:
    the Collection
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getFormatCollection

    public final Collection getFormatCollection()
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Gets a reference to the Format (by name) collection.

  Specified by:
    `getFormatCollection` in interface `LibrarySessionInterface`
  Returns:
    the Format Collection
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getFormatExtensionCollection

    public final Collection getFormatExtensionCollection()
                                                  throws IfsException

  Description copied from class: `LibrarySession`
  Gets a reference to the FormatExtension collection.

  Unlike the FormatCollection, this collection is organizaed by EXTENSION, not NAME.

  Specified by:
    `getFormatExtensionCollection` in interface `LibrarySessionInterface`
  Returns:
    the Collection, keyed by EXTENSION
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getMediaCollection

    public final Collection getMediaCollection()
                                        throws IfsException

  Description copied from class: `LibrarySession`
  Gets a reference to the Media collection.

  Specified by:
    `getMediaCollection` in interface `LibrarySessionInterface`
  Returns:
    the Collection
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getSharedAccessControlListCollection

    public final Collection getSharedAccessControlListCollection()
                                                          throws IfsException

  Description copied from class: `LibrarySession`
  Gets a reference to the SharedAccessControlList collection.

  Returns:
    the Collection
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getSystemAccessControlListCollection

    public final Collection getSystemAccessControlListCollection()
                                                          throws IfsException

  Description copied from class: `LibrarySession`
  Gets a reference to the SystemAccessControlList collection.

  Specified by:
    `getSystemAccessControlListCollection` in interface `LibrarySessionInterface`
  Returns:
    the Collection
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getClassAccessControlListCollection

    public final Collection getClassAccessControlListCollection()
                                                         throws IfsException

  Description copied from class: `LibrarySession`
  Gets a reference to the ClassAccessControlList collection.

  Specified by:
    `getClassAccessControlListCollection` in interface `LibrarySessionInterface`
  Returns:
    the Collection
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getSystemLockObjectCollection

    public final Collection getSystemLockObjectCollection()
                                                   throws IfsException

  Description copied from class: `LibrarySession`
  Gets a reference to the SystemLockObject collection.

  Returns:
    the Collection
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getDirectoryUserCollection

    public final Collection getDirectoryUserCollection()
                                                throws IfsException

  Description copied from class: `LibrarySession`
  Gets a reference to the DirectoryUser collection.

  Specified by:
    `getDirectoryUserCollection` in interface `LibrarySessionInterface`
  Returns:
    the UncachedPreparedSelectorCollection
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getExtendedPermissionCollection

    public final Collection getExtendedPermissionCollection()
                                                     throws IfsException

  Description copied from class: `LibrarySession`
  Gets a reference to the ExtendedPermission collection.

  Specified by:
    `getExtendedPermissionCollection` in interface `LibrarySessionInterface`
  Returns:
    the Collection
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getPermissionBundleCollection

    public final Collection getPermissionBundleCollection()
                                                   throws IfsException

  Description copied from class: `LibrarySession`
  Gets a reference to the PermissionBundle collection.

  Specified by:
    `getPermissionBundleCollection` in interface `LibrarySessionInterface`
  Returns:
    the Collection
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getPolicyCollection

    public final Collection getPolicyCollection()
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Gets a reference to the Policy collection.

  Specified by:
    `getPolicyCollection` in interface `LibrarySessionInterface`
  Returns:
    the Collection
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getPolicyListCollection

    public final Collection getPolicyListCollection()
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Gets a reference to the PolicyList collection.

  Returns:
    the Collection
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getDomainPropertyValue

    public final AttributeValue getDomainPropertyValue(java.lang.String name)
                                                throws IfsException

  Description copied from class: `LibrarySession`
  Gets the value of a domain property, by name. If no property exists for the name specified, a null is returned.

  Parameters:
    `name` - the property name
  Returns:
    the property value, or null if no property exists for the name specified
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getDomainPropertyBundle

    public final PropertyBundle getDomainPropertyBundle()
                                                 throws IfsException

  Description copied from class: `LibrarySession`
  Gets the domain PropertyBundle. Can return null if there is no domain PropertyBundle, a condition that should only occur during an upgrade of a pre-9.0.3 schema.

  Returns:
    the domain PropertyBundle
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### putSessionState

    public java.lang.Object putSessionState(java.lang.String key,
                                            java.lang.Object value)
                                     throws IfsException

  Description copied from class: `LibrarySession`
  Add a session state item.

  This behaves like a Hashtable, replacing any state that exists for the specified key and returning the state that was previously defined for that key.

  Parameters:
    `key` - the identifer that uniquely identifies an item of session state
    `value` - the value for the state
  Returns:
    the previous value for the specified state, or null if no previous value was defined
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getSessionState

    public java.lang.Object getSessionState(java.lang.String key)
                                     throws IfsException

  Description copied from class: `LibrarySession`
  Get a session state item.

  Parameters:
    `key` - the identifer that uniquely identifies an item of session state
  Returns:
    the value for the state, or null if the state is not defnied
  Throws:
    `IfsException` - if operation fails.
  (Published)

### removeSessionState

    public java.lang.Object removeSessionState(java.lang.String key)
                                        throws IfsException

  Description copied from class: `LibrarySession`
  Remove a session state item.

  This behaves like a Hashtable, returning any state that was previously defined for that key.

  Parameters:
    `key` - the identifer that uniquely identifies an item of session state
  Returns:
    the previous value for the specified state, or null if no previous value was defined
  Throws:
    `IfsException` - if operation fails.
  (Published)

### establishSessionState

    public java.util.Hashtable establishSessionState(java.util.Hashtable stateMap)

  Description copied from class: `LibrarySession`
  Establish session state for the session.

  The map specified should be the equivalent to the map obtained by `captureSessionState`. It is used in cases where an application is pooling sessions for various purposes on behalf of a single user, and the sessions have varying session state.

  Parameters:
    `stateMap` - the session state map
  Returns:
    the previous session state map
  (Unpublished)

### captureSessionState

    public java.util.Hashtable captureSessionState()

  Description copied from class: `LibrarySession`
  Capture the current session state for the session.

  This is used in cases where an application needs to hold the session state so that it can be established on a different session in the future, useful when the the application is pooling sessions for various purposes on behalf of a single user, and the sessions have varying session state.

  Returns:
    the current session state map
  (Unpublished)

### getSharedStateFactory

    protected S_LibraryObjectDataSharedStateFactory getSharedStateFactory()

  Description copied from class: `LibrarySession`
  Returns the Shared State factory in effect for the session.

  Returns:
    the Shared State factory
  (Published)

### createPublicObject

    public PublicObject createPublicObject(PublicObjectDefinition def)
                                    throws IfsException

  Description copied from class: `LibrarySession`
  Create a new public object.

  Parameters:
    `def` - the definition for the new PublicObject
  Returns:
    the newly created PublicObject.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### createSchemaObject

    public SchemaObject createSchemaObject(SchemaObjectDefinition def)
                                    throws IfsException

  Description copied from class: `LibrarySession`
  Create a new schema object.

  Parameters:
    `def` - the definition for the new SchemaObject
  Returns:
    the newly created SchemaObject.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### createSystemObject

    public SystemObject createSystemObject(SystemObjectDefinition def)
                                    throws IfsException

  Description copied from class: `LibrarySession`
  Create a new system object.

  Parameters:
    `def` - the definition for the new SystemObject
  Returns:
    the newly created SystemObject.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getIdsForNewObjects

    public java.lang.Long[] getIdsForNewObjects(int length)
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Return a set of Ids that can be used to import a set of objects.

  Parameters:
    `length` - The number of Ids desired.
  Returns:
    the set of IDs
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getIdForNewObject

    public java.lang.Long getIdForNewObject()
                                     throws IfsException

  Description copied from class: `LibrarySession`
  Return an Id that can be used to create a new LibraryObject.

  Returns:
    the ID
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getClockOffset

    public java.lang.Long getClockOffset()
                                  throws IfsException

  Description copied from class: `LibrarySession`
  Gets the clock offset, representing the number of milliseconds the DBMS clock is ahead of this mid tier.

  Returns:
    the clock offset
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getCurrentTimeMillis

    public long getCurrentTimeMillis()
                              throws IfsException

  Description copied from class: `LibrarySession`
  Gets the current time in milliseconds, with the clock offset applied.

  Will return the value from `System.currentTimeMillis` with an offset applied equal to the number of milliseconds the DBMS clock is ahead of the mid tier.

  Returns:
    the current time, adjusted with the clock offset
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getCurrentDate

    public java.util.Date getCurrentDate()
                                  throws IfsException

  Description copied from class: `LibrarySession`
  Gets the current Date, with the clock offset applied.

  Will return a Date value constructed from `System.currentTimeMillis` with an offset applied equal to the number of milliseconds the DBMS clock is ahead of the mid tier.

  Returns:
    the current date, adjusted with the clock offset
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getCurrentAuditDomainContext

    public Folder getCurrentAuditDomainContext()
                                        throws IfsException

  Description copied from class: `LibrarySession`
  Gets the current "Audit Domain" context for the session's user.

  Delegates to the current user, so that applications can override within the Tie class for DirectoryUser.

  Returns:
    the current audit domain context
  Throws:
    `IfsException` - if the operation fails

### getCurrentOrDefaultAuditDomainContext

    public Folder getCurrentOrDefaultAuditDomainContext()
                                                 throws IfsException

  Description copied from class: `LibrarySession`
  Gets the current or default "Audit Domain" context for the session's user.

  Delegates to the current user, so that applications can override within the Tie class for DirectoryUser.

  Returns:
    the current or default audit domain context
  Throws:
    `IfsException` - if the operation fails

### setCurrentAuditDomainContext

    public void setCurrentAuditDomainContext(Folder domain)
                                      throws IfsException

  Description copied from class: `LibrarySession`
  Sets the current "Audit Domain" context.

  Parameters:
    `domain` - the new current Domain; if null, the default domain will be used by this session as the current domain
  Throws:
    `IfsException` - if the operation fails

### postAuditEvent

    public void postAuditEvent(AuditEvent event)
                        throws IfsException

  Description copied from class: `LibrarySession`
  Create a new audit event.

  Post the event using `AuditEvent.POST_NORMALLY` mode.

  Parameters:
    `event` - the event to post
  Throws:
    `IfsException` - if the operation fails

### postAuditEvent

    public void postAuditEvent(LibraryObject target,
                               AuditEvent event)
                        throws IfsException

  Description copied from class: `LibrarySession`
  Create a new audit event.

  Post the event using `AuditEvent.POST_NORMALLY` mode.

  Parameters:
    `target` - the target of the event
    `event` - the event to post
  Throws:
    `IfsException` - if the operation fails

### postAuditEvent

    public void postAuditEvent(AuditEvent event,
                               int mode)
                        throws IfsException

  Description copied from class: `LibrarySession`
  Create a new audit event.

  Parameters:
    `event` - the event to post
    `mode` - the success/fail mode for the post
  Throws:
    `IfsException` - if the operation fails

### postAuditEvent

    public void postAuditEvent(LibraryObject target,
                               AuditEvent event,
                               int mode)
                        throws IfsException

  Description copied from class: `LibrarySession`
  Create a new audit event.

  Parameters:
    `event` - the event to post
    `target` - the target of the event
    `mode` - the success/fail mode for the post
  Throws:
    `IfsException` - if the operation fails

### postCustomAuditEvent

    public void postCustomAuditEvent(AuditEvent event)
                              throws IfsException

  Description copied from class: `LibrarySession`
  Create a new custom audit event.

  Delegates to `postAuditEvent` after verifying that the type being posted is a custom type

  Parameters:
    `event` - the event to post
  Throws:
    `IfsException` - if the operation fails

### postCustomAuditEvent

    public void postCustomAuditEvent(LibraryObject target,
                                     AuditEvent event)
                              throws IfsException

  Description copied from class: `LibrarySession`
  Create a new custom audit event.

  Delegates to `postAuditEvent` after verifying that the type being posted is a custom type

  Parameters:
    `target` - the target of the event
    `event` - the event to post
  Throws:
    `IfsException` - if the operation fails

### selectRawAuditEvents

    public RawAuditEvent[] selectRawAuditEvents(java.lang.String filterClause,
                                                int maxItems)
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Select raw audit events.

  Should only be performed as part of event dispatching.

  Parameters:
    `filterClause` - the filter criteria (where clause); use null for standard (efficient) event processing
    `maxItems` - max number of items to select
  Returns:
    the selected raw audit events
  Throws:
    `IfsException` - if the operation fails

### removeRawAuditEvents

    public void removeRawAuditEvents(RawAuditEvent[] rawEvents)
                              throws IfsException

  Description copied from class: `LibrarySession`
  Free raw audit events.

  Parameters:
    `rawEvents` - the raw events to be freed.
  Throws:
    `IfsException` - if the operation fails

### handleAuditEventDispatchRequests

    public void handleAuditEventDispatchRequests(java.util.ArrayList reqList,
                                                 java.lang.String tableName)
                                          throws IfsException

  Description copied from class: `LibrarySession`
  Handle a list of AuditEvent dispatch requests.

  Parameters:
    `reqList` - a list of AuditEventDispatchRequest
    `tableName` - the table name where the events are to be stored
  Throws:
    `IfsException` - if the operation fails

### selectAuditEvents

    public AuditEvent[] selectAuditEvents(java.lang.Long auditSpec,
                                          java.lang.String filterClause,
                                          java.lang.String sortClause,
                                          int maxItems)
                                   throws IfsException

  Description copied from class: `LibrarySession`
  Select audit events.

  The filter clause is the where clause (exclusing the "where" prefix) that is used in selecting against the audit table. The sort clause is the order by clause (excluding the "order by" prefix) used in the query against the audit table.

  Parameters:
    `auditSpec` - the audit history ID to search
    `filterClause` - the filter criteria (where clause)
    `sortClause` - the sort criteria (order by clause)
    `maxItems` - max number of items to select
  Returns:
    the selected audit events
  Throws:
    `IfsException` - if the operation fails

### selectAggregateAuditEventColumns

    public AttributeValue[] selectAggregateAuditEventColumns(java.lang.Long auditSpec,
                                                             java.lang.String aggFuncName,
                                                             java.lang.String[] columnNames,
                                                             java.lang.String[] innerColNames,
                                                             java.lang.String filterClause,
                                                             java.lang.String sortClause)
                                                      throws IfsException

  Description copied from class: `LibrarySession`
  Returns the list of distinct values of the specified AuditEvent columns, along with an optional aggregate function.

  Parameters:
    `auditSpec` - the audit history ID to search
    `aggFuncName` - the SQL aggregate function (can be null)
    `columnNames` - the audit table column names to select
    `innerColNames` - the audit table column names to use in the inner select; if null, no inner select is used
    `filterClause` - the filter criteria (where clause)
    `sortClause` - the sort criteria (order by clause)
  Returns:
    the AttributeValues corresponding to the list of values of the specified aggregate function and the distinct values of the Event columns. The name of each AttributeValue corresponds to the aggregate function or specified AuditEvent column name; the value of the AttributeValue is an array of the appropriate datatype.
  Throws:
    `IfsException` - if the operation fails

### removeAuditEvents

    public void removeAuditEvents(long[] eventIds,
                                  java.lang.String tableName)
                           throws IfsException

  Description copied from class: `LibrarySession`
  Free audit events.

  Parameters:
    `eventIds` - event IDs to be freed.
    `tableName` - event table name
  Throws:
    `IfsException` - if the operation fails

### removeAuditEventsForTarget

    public void removeAuditEventsForTarget(java.lang.Long specId,
                                           java.lang.Long targetId)
                                    throws IfsException

  Description copied from class: `LibrarySession`
  Free audit events from a specific Audit history, by target ID.

  Parameters:
    `specId` - the audit history identifier
    `targetId` - the target ID
  Throws:
    `IfsException` - if the operation fails

### selectSpecificAuditFolderPath

    public AuditFolderPath selectSpecificAuditFolderPath(long folderPathId)
                                                  throws IfsException

  Description copied from class: `LibrarySession`
  Select the specific AuditFolderPath for a given primary key.

  Parameters:
    `folderPathId` - the folder path ID of interest
  Returns:
    the AuditFolderPath for that ID
  Throws:
    `IfsException` - if the operation fails

### registerAuditEventOperationType

    public int registerAuditEventOperationType(java.lang.String opTypeKey,
                                               int targetCode,
                                               java.lang.String targetClass,
                                               int opCode,
                                               java.lang.Boolean createOrFree)
                                        throws IfsException

  Description copied from class: `LibrarySession`
  Register a new audit event operation type.

  Occurs during schema creation, upgrade, and when registering new custom event types. Is coded so that services can be running, as they correctly invalidate their type map caches.

  Parameters:
    `opTypeKey` - operation type key
    `targetCode` - code for the target object type
    `targetClass` - class name for the target object type
    `opCode` - code for the type of operation
    `createOrFree` - indication as to whther the operation is a Create (true) or Free (false) operation; should be null if neither
  Returns:
    the numeric operation type registered
  Throws:
    `IfsException` - if the operation fails

### unregisterAuditEventOperationType

    public void unregisterAuditEventOperationType(java.lang.String opTypeKey)
                                           throws IfsException

  Description copied from class: `LibrarySession`
  Unregister an audit event operation type.

  Only occurs during upgrade, but is coded so that services can be running, as they correctly invalidate their type map caches.

  Parameters:
    `opTypeKey` - operation type key
  Throws:
    `IfsException` - if the operation fails

### lookupAuditEventOperationTypes

    public int[] lookupAuditEventOperationTypes(java.lang.String[] opTypeKeys)
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Looks up audit event operation types by their string key, returning the corresponding numeric equivalents.

  Parameters:
    `opTypeKeys` - operation type keys
  Returns:
    the numeric equivalents; note the returned array could be shorter if any keys specified are not registered.
  Throws:
    `IfsException` - if the operation fails

### lookupAuditEventOperationTypeKeys

    public java.lang.String[] lookupAuditEventOperationTypeKeys(int[] opTypes)
                                                         throws IfsException

  Description copied from class: `LibrarySession`
  Looks up audit event operation type keys by their numeric values, returning the string keys.

  Parameters:
    `opTypes` - numeric operation types
  Returns:
    the String key equivalents; note the returned array could be shorter if any specified types are not registered.
  Throws:
    `IfsException` - if the operation fails

### lookupAuditTargetCode

    public AuditTargetCode lookupAuditTargetCode(java.lang.String className)
                                          throws IfsException

  Description copied from class: `LibrarySession`
  Looks up an audit target code structure from the specified Class name or other registered alias for the desired type.

  Parameters:
    `className` - class name associated with a registered audit target type
  Returns:
    the AuditTargetCode structure, or null if none found matching the specified class name
  Throws:
    `IfsException` - if the operation fails

### getAuditTypesForClass

    public AttributeValue[] getAuditTypesForClass(java.lang.String className,
                                                  boolean includeNested)
                                           throws IfsException

  Description copied from class: `LibrarySession`
  Gets the audit operation type values for a specified class name, optionally including any types that are applicable to a class that is considered a descendent of the specified class.

  The AttributeValues returned use the operation type key as the name, and the numeric operation type as the value.

  Parameters:
    `className` - the class name of interest, force to upper case (e.g. FOLDER)
    `includeNested` - whether or not to include operations for classes that are descendents of the specified class
  Returns:
    the operation types that match
  Throws:
    `IfsException` - if the operation fails

### getAuditTypesForCreateOperations

    public AttributeValue[] getAuditTypesForCreateOperations()
                                                      throws IfsException

  Description copied from class: `LibrarySession`
  Gets the audit operation type values that correspond to "CREATED" operations.

  Used to indicate when an object has been created simply by inspecting event types.

  Returns:
    the operation types for create operations
  Throws:
    `IfsException` - if the operation fails

### getAuditTypesForFreeOperations

    public AttributeValue[] getAuditTypesForFreeOperations()
                                                    throws IfsException

  Description copied from class: `LibrarySession`
  Gets the audit operation type values that correspond to "FREE" operations.

  Used to indicate when an object has been freed simply by inspecting event types.

  Returns:
    the operation types for free operations
  Throws:
    `IfsException` - if the operation fails

### getCustomAuditTypes

    public AttributeValue[] getCustomAuditTypes()
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Gets the custom audit operation type values.

  Returns:
    the custom operation types
  Throws:
    `IfsException` - if the operation fails

### registerCustomAuditEventOperationCodeKey

    public int registerCustomAuditEventOperationCodeKey(java.lang.String opCodeKey)
                                                 throws IfsException

  Description copied from class: `LibrarySession`
  Register a new custom operation code key.

  If the key is already registered, this simply returns the numeric value of the previous registration.

  Parameters:
    `opCodeKey` - operation code key; e.g. "FAXED"
  Returns:
    the numeric operation code registered
  Throws:
    `IfsException` - if the operation fails

### registerCustomAuditEventOperationType

    public void registerCustomAuditEventOperationType(java.lang.String opTypeKey,
                                                      java.lang.String opCodeKey,
                                                      int targetCode,
                                                      java.lang.String targetClass)
                                               throws IfsException

  Description copied from class: `LibrarySession`
  Register a new custom audit event operation type.

  Slightly different signature than the one that registers non-custom types, as the operation code suffix must be registered in a separate step. This method is inherently idempotent - it will return successfully if the operation type is already registered.

  The caller must ensure that the targetCode and targetClass are consistent (the mapping is done by AuditEventTypeRegistrations).

  Parameters:
    `opTypeKey` - the operation key (e.g. "DOCUMENT__FAXED")
    `opCodeKey` - operation code key (e.g. "FAXED")
    `targetCode` - code for the target object type
    `targetClass` - class name for target object type (e.g. "DOCUMENT")
  Throws:
    `IfsException` - if the operation fails

### unregisterCustomAuditEventOperationType

    public void unregisterCustomAuditEventOperationType(java.lang.String opTypeKey)
                                                 throws IfsException

  Description copied from class: `LibrarySession`
  Unregister a custom audit event operation type.

  Slightly different semantics than the one that unregisters non-custom types. This method is inherently idempotent - it will return successfully even if the operation type is not registered.

  Parameters:
    `opTypeKey` - the operation key (e.g. "DOCUMENT__FAXED")
  Throws:
    `IfsException` - if the operation fails

### getHighestAuditId

    public long getHighestAuditId()
                           throws IfsException

  Description copied from class: `LibrarySession`
  Get the highest Audit Id in use.

  Currently approximates this by selecting the next ID by selecting from the audit sequence, and subtracting 1.

  Returns:
    the highest audit ID in effect
  Throws:
    `IfsException` - if the operation fails

### getAuditCertificates

    public AuditCertificate[] getAuditCertificates(java.lang.Long[] objectIds)
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Select AuditCertificates for the specified object IDs.

  Parameters:
    `objectIds` - object IDs
  Returns:
    the requested certificates
  Throws:
    `IfsException` - if the operation fails

### isTraced

    public final boolean isTraced(int channel,
                                  int level)
                           throws IfsException

  Description copied from class: `LibrarySession`
  Gets whether tracing is enabled for the specified channel and level.

  Specified by:
    `isTraced` in interface `Traceable`
  Parameters:
    `channel` - the channel number
    `level` - the level
  Returns:
    whether tracing is enabled
  Throws:
    `IfsException` - (IFS-11201) if the channel is invalid
  (Published)

### trace

    public final void trace(int channel,
                            int level,
                            java.lang.String payload)

  Description copied from class: `LibrarySession`
  Issues a trace request to the trace logger.

  Specified by:
    `trace` in interface `Traceable`
  Parameters:
    `channel` - the channel number
    `level` - the level
    `payload` - a string containing any additional information to be placed in the trace log
  (Published)

### getServiceConfigurationProperty

    public AttributeValue getServiceConfigurationProperty(java.lang.String name)
                                                   throws IfsException

  Description copied from class: `LibrarySession`
  Gets the specified service configuration property.

  Parameters:
    `name` - the property name
  Returns:
    the property, or null if there is no such property
  Throws:
    `IfsException` - (IFS-20004) if the operation fails
  (Published)

### getServiceConfigurationProperty

    public java.lang.String getServiceConfigurationProperty(java.lang.String name,
                                                            java.lang.String defaultValue)
                                                     throws IfsException

  Description copied from class: `LibrarySession`
  Gets the value of the specified service configuration property, as a string.

  Parameters:
    `name` - the property name
    `defaultValue` - the default value
  Returns:
    the property value
  Throws:
    `IfsException` - (IFS-20004) if the operation fails
  (Published)

### getServiceConfigurationProperty

    public boolean getServiceConfigurationProperty(java.lang.String name,
                                                   boolean defaultValue)
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Gets the value of the specified service configuration property, as a boolean.

  Parameters:
    `name` - the property name
    `defaultValue` - the default value
  Returns:
    the property value
  Throws:
    `IfsException` - (IFS-20004) if the operation fails
  (Published)

### getServiceConfigurationProperty

    public int getServiceConfigurationProperty(java.lang.String name,
                                               int defaultValue)
                                        throws IfsException

  Description copied from class: `LibrarySession`
  Gets the value of the specified service configuration property, as an integer.

  Parameters:
    `name` - the property name
    `defaultValue` - the default value
  Returns:
    the property value
  Throws:
    `IfsException` - (IFS-20004) if the operation fails
  (Published)

### getRepositoryParameterNames

    public java.lang.String[] getRepositoryParameterNames(java.lang.String prefix)
                                                   throws IfsException

  Description copied from class: `LibrarySession`
  Gets the repository parameter names that start with the specified prefix.

  Parameters:
    `prefix` - the prefix with which repository parameter names must start to be returned; if null or zero-length, all repository parameter names are returned
  Returns:
    the repository parameter names, or null if none
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getRepositoryParameter

    public java.lang.String getRepositoryParameter(java.lang.String name)
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Gets the value of the specified repository parameter.

  Parameters:
    `name` - the parameter name
  Returns:
    the parameter value, or null if there is no parameter with the specified name
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setRepositoryParameter

    public void setRepositoryParameter(java.lang.String name,
                                       java.lang.String value)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Sets the value of the specified repository parameter.

  Parameters:
    `name` - the parameter name
    `value` - the parameter value
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### deleteRepositoryParameter

    public void deleteRepositoryParameter(java.lang.String name)
                                   throws IfsException

  Description copied from class: `LibrarySession`
  Deletes the specified repository parameter.

  Parameters:
    `name` - the parameter name
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getEncryptedRepositoryParameter

    public java.lang.String getEncryptedRepositoryParameter(java.lang.String name)
                                                     throws IfsException

  Description copied from class: `LibrarySession`
  Gets the value of the specified repository parameter.

  The specified repository parameter's value is stored encrypted.

  Parameters:
    `name` - the parameter name
  Returns:
    the parameter value, or null if there is no parameter with the specified name
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setEncryptedRepositoryParameter

    public void setEncryptedRepositoryParameter(java.lang.String name,
                                                java.lang.String value)
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Sets the value of the specified repository parameter.

  The specified repository parameter's value is stored encrypted.

  Parameters:
    `name` - the parameter name
    `value` - the parameter value, up to 127 characters
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### postAdminModeChange

    protected final void postAdminModeChange()
                                      throws IfsException

  Description copied from class: `LibrarySession`
  Post intra-session admin mode change. This is not a normal event, as it only affects the target session. It is called internally whenever an operation results in a change of administration mode, including group admininstration mode changes.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### postDefaultFolderOptionChange

    protected final void postDefaultFolderOptionChange()
                                                throws IfsException

  Description copied from class: `LibrarySession`
  Post intra-session change to default Folder options, such as default sort order or FolderRelationship class. This is not a normal event, as it only affects the target session.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### postEvent

    protected final void postEvent(IfsEvent event)
                            throws IfsException

  Description copied from class: `LibrarySession`
  Post the specified event.

  Parameters:
    `event` - the event
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getEventPoller

    public final oracle.ifs.beans.LibrarySessionEventPoller getEventPoller()
                                                                    throws IfsException

  Description copied from class: `LibrarySession`
  Gets the event poller for this LibrarySession.

  Returns:
    the event poller
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### processEvents

    public final void processEvents()
                             throws IfsException

  Description copied from class: `LibrarySession`
  Polls the server for any events queued for transport to this LibrarySession and immediately processes them.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### flushEvents

    public final void flushEvents()
                           throws IfsException

  Description copied from class: `LibrarySession`
  Flushes any outgoing events to the database.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### forceReadEvents

    public final void forceReadEvents()
                               throws IfsException

  Description copied from class: `LibrarySession`
  Forces a read and processing of incoming events from other services.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### processEventsInBackground

    protected final void processEventsInBackground()
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Polls the server for any events queued for transport to this LibrarySession and immediately processes them.

  Unlike `processEvents`, which is part of the published API and only invoked from user applications, this method is invoked only by the EventPoller. As such, it uses different locking semantics.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### blockBackgroundProcessing

    public final void blockBackgroundProcessing()

  Description copied from class: `LibrarySession`
  Blocks any background event processing.

  Necessary whenever IfsConnections are used in bean-side code. The caller must ensure that `resumeBackgroundProcessing` is called in a finally block to resume background processing.

  (Unpublished)

### resumeBackgroundProcessing

    public final void resumeBackgroundProcessing()

  Description copied from class: `LibrarySession`
  Resumes any background event processing.

  Must allows be called after a call to `blockBackgroundProcessing`.

  (Unpublished)

### processEvent

    public final void processEvent(IfsEvent event)
                            throws IfsException

  Description copied from class: `LibrarySession`
  Processes the specified event. This is an internal method, and should only be used by the event processing methods in S_LibrarySession.

  Parameters:
    `event` - the event
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### handleEvent

    public void handleEvent(IfsEvent event)
                     throws IfsException

  Description copied from class: `LibrarySession`
  Handles the specified event.

  Specified by:
    `handleEvent` in interface `IfsEventHandler`
  Parameters:
    `event` - the event
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### registerEventHandler

    public final void registerEventHandler(LibraryObject lo,
                                           IfsEventHandler handler)
                                    throws IfsException

  Description copied from class: `LibrarySession`
  Registers the specified IfsEventHandler to receive events for the specified LibraryObject.

  This method allows any object implementing the IfsEventHandler interface to receive notification of events for any LibraryObject. This could be used, for example, to automatically refresh a window displaying the items in a Folder whenever the Folder's contents change.

  Parameters:
    `lo` - the LibraryObject of interest
    `handler` - the IfsEventHandler
  Throws:
    `IfsException` - (IFS-11000) if the operation fails
  (Published)

### deregisterEventHandler

    public final void deregisterEventHandler(LibraryObject lo,
                                             IfsEventHandler handler)
                                      throws IfsException

  Description copied from class: `LibrarySession`
  Deregisters the specified IfsEventHandler for the specified LibraryObject.

  Parameters:
    `lo` - the LibraryObject. If null, all LibraryObjects previously registered for the IfsEventHandler using `registerEventHandler` are deregistered.
    `handler` - the IfsEventHandler. If null, all IfsEventHandlers previously registered for the LibraryObject using `registerEventHandler` are deregistered.
  Throws:
    `IfsException` - (IFS-11001) if the operation fails
  (Published)

### registerClassEventHandler

    public final void registerClassEventHandler(ClassObject co,
                                                boolean includeSubclasses,
                                                IfsEventHandler handler)
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Registers the specified IfsEventHandler to receive events for all objects in the specified class.

  This method allows any object implementing the IfsEventHandler interface to receive notification of events for any LibraryObject. This could be used, for example, to automatically refresh a window displaying the items in a Folder whenever the Folder's contents change.

  Parameters:
    `co` - the ClassObject of interest
    `includeSubclasses` - whether to include current subclasses of `co`; if a new subclass is subsequently created, it must be explicitly registered for IfsEventHandler to receive events on LibraryObjects of that new class
    `handler` - the IfsEventHandler
  Throws:
    `IfsException` - (IFS-11000) if the operation fails
  (Published)

### deregisterClassEventHandler

    public final void deregisterClassEventHandler(ClassObject co,
                                                  boolean includeSubclasses,
                                                  IfsEventHandler handler)
                                           throws IfsException

  Description copied from class: `LibrarySession`
  Deregisters the specified IfsEventHandler for the specified class.

  Parameters:
    `co` - the ClassObject. If null, all ClassObjects previously registered for the IfsEventHandler using `registerClassEventHandler` are deregistered.
    `includeSubclasses` - whether to include current subclasses of `co`
    `handler` - the IfsEventHandler. If null, all IfsEventHandlers previously registered for the ClassObject using `registerClassEventHandler` are deregistered.
  Throws:
    `IfsException` - (IFS-11001) if the operation fails
  (Published)

### registerServiceEventHandler

    public final void registerServiceEventHandler(IfsEventHandler handler)
                                           throws IfsException

  Description copied from class: `LibrarySession`
  Registers the specified IfsEventHandler to receive events for all committed events processed by the current service.

  This method allows any object implementing the IfsEventHandler interface to receive notification of all committed events processed by the S_LibraryService.

  Parameters:
    `handler` - the IfsEventHandler
  Throws:
    `IfsException` - 11000: if the operation fails
  (Unpublished)

### deregisterServiceEventHandler

    public final void deregisterServiceEventHandler(IfsEventHandler handler)
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Deregisters the specified IfsEventHandler.

  Parameters:
    `handler` - the IfsEventHandler. If null, all IfsEventHandlers previously registered are deregistered.
  Throws:
    `IfsException` - (IFS-11001) if the operation fails
  (Unpublished)

### isConnected

    public boolean isConnected()

  Description copied from class: `LibrarySession`
  Return connection state of this LibrarySession

  Returns:
    the connection state; true if connected.
  (Published)

### isBusy

    public final boolean isBusy()
                         throws IfsException

  Description copied from class: `LibrarySession`
  Return busy state of this LibrarySession. This returns true if there is an active operation in the server for this session

  Returns:
    the busy state; true if a server-side operation is in progress
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### isOuterOperation

    public final boolean isOuterOperation()
                                   throws IfsException

  Description copied from class: `LibrarySession`
  Return indication as to whether the outer most operation (of a potentially nested operation) is currently in progress.

  Returns:
    true if the outermost operation is in progress
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setCreateContext

    public final void setCreateContext(java.lang.Long id,
                                       LibraryObjectDefinition def)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Set the context of a create operation for the specified object.

  Parameters:
    `id` - the object ID
    `def` - the create operation context
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getCreateContext

    public final LibraryObjectDefinition getCreateContext(java.lang.Long id)
                                                   throws IfsException

  Description copied from class: `LibrarySession`
  Get the context of a create operation, if a create is in progress for the specified object.

  Parameters:
    `id` - the object ID
  Returns:
    the create operation context if the specified object has a create operation in progress, or null otherwise
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### clearCreateContext

    public final void clearCreateContext(java.lang.Long id)
                                  throws IfsException

  Description copied from class: `LibrarySession`
  Remove the context of a create operation for the specified object.

  Parameters:
    `id` - the object ID
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setFreeContext

    public final void setFreeContext(java.lang.Long id,
                                     LibraryObjectDefinition def)
                              throws IfsException

  Description copied from class: `LibrarySession`
  Set the context of a free operation for the specified object.

  Parameters:
    `id` - the object ID
    `def` - the free operation context
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getFreeContext

    public final LibraryObjectDefinition getFreeContext(java.lang.Long id)
                                                 throws IfsException

  Description copied from class: `LibrarySession`
  Get the context of a free operation, if a free is in progress for the specified object.

  Parameters:
    `id` - the object ID
  Returns:
    the free operation context if the specified object has a free operation in progress, or null otherwise
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### clearFreeContext

    public final void clearFreeContext(java.lang.Long id)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Remove the context of a free operation for the specified object.

  Parameters:
    `id` - the object ID
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setUpdateContext

    public final void setUpdateContext(java.lang.Long id,
                                       LibraryObjectDefinition def)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Set the context of an update operation for the specified object.

  Parameters:
    `id` - the object ID
    `def` - the update operation context
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getUpdateContext

    public final LibraryObjectDefinition getUpdateContext(java.lang.Long id)
                                                   throws IfsException

  Description copied from class: `LibrarySession`
  Get the context of an update operation, if an update is in progress for the specified object.

  Parameters:
    `id` - the object ID
  Returns:
    the update operation context if the specified object has an update operation in progress, or null otherwise
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### clearUpdateContext

    public final void clearUpdateContext(java.lang.Long id)
                                  throws IfsException

  Description copied from class: `LibrarySession`
  Remove the context of an update operation for the specified object.

  Parameters:
    `id` - the object ID
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setCopyContext

    public final void setCopyContext(java.lang.Long id,
                                     LibraryObjectDefinition def)
                              throws IfsException

  Description copied from class: `LibrarySession`
  Set the context of a copy operation for the specified object.

  Parameters:
    `id` - the object ID
    `def` - the copy operation context
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getCopyContext

    public final LibraryObjectDefinition getCopyContext(java.lang.Long id)
                                                 throws IfsException

  Description copied from class: `LibrarySession`
  Get the context of a copy operation, if a copy is in progress for the specified object.

  Parameters:
    `id` - the object ID
  Returns:
    the copy operation context if the specified object has a copy operation in progress, or null otherwise
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### clearCopyContext

    public final void clearCopyContext(java.lang.Long id)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Remove the context of a copy operation for the specified object.

  Parameters:
    `id` - the object ID
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### beginImplicitTransaction

    public final Transaction beginImplicitTransaction()
                                               throws IfsException

  Description copied from class: `LibrarySession`
  Starts a writeable transaction implicitly at the beginning of an operation. Returns null and takes no action if an implicit transaction is already started, either initialted bean-side or server-side.

  Returns:
    a token that can be passed to either `completeImplicitTransaction` or `abortImplicitTransaction`. The token is null if an implicit transaction is already started.
  Throws:
    `IfsException` - (IFS-10651) if the operation fails
  (Unpublished)

### completeImplicitTransaction

    public final void completeImplicitTransaction(Transaction transaction)
                                           throws IfsException

  Description copied from class: `LibrarySession`
  Completes an implicit transaction. If the specified transaction is null, then an implicit transaction was not created, and no action is necessary.

  Parameters:
    `transaction` - the transaction to complete
  Throws:
    `IfsException` - (IFS-10652) if the operation fails
  (Unpublished)

### abortImplicitTransaction

    public final void abortImplicitTransaction(Transaction transaction)

  Description copied from class: `LibrarySession`
  Aborts an implicit transaction. If the specified transaction is null, then an implicit transaction was not created, and no action is necessary. If an exception occurs while trying to abort the implicit transaction, the transaction will be forcefully rolled back, and the internal exception will be logged.

  Parameters:
    `transaction` - the transaction to abort
  (Unpublished)

### isImplicitTransactionInProgress

    public final boolean isImplicitTransactionInProgress()
                                                  throws IfsException

  Description copied from class: `LibrarySession`
  Return indication as to whether there is an implicit transaction in progress.

  Returns:
    true if an implicit transaction is in progress
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### isTransactionInProgress

    public final boolean isTransactionInProgress()
                                          throws IfsException

  Description copied from class: `LibrarySession`
  Gets whether this LibrarySession is in a transaction, explicit or implicit.

  Returns:
    true if the session has a transaction context; false otherwise
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### cancel

    public final void cancel()
                      throws IfsException

  Description copied from class: `LibrarySession`
  Cancel any server-side operation in progress for this session. If no server-side operation is in progress, this method simply returns without performing any action, and no exception is thrown. Otherwise, a cancel is signalled on the server-side. This method may return before the operation is completely cancelled, as the completion of the cancellation occurs in another thread.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getResourceString

    public java.lang.String getResourceString(java.lang.String key)
                                       throws IfsException

  Description copied from class: `LibrarySession`
  Gets the resource string for the specified key.

  The method looks-up the key in each extended resource bundle. If no extended resource bundle contains the key, the default resource bundle (LibraryResources) is used.

  Parameters:
    `key` - the resource bundle key
  Returns:
    the resource string
  Throws:
    `IfsException` - IFS-12001 if the operation fails
  (Unpublished)

### getResourceString

    public java.lang.String getResourceString(java.lang.String key,
                                              java.lang.Object[] params)
                                       throws IfsException

  Description copied from class: `LibrarySession`
  Gets the resource string for the specified key, and substitutes the specified parameters into that resource string.

  The method looks-up the key using `getResourceString(key)`. Next, `java.text.MessageFormat` is used to substitute the parameters specified by `params` into the key's value. If a string element of `params` is delimited by brackets, i.e. "`{param}`", then that element is replaced with the value returned by `getResourceString("param")` before being passed to `MessageFormat`.

  Parameters:
    `key` - the resource bundle key
    `params` - an array of Objects to be substituted into the resource bundle message using using `java.text.MessageFormat`
  Returns:
    the formatted resource string
  Throws:
    `IfsException` - IFS-12006 if the operation fails
  (Unpublished)

### getClassObjectByName

    public final ClassObject getClassObjectByName(java.lang.String classname)
                                           throws IfsException

  Description copied from class: `LibrarySession`
  Returns a class object given a class name. This uses the ClassObjectCollection and is simply a convenience method.

  Parameters:
    `classname` - the name of a class
  Returns:
    the ClassObject matching the specified name
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getClassObjectValueByName

    public AttributeValue getClassObjectValueByName(java.lang.String name)
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Gets an AttributeValue representation of a CLASSOBJECT that has the specified name.

  Specified by:
    `getClassObjectValueByName` in interface `LibrarySessionInterface`
  Returns:
    the CLASSOBJECT value
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getAttributeSortName

    public java.lang.String getAttributeSortName(java.lang.String classname,
                                                 java.lang.String attributename)
                                          throws IfsException

  Description copied from class: `LibrarySession`
  return the Database object name that corresponds to an Attribute of a specified ClassObject. Used by SortSpecification to derive the SQL order by clause. This will throw an Exception if there is no Attribute for the specified class, or if the ClassObject does not exist.

  This is part of the LibrarySessionInterface definition.

  Specified by:
    `getAttributeSortName` in interface `LibrarySessionInterface`
  Parameters:
    `classname` - the name of the ClassObject
    `attributename` - the name of the Attribute
  Returns:
    the Database object name that corresponds to an Attribute.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getDirectoryObject

    public DirectoryObject getDirectoryObject(java.lang.Long id)
                                       throws IfsException

  Description copied from class: `LibrarySession`
  Lookup a DirectoryObject by its id.

  Parameters:
    `id` - identifier for the object
  Returns:
    the DirectoryObject
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getLibraryObject

    public LibraryObject getLibraryObject(java.lang.Long id)
                                   throws IfsException

  Description copied from class: `LibrarySession`
  Lookup a LibraryObject by its id.

  Parameters:
    `id` - identifier for the object
  Returns:
    the LibraryObject
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getLibraryObject

    public LibraryObject getLibraryObject(java.lang.Long id,
                                          java.lang.Long classId)
                                   throws IfsException

  Description copied from class: `LibrarySession`
  Lookup a LibraryObject by its id and classId.

  Parameters:
    `id` - ID for the object
    `classId` - class ID for the object
  Returns:
    the LibraryObject
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getSchemaObject

    public SchemaObject getSchemaObject(java.lang.Long id)
                                 throws IfsException

  Description copied from class: `LibrarySession`
  Lookup a SchemaObject by its id.

  Parameters:
    `id` - identifier for the object
  Returns:
    the SchemaObject
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getSchemaObject

    public SchemaObject getSchemaObject(java.lang.Long id,
                                        java.lang.Long classId)
                                 throws IfsException

  Description copied from class: `LibrarySession`
  Lookup a SchemaObject by its id and classId.

  The classId can be specified as null if it is not known.

  Parameters:
    `id` - ID for the object
    `classId` - class ID for the object
  Returns:
    the SchemaObject
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getSystemObject

    public SystemObject getSystemObject(java.lang.Long id)
                                 throws IfsException

  Description copied from class: `LibrarySession`
  Lookup a SystemObject by its id.

  Parameters:
    `id` - identifier for the object
  Returns:
    the SystemObject
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getSystemObject

    public SystemObject getSystemObject(java.lang.Long id,
                                        java.lang.Long classId)
                                 throws IfsException

  Description copied from class: `LibrarySession`
  Lookup a SystemObject by its id and classId.

  The classId can be specified as null if it is not known.

  Parameters:
    `id` - ID for the object
    `classId` - class ID for the object
  Returns:
    the SystemObject
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getPublicObject

    public PublicObject getPublicObject(java.lang.Long id)
                                 throws IfsException

  Description copied from class: `LibrarySession`
  Lookup a PublicObject by its id.

  Parameters:
    `id` - identifier for the object
  Returns:
    the PublicObject
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getPublicObject

    public PublicObject getPublicObject(java.lang.Long id,
                                        java.lang.Long classId)
                                 throws IfsException

  Description copied from class: `LibrarySession`
  Lookup a PublicObject by its id and classId.

  The classId can be specified as null if it is not known.

  Parameters:
    `id` - ID for the object
    `classId` - class ID for the object
  Returns:
    the PublicObject
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getDiscoverabilityOfPublicObjectsIds

    public java.lang.Long[] getDiscoverabilityOfPublicObjectsIds(java.lang.Long[] ids)
                                                          throws IfsException

  Description copied from class: `LibrarySession`
  Return indication as to which PublicObject objects specified (by ID) the current user can discover.

  The array specified contains the set of PublicObject IDs that are to be checked. A corresponding array is returned, which will be a clone of the one specified, with null values replaced for the IDs that correspond to objects the user cannot discover.

  Parameters:
    `ids` - array of PublicObject IDs
  Returns:
    array containing the original values reflecting the objects that are discoverable by the user, and null values in the corresponding elements for objects the user cannot discover.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### isDiscoverablePublicObjectId

    public boolean isDiscoverablePublicObjectId(java.lang.Long id)
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Return indication as to whether the PublicObject ID specified represents an object that the current user can discover.

  Parameters:
    `id` - the PublicObject ID to check
  Returns:
    true if the ID represents an ID the user can discover; false otherwise
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### isPublicObjectIdDiscoverable

    public boolean isPublicObjectIdDiscoverable(java.lang.Long id)
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Return indication as to whether the PublicObject matching the specified object ID is discoverable.

  Returns true if and only if the user is able to discover a PublicObject with the ID specified.

  Parameters:
    `id` - PublicObject ID
  Returns:
    true if the user can discover a PublicOBject with the specified ID; false otherwise
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getDirectoryObjectInterface

    public DirectoryObjectInterface getDirectoryObjectInterface(java.lang.Long id)
                                                         throws IfsException

  Description copied from class: `LibrarySession`
  Gets the DirectoryObjectInterface for the specified id.

  Specified by:
    `getDirectoryObjectInterface` in interface `LibrarySessionInterface`
  Parameters:
    `id` - the id of interest
  Returns:
    the DirectoryObjectInterface
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getDirectoryObjectInterfaces

    public DirectoryObjectInterface[] getDirectoryObjectInterfaces(java.lang.Long[] ids)
                                                            throws IfsException

  Description copied from class: `LibrarySession`
  Gets the DirectoryObjectInterfaces for the specified ids.

  Specified by:
    `getDirectoryObjectInterfaces` in interface `LibrarySessionInterface`
  Parameters:
    `ids` - the ids of interest
  Returns:
    the DirectoryObjectInterfaces
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getPublicObjectInterface

    public PublicObjectInterface getPublicObjectInterface(java.lang.Long id)
                                                   throws IfsException

  Description copied from class: `LibrarySession`
  Gets the PublicObjectInterface for the specified id.

  Specified by:
    `getPublicObjectInterface` in interface `LibrarySessionInterface`
  Parameters:
    `id` - the id of interest
  Returns:
    the PublicObjectInterface
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getPublicObjectInterfaces

    public PublicObjectInterface[] getPublicObjectInterfaces(java.lang.Long[] ids)
                                                      throws IfsException

  Description copied from class: `LibrarySession`
  Gets the PublicObjectInterfaces for the specified ids.

  Specified by:
    `getPublicObjectInterfaces` in interface `LibrarySessionInterface`
  Parameters:
    `ids` - the ids of interest
  Returns:
    the PublicObjectInterfaces
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getSchemaObjectInterface

    public SchemaObjectInterface getSchemaObjectInterface(java.lang.Long id)
                                                   throws IfsException

  Description copied from class: `LibrarySession`
  Gets the SchemaObjectInterface for the specified id.

  Specified by:
    `getSchemaObjectInterface` in interface `LibrarySessionInterface`
  Parameters:
    `id` - the id of interest
  Returns:
    the SchemaObjectInterface
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getSchemaObjectInterfaces

    public SchemaObjectInterface[] getSchemaObjectInterfaces(java.lang.Long[] ids)
                                                      throws IfsException

  Description copied from class: `LibrarySession`
  Gets the SchemaObjectInterfaces for the specified ids.

  Specified by:
    `getSchemaObjectInterfaces` in interface `LibrarySessionInterface`
  Parameters:
    `ids` - the ids of interest
  Returns:
    the SchemaObjectInterfaces
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getSystemObjectInterface

    public SystemObjectInterface getSystemObjectInterface(java.lang.Long id)
                                                   throws IfsException

  Description copied from class: `LibrarySession`
  Gets the SystemObjectInterface for the specified id.

  Specified by:
    `getSystemObjectInterface` in interface `LibrarySessionInterface`
  Parameters:
    `id` - the id of interest
  Returns:
    the SystemObjectInterface
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getSystemObjectInterfaces

    public SystemObjectInterface[] getSystemObjectInterfaces(java.lang.Long[] ids)
                                                      throws IfsException

  Description copied from class: `LibrarySession`
  Gets the SystemObjectInterfaces for the specified ids.

  Specified by:
    `getSystemObjectInterfaces` in interface `LibrarySessionInterface`
  Parameters:
    `ids` - the ids of interest
  Returns:
    the SystemObjectInterfaces
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getLibraryObject

    public LibraryObject getLibraryObject(S_LibraryObjectData data)
                                   throws IfsException

  Description copied from class: `LibrarySession`
  getLibraryObject - lookup a LibraryObject by its data.

  Parameters:
    `data` - a data object
  Returns:
    the corresponding object
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### constructInstance

    protected LibraryObject constructInstance(S_LibraryObjectData data)
                                       throws IfsException

  Description copied from class: `LibrarySession`
  construct a LibraryObject Instance

  Parameters:
    `data` - data for the object
  Returns:
    the object
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### constructInstance

    public LibraryObject constructInstance(java.lang.Long id,
                                           java.lang.Long class_id,
                                           S_ClassObjectData classData)
                                    throws IfsException

  Description copied from class: `LibrarySession`
  construct a LibraryObject Instance

  Parameters:
    `id` - id for the object
    `class_id` - Class id for the object
    `classData` - Class data for the object's class
  Returns:
    the object
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### cacheInstance

    protected LibraryObject cacheInstance(java.lang.Long id,
                                          LibraryObject obj)
                                   throws IfsException

  Description copied from class: `LibrarySession`
  Put a LibraryObject Instance in the session's object cache.

  This is done as part of normal construction, and is also done when after an object's creation is complete, if constructed prior to createPublicObject() etal.

  Parameters:
    `id` - id for the object
    `obj` - the object
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getLibraryObjectData

    public S_LibraryObjectData getLibraryObjectData(java.lang.Long id,
                                                    java.lang.Long classId,
                                                    java.lang.String attributeName,
                                                    boolean selectFully)
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Gets the S_LibraryObjectData for the specified id and class id.

  Parameters:
    `id` - the id of interest
    `classId` - the if of the class
    `attributeName` - if non-null, the returned data will be selected at least as deeply as this attribute
    `selectFully` - if true, the returned data will be fully selected (i.e. as deep as possible)
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getServerSideLockObject

    public java.lang.Object getServerSideLockObject()

  Description copied from class: `LibrarySession`
  Gets the Object used by LibrarySession to synchronize invocations to the server-side class, mainly the invocations of the methods defined by the S_LibrarySessionInterface.

  Returns:
    the synchronization object
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getResolvedClassObjectData

    public S_ClassObjectData getResolvedClassObjectData(java.lang.Long id)
                                                 throws IfsException

  Description copied from class: `LibrarySession`
  Gets the fully-resolved S_ClassObjectData.

  Parameters:
    `id` - the id
  Returns:
    the data
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### delete

    public void delete(PublicObject[] items)
                throws IfsException

  Description copied from class: `LibrarySession`
  Deletes all the passed PublicObjects. All objects are marked for delete and are 'moved' to the virtual wastebasket. The objects are deleted in a single transaction; any failure will rollback the entire operation.

  Parameters:
    `items` - the PublicObjects to be deleted.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### undelete

    public void undelete(PublicObject[] items)
                  throws IfsException

  Description copied from class: `LibrarySession`
  Undeletes all the passed PublicObjects. The passed objects are 'moved' from the virtual wastebasket by having their marked for delete attribute cleared. The objects are undeleted in a single transaction; any failure will rollback the entire operation.

  Parameters:
    `items` - the PublicObjects to be undeleted.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### free

    public void free(LibraryObject[] items)
              throws IfsException

  Description copied from class: `LibrarySession`
  Free all the passed objects. All passed objects are permanently removed from the CM SDK Server. The objects are freed in a single transaction; any failure will rollback the entire operation.

  Parameters:
    `items` - the objects to be freed.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getObjectsLockedForSession

    public PublicObject[] getObjectsLockedForSession()
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Gets the array of PublicObjects that the current session holds session locks on.

  Returns:
    the PublicObjects currently session locked by this session.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### unlockForSession

    public void unlockForSession(PublicObject[] items)
                          throws IfsException

  Description copied from class: `LibrarySession`
  Release session locks on a set of PublicObjects. This method is convenient for releasing session locks explicitly on all objects that are locked by this session; use this method in conjunction with the getObjectsLockedForSession() method.

  The objects are unlocked in a single transaction; any failure will rollback the entire operation.

  Parameters:
    `items` - the PublicObjects to be unlocked.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getWorldDirectoryGroup

    public DirectoryGroup getWorldDirectoryGroup()
                                          throws IfsException

  Description copied from class: `LibrarySession`
  Gets the DirectoryGroup that represents World access.

  Returns:
    the World group.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getSystemDirectoryUser

    public DirectoryUser getSystemDirectoryUser()
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Gets the DirectoryUser who is the permanent admin user.

  Returns:
    the system user
  Throws:
    `IfsException` - if operation fails.
  (Published)

### isSystemDirectoryUser

    public boolean isSystemDirectoryUser()
                                  throws IfsException

  Description copied from class: `LibrarySession`
  Returns true if the session's current user is the permanent admin user.

  Returns:
    true if the permanent admin user is the current user
  Throws:
    `IfsException` - if operation fails.
  (Published)

### isGuestUser

    public boolean isGuestUser()
                        throws IfsException

  Description copied from class: `LibrarySession`
  Returns true if the session's current user is the guest user.

  Returns:
    true if the guest user is the current user
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getGuestUser

    public DirectoryUser getGuestUser()
                               throws IfsException

  Description copied from class: `LibrarySession`
  Gets the DirectoryUser who is the guest user.

  Returns:
    the guest user; returns null if there is no guest user
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getArrayTypeAttributeValue

    public AttributeValue getArrayTypeAttributeValue(AttributeValueArray av,
                                                     long objectId,
                                                     long attributeId,
                                                     long auditId,
                                                     int count)
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Gets a fully resolved array-type AttributeValue with non-transient elements that is a copy of the specified array-type AttributeValue.

  For internal use only. Do not use this method.

  The invoker of this method sucks the elements from the returned object, plugs them into the corresponding cached AttributeValue, and then discards the returned object.

  Specified by:
    `getArrayTypeAttributeValue` in interface `LibrarySessionInterface`
  Parameters:
    `av` - the AttributeValue of interest
    `objectId` - if this AttributeValue represents the value of a LibraryObject's Attribute, this is the id of that LibraryObject; -1 if this AttributeValue represents the value of a system audit entry property
    `attributeId` - if this AttributeValue represents the value of a LibraryObject's Attribute, this is the id of that Attribute; if this AttributeValue represents the value of a system audit entry property, this is the system audit entry property id
    `auditId` - if this AttributeValue represents the value of a system audit entry property or an audited LibraryObject's Attribute, this is the audit id; 0 if this AttributeValue represents the current value of a LibraryObject's Attribute
    `count` - the number of elements in the AttributeValue
  Returns:
    a fully-resolved copy of the AttributeValue
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### grantAdministration

    public void grantAdministration(DirectoryUser user)
                             throws IfsException

  Description copied from class: `LibrarySession`
  Grant the Administrator Mode state for the specified Directory User.

  Parameters:
    `user` - the user to receive the admin grant
  Throws:
    `IfsException` - if operation fails.
  (Published)

### registerCollection

    public void registerCollection(Collection collection,
                                   java.lang.String classname)
                            throws IfsException

  Description copied from class: `LibrarySession`
  Registers a collection so that it can be automatically reset by handleEvent as needed when new LibraryObjects are created, updated, or freed.

  Parameters:
    `collection` - the collection itself
    `classname` - the classname corresponding to the ClassObject name specified at collection construction
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### deregisterCollection

    public void deregisterCollection(Collection collection,
                                     java.lang.String classname)
                              throws IfsException

  Description copied from class: `LibrarySession`
  Deregisters a collection, cancelling the event registration.

  Parameters:
    `collection` - the collection itself
    `classname` - the classname corresponding to the ClassObject name specified at collection construction
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyExecutionMode

    public void verifyExecutionMode(int mode)
                             throws IfsException

  Description copied from class: `LibrarySession`
  Verify that the effective execution mode for the session is at least the mode specified.

  Throw an exception otherwise.

  Throws:
    `IfsException` - if not in at least the mode specified
  (Unpublished)

### verifyAdministrationMode

    public void verifyAdministrationMode()
                                  throws IfsException

  Description copied from class: `LibrarySession`
  Verify that the effective execution mode for the session is at least administration mode.

  Throws:
    `IfsException` - (IFS-21051) if not in administration mode
  (Unpublished)

### verifyInstallationMode

    protected void verifyInstallationMode()
                                   throws IfsException

  Description copied from class: `LibrarySession`
  Verify that the effective execution mode for the session is at least installation mode.

  Throws:
    `IfsException` - (IFS-21051) if not in installation mode
  (Unpublished)

### beginTransaction

    public final Transaction beginTransaction()
                                       throws IfsException

  Description copied from class: `LibrarySession`
  Starts a writeable transaction.

  Returns:
    a token that can be passed to either `completeTransaction` or `abortTransaction`
  Throws:
    `IfsException` - (IFS-21000) if not connected; (IFS-10651) if the operation fails
  (Published)

### completeTransaction

    public final void completeTransaction(Transaction transaction)
                                   throws IfsException

  Description copied from class: `LibrarySession`
  Completes a transaction.

  Parameters:
    `transaction` - the transaction to complete
  Throws:
    `IfsException` - (IFS-21000) if not connected; (IFS-10652) if the operation fails
  (Published)

### abortTransaction

    public final void abortTransaction(Transaction transaction)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Aborts a transaction.

  Parameters:
    `transaction` - the transaction to abort
  Throws:
    `IfsException` - (IFS-21000) if not connected; (IFS-10653) if the operation fails
  (Published)

### abortTransaction

    public final void abortTransaction(Transaction transaction,
                                       IfsException originalException)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Aborts a transaction in response to the specified IfsException.

  If an exception in thrown in aborting the transaction, `originalException` will be nested within IFS-10653.

  Parameters:
    `transaction` - the transaction to abort
    `originalException` - the IfsException that caused this transaction to be aborted
  Throws:
    `IfsException` - (IFS-10653) if the operation fails
  (Unpublished)

### commit

    public final void commit()
                      throws IfsException

  Description copied from class: `LibrarySession`
  Makes all pending changes for all in-progress Transactions for this LibrarySession visible to all other LibrarySessions.

  After this method is invoked, attempting to abort any of the in-progress Transactions for this LibrarySession will throw an exception.

  Throws:
    `IfsException` - (IFS-21000) if not connected; (IFS-10654) if the operation fails
  (Unpublished)

### rollback

    public final void rollback()
                        throws IfsException

  Description copied from class: `LibrarySession`
  Discards all pending changes for all in-progress Transactions for this LibrarySession.

  After this method is invoked, attempting to complete any of the in-progress Transactions for this LibrarySession will throw an exception.

  Throws:
    `IfsException` - (IFS-21000) if not connected; (IFS-10655) if the operation fails
  (Unpublished)

### getIfsConnection

    public IfsConnection getIfsConnection()
                                   throws IfsException

  Description copied from class: `LibrarySession`
  Returns an IfsConnection for this LibrarySession.

  A writeable transaction must be in progress; if not, an IfsException (IFS-10665) is thrown. The session must be in administration mode.

  Returns:
    the connection
  Throws:
    `IfsException` - if the operation fails
  (Published)

### invokeServerMethod

    public java.io.Serializable invokeServerMethod(java.lang.String methodName,
                                                   java.io.Serializable payload)
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes a custom server-side method. The payload and return are arbitrary Serializable objects. There must be a method with the specified name on the server-side S_LibrarySession class.

  Parameters:
    `methodName` - the method name.
    `payload` - the method argument
  Returns:
    the method result
  Throws:
    `IfsException` - if operation fails.
  (Published)

### createView

    public void createView(ViewSpecification vsp)
                    throws IfsException

  Description copied from class: `LibrarySession`
  Creates a database view from a View specification.

  Parameters:
    `vsp` - the view specification
  Throws:
    `IfsException` - if operation fails
  (Published)

### getFolderIndexDeferredUpdates

    public java.util.Vector getFolderIndexDeferredUpdates(int maxItems)
                                                   throws IfsException

  Description copied from class: `LibrarySession`
  Gets a set of Deferred Folder Index Updates

  Parameters:
    `maxItems` - the maximum number of entries to return
  Returns:
    a vector of FolderIndexDeferredUpdate, or null if no entries
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### applyFolderIndexDeferredUpdate

    public void applyFolderIndexDeferredUpdate(FolderIndexDeferredUpdate entry)
                                        throws IfsException

  Description copied from class: `LibrarySession`
  Apply a Folder index deferred update

  Parameters:
    `entry` - the entry to apply
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### isAclIndexUpdateModeSynchronous

    public boolean isAclIndexUpdateModeSynchronous()
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Check if ACL Index update mode is synchronous

  Returns:
    true if update mode is synchronous; false otherwise
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getAclIndexDeferredUpdates

    public java.util.Vector getAclIndexDeferredUpdates(int maxItems)
                                                throws IfsException

  Description copied from class: `LibrarySession`
  Gets a set of Deferred ACL Resolution Entries

  Parameters:
    `maxItems` - the maximum number of entries to return
  Returns:
    a vector of AccessControlListDeferredUpdate, or null if no entries
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### applyAclIndexDeferredUpdate

    public void applyAclIndexDeferredUpdate(AccessControlListDeferredUpdate entry,
                                            boolean deleteAfterProcessing)
                                     throws IfsException

  Description copied from class: `LibrarySession`
  Apply an ACL index deferred update

  Parameters:
    `entry` - the entry to apply
    `deleteAfterProcessing` - whether to delete after processing
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### deleteAclIndexDeferredUpdates

    public void deleteAclIndexDeferredUpdates(java.lang.Long[] ids)
                                       throws IfsException

  Description copied from class: `LibrarySession`
  Deletes a set of Deferred ACL Resolution Entries

  Parameters:
    `ids` - the set of AccessControlListDeferredUpdate IDs to delete
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### resolveObjects

    public void resolveObjects(LibraryObject[] objs,
                               ObjectResolverSpecification spec)
                        throws IfsException

  Description copied from class: `LibrarySession`
  Force resolution of a set of LibraryObjects

  Parameters:
    `objs` - the set of objects to resolve
    `spec` - the resolution specification
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### createRetainedEventDatabaseObjects

    public void createRetainedEventDatabaseObjects(RetainedEvent event)
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Create tables for a RetainedEvent type.

  Parameters:
    `event` - RetainedEvent that describes the type
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### dropRetainedEventDatabaseObjects

    public void dropRetainedEventDatabaseObjects(RetainedEvent event)
                                          throws IfsException

  Description copied from class: `LibrarySession`
  Drop tables for a RetainedEvent type.

  Parameters:
    `event` - RetainedEvent that describes the type
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### insertRetainedEvent

    public void insertRetainedEvent(RetainedEvent event)
                             throws IfsException

  Description copied from class: `LibrarySession`
  insert a RetainedEvent.

  Parameters:
    `event` - RetainedEvent to insert
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### deleteRetainedEvent

    public void deleteRetainedEvent(RetainedEvent event)
                             throws IfsException

  Description copied from class: `LibrarySession`
  delete a RetainedEvent.

  Parameters:
    `event` - RetainedEvent to delete
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getRetainedEvents

    public RetainedEvent[] getRetainedEvents(RetainedEvent event,
                                             int maxItems)
                                      throws IfsException

  Description copied from class: `LibrarySession`
  get a set of RetainedEvents, using a specified RetainedEvent to indicate the type of RetainedEvent desired.

  Parameters:
    `event` - Type of RetainedEvent desired
    `maxItems` - max number of items desired
  Returns:
    The set of RetainedEvents, can return null if none
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMSetLibrarySession

    protected void DMSetLibrarySession(LibrarySession session)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetSessionId

    protected java.lang.Long DMGetSessionId()
                                     throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetServiceId

    protected java.lang.Long DMGetServiceId()
                                     throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetClockOffset

    protected java.lang.Long DMGetClockOffset()
                                       throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetServiceConfigurationProperties

    protected java.util.Hashtable DMGetServiceConfigurationProperties()
                                                               throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetRepositoryParameterNames

    protected java.lang.String[] DMGetRepositoryParameterNames(java.lang.String prefix)
                                                        throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetRepositoryParameter

    protected java.lang.String DMGetRepositoryParameter(java.lang.String name)
                                                 throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMSetRepositoryParameter

    protected void DMSetRepositoryParameter(java.lang.String name,
                                            java.lang.String value)
                                     throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMDeleteRepositoryParameter

    protected void DMDeleteRepositoryParameter(java.lang.String name)
                                        throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetEncryptedRepositoryParameter

    protected java.lang.String DMGetEncryptedRepositoryParameter(java.lang.String name)
                                                          throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMSetEncryptedRepositoryParameter

    protected void DMSetEncryptedRepositoryParameter(java.lang.String name,
                                                     java.lang.String value)
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMUpdateSessionDefaults

    public final void DMUpdateSessionDefaults(java.util.Hashtable properties)
                                       throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMUpdateLocalizer

    public final void DMUpdateLocalizer(java.util.Hashtable properties)
                                 throws IfsException

  Description copied from class: `LibrarySession`
  Updates the S_LibrarySession Localizer to reflect the Localizer properties specified as name/value pairs.

  Parameters:
    `properties` - the Localizer properties
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRegisterEventHandler

    public void DMRegisterEventHandler(java.lang.Long id)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Notify server-side of a registered event handler for the specified object.

  Parameters:
    `id` - the object ID that has a registered handler
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMDeregisterEventHandler

    public void DMDeregisterEventHandler(java.lang.Long id)
                                  throws IfsException

  Description copied from class: `LibrarySession`
  Notify server-side that previously registered event handlers for the specified object have been de-registered.

  Parameters:
    `id` - the object ID that no longer has any registered handlers
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRegisterClassEventHandler

    public void DMRegisterClassEventHandler(java.lang.Long classId)
                                     throws IfsException

  Description copied from class: `LibrarySession`
  Notify server-side of a registered event handler for the specified ClassObject.

  Parameters:
    `classId` - the Class ID that has a registered handler
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMDeregisterClassEventHandler

    public void DMDeregisterClassEventHandler(java.lang.Long classId)
                                       throws IfsException

  Description copied from class: `LibrarySession`
  Notify server-side that previously registered event handlers for the specified ClassObject have been de-registered.

  Parameters:
    `classId` - the Class ID that no longer has any registered handlers
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRegisterServiceEventHandler

    protected void DMRegisterServiceEventHandler(IfsEventHandler handler)
                                          throws IfsException

  Description copied from class: `LibrarySession`
  Notify server-side of a new registered Service event handler.

  Parameters:
    `handler` - the handler to register
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMDeregisterServiceEventHandler

    protected void DMDeregisterServiceEventHandler(IfsEventHandler handler)
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Notify server-side to de-register a Service event handler.

  Parameters:
    `handler` - the handler to de-register
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMTrace

    protected void DMTrace(int channel,
                           int level,
                           java.lang.Long serviceId,
                           java.lang.Long sessionId,
                           java.lang.Long id,
                           java.lang.String classname,
                           java.lang.String payload)
                    throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMSetSessionTraceLoggerLevels

    protected void DMSetSessionTraceLoggerLevels(int[] levels)
                                          throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetSessionTraceLoggerLevels

    protected int[] DMGetSessionTraceLoggerLevels()
                                           throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMSetServiceTraceLoggerLevels

    protected void DMSetServiceTraceLoggerLevels(int[] levels)
                                          throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetServiceTraceLoggerLevels

    protected int[] DMGetServiceTraceLoggerLevels()
                                           throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMPostEvent

    protected void DMPostEvent(IfsEvent event)
                        throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMProcessEvents

    protected void DMProcessEvents()
                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMFlushEvents

    protected void DMFlushEvents()
                          throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMForceReadEvents

    protected void DMForceReadEvents()
                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMProcessEventsInBackground

    protected java.util.Vector DMProcessEventsInBackground()
                                                    throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMDisconnect

    protected void DMDisconnect()
                         throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMVersionNumber

    protected long DMVersionNumber()
                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMVersionString

    protected java.lang.String DMVersionString()
                                        throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMSchemaVersionNumber

    protected long DMSchemaVersionNumber()
                                  throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMSchemaVersionString

    protected java.lang.String DMSchemaVersionString()
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMListWastebasketSelectorItems

    protected java.util.Vector DMListWastebasketSelectorItems(java.lang.String searchClass,
                                                              java.lang.String searchDefinition,
                                                              boolean recursive,
                                                              SortSpecification sort)
                                                       throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetWastebasketSelectorItemCount

    protected long DMGetWastebasketSelectorItemCount(java.lang.String searchClass,
                                                     java.lang.String searchDefinition,
                                                     boolean recursive)
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMOpenWastebasketSelector

    protected long DMOpenWastebasketSelector(java.lang.String searchClass,
                                             java.lang.String searchDefinition,
                                             boolean recursive,
                                             SortSpecification sort)
                                      throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMPostAuditEvent

    protected void DMPostAuditEvent(AuditEvent event,
                                    int mode)
                             throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMSelectRawAuditEvents

    protected RawAuditEvent[] DMSelectRawAuditEvents(java.lang.String filterClause,
                                                     int maxItems)
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRemoveRawAuditEvents

    protected void DMRemoveRawAuditEvents(RawAuditEvent[] rawEvents)
                                   throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMHandleAuditEventDispatchRequests

    protected void DMHandleAuditEventDispatchRequests(java.util.ArrayList reqList,
                                                      java.lang.String tableName)
                                               throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMSelectAuditEvents

    protected AuditEvent[] DMSelectAuditEvents(java.lang.Long auditSpec,
                                               java.lang.String filterClause,
                                               java.lang.String sortClause,
                                               int maxItems)
                                        throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMSelectAggregateAuditEventColumns

    protected AttributeValue[] DMSelectAggregateAuditEventColumns(java.lang.Long auditSpec,
                                                                  java.lang.String aggFuncName,
                                                                  java.lang.String[] columnNames,
                                                                  java.lang.String[] aggColumnNames,
                                                                  java.lang.String filterClause,
                                                                  java.lang.String sortClause)
                                                           throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRemoveAuditEvents

    protected void DMRemoveAuditEvents(long[] eventIds,
                                       java.lang.String tableName)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRemoveAuditEventsForTarget

    protected void DMRemoveAuditEventsForTarget(java.lang.Long specId,
                                                java.lang.Long targetId)
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMSelectSpecificAuditFolderPath

    protected AuditFolderPath DMSelectSpecificAuditFolderPath(long folderPathId)
                                                       throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRegisterAuditEventOperationType

    protected int DMRegisterAuditEventOperationType(java.lang.String opTypeKey,
                                                    int targetCode,
                                                    java.lang.String targetClass,
                                                    int opCode,
                                                    java.lang.Boolean createOrFree)
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMUnregisterAuditEventOperationType

    protected void DMUnregisterAuditEventOperationType(java.lang.String opTypeKey)
                                                throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMLookupAuditEventOperationTypes

    protected int[] DMLookupAuditEventOperationTypes(java.lang.String[] keys)
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMLookupAuditEventOperationTypeKeys

    protected java.lang.String[] DMLookupAuditEventOperationTypeKeys(int[] opTypes)
                                                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMLookupAuditTargetCode

    public AuditTargetCode DMLookupAuditTargetCode(java.lang.String className)
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetAuditTypesForClass

    protected AttributeValue[] DMGetAuditTypesForClass(java.lang.String className,
                                                       boolean includeNested)
                                                throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetAuditTypesForCreateOperations

    protected AttributeValue[] DMGetAuditTypesForCreateOperations()
                                                           throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetAuditTypesForFreeOperations

    protected AttributeValue[] DMGetAuditTypesForFreeOperations()
                                                         throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetCustomAuditTypes

    protected AttributeValue[] DMGetCustomAuditTypes()
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRegisterCustomAuditEventOperationCodeKey

    protected int DMRegisterCustomAuditEventOperationCodeKey(java.lang.String opCodeKey)
                                                      throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetHighestAuditId

    protected long DMGetHighestAuditId()
                                throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetAuditCertificates

    protected AuditCertificate[] DMGetAuditCertificates(java.lang.Long[] objectIds)
                                                 throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMEmptyWastebasket

    protected void DMEmptyWastebasket()
                               throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMFilterDeletedObjects

    protected void DMFilterDeletedObjects(boolean mode)
                                   throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMSetExecutionMode

    protected void DMSetExecutionMode(int mode)
                               throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMIsExecutionMode

    protected boolean DMIsExecutionMode(int mode)
                                 throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMPushTemporaryExecutionMode

    protected void DMPushTemporaryExecutionMode(int mode)

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  (Unpublished)

### DMPopTemporaryExecutionMode

    protected void DMPopTemporaryExecutionMode()

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  (Unpublished)

### DMPushTemporaryAccessCheckMode

    protected void DMPushTemporaryAccessCheckMode(boolean mode)

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  (Unpublished)

### DMPopTemporaryAccessCheckMode

    protected void DMPopTemporaryAccessCheckMode()

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  (Unpublished)

### DMSendClientVersionInformation

    protected void DMSendClientVersionInformation(long versionNumber,
                                                  java.lang.String versionString)
                                           throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMFeignUser

    protected void DMFeignUser(java.lang.Long id,
                               java.lang.Long classid)
                        throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMPersistTokenCredential

    public void DMPersistTokenCredential(TokenCredential credential)
                                  throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMInvalidateTokenCredentials

    public void DMInvalidateTokenCredentials(java.lang.Long userId)
                                      throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMReauthenticate

    protected boolean DMReauthenticate(Credential credential,
                                       ConnectOptions options)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGrantAdmin

    protected void DMGrantAdmin(java.lang.Long userid)
                         throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetPrimaryUserProfile

    protected S_LibraryObjectData DMGetPrimaryUserProfile(java.lang.Long id)
                                                   throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetDirectoryUserData

    protected S_LibraryObjectData DMGetDirectoryUserData()
                                                  throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-name remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetOurPrimaryUserProfile

    protected S_LibraryObjectData DMGetOurPrimaryUserProfile()
                                                      throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMCalculateConsumedStorage

    protected void DMCalculateConsumedStorage(java.lang.Long id,
                                              java.lang.Long classid)
                                       throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetArrayTypeAttributeValue

    protected AttributeValue DMGetArrayTypeAttributeValue(long objectId,
                                                          long attributeId,
                                                          long auditId,
                                                          int count)
                                                   throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetArrayReferencingObjects

    protected java.util.Vector DMGetArrayReferencingObjects(java.lang.Long attributeId,
                                                            AttributeValue referencedValue,
                                                            SortSpecification sort)
                                                     throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetResolvedClassObjectData

    protected S_ClassObjectData DMGetResolvedClassObjectData(java.lang.Long id)
                                                      throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetAttributesRsn

    protected long DMGetAttributesRsn()
                               throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMAddMemberToDirectoryGroup

    protected void DMAddMemberToDirectoryGroup(java.lang.Long group_id,
                                               java.lang.Long classid,
                                               java.lang.Long rightObj,
                                               java.lang.Long rightObjClassid)
                                        throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRemoveMemberFromDirectoryGroup

    protected void DMRemoveMemberFromDirectoryGroup(java.lang.Long group_id,
                                                    java.lang.Long classid,
                                                    java.lang.Long rightObj,
                                                    java.lang.Long rightObjClassid)
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMAddMembersToDirectoryGroup

    protected void DMAddMembersToDirectoryGroup(java.lang.Long group_id,
                                                java.lang.Long classid,
                                                java.lang.Long[] rightObjIds,
                                                java.lang.Long[] rightObjClassids)
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRemoveMembersFromDirectoryGroup

    protected void DMRemoveMembersFromDirectoryGroup(java.lang.Long group_id,
                                                     java.lang.Long classid,
                                                     java.lang.Long[] rightObjIds,
                                                     java.lang.Long[] rightObjClassids)
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetAllMembersOfDirectoryGroup

    protected java.lang.Long[] DMGetAllMembersOfDirectoryGroup(java.lang.Long id,
                                                               java.lang.Long classid,
                                                               boolean filterForDiscoverability)
                                                        throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetDirectMembersOfDirectoryGroup

    protected java.lang.Long[] DMGetDirectMembersOfDirectoryGroup(java.lang.Long id,
                                                                  java.lang.Long userid,
                                                                  boolean filterForDiscoverability)
                                                           throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMIsDirectMemberOfDirectoryGroup

    protected boolean DMIsDirectMemberOfDirectoryGroup(java.lang.Long groupId,
                                                       java.lang.Long groupClassId,
                                                       java.lang.Long userId,
                                                       java.lang.Long userClassId)
                                                throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMIsMemberOfDirectoryGroup

    protected boolean DMIsMemberOfDirectoryGroup(java.lang.Long groupId,
                                                 java.lang.Long groupClassId,
                                                 java.lang.Long userId,
                                                 java.lang.Long userClassId)
                                          throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetCategoryIds

    protected java.lang.Long[] DMGetCategoryIds(java.lang.Long id,
                                                java.lang.Long classid)
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetAllAncestorsOfDirectoryObject

    protected java.lang.Long[] DMGetAllAncestorsOfDirectoryObject(java.lang.Long id,
                                                                  java.lang.Long userid)
                                                           throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetDirectAncestorsOfDirectoryObject

    protected java.lang.Long[] DMGetDirectAncestorsOfDirectoryObject(java.lang.Long id,
                                                                     java.lang.Long userid)
                                                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetCompositeAclIds

    protected java.lang.Long[] DMGetCompositeAclIds(java.lang.Long id,
                                                    java.lang.Long classid,
                                                    SortSpecification sort)
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetPublicObjectsReferringToLockObject

    protected java.util.Vector DMGetPublicObjectsReferringToLockObject(java.lang.Long id,
                                                                       java.lang.Long classid,
                                                                       SortSpecification sort)
                                                                throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMIsLockObjectShared

    protected boolean DMIsLockObjectShared(java.lang.Long id,
                                           java.lang.Long classid)
                                    throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetLockedForSessionObjects

    protected java.util.Vector DMGetLockedForSessionObjects()
                                                     throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMCopyLibraryObject

    protected S_LibraryObjectData DMCopyLibraryObject(java.lang.Long id,
                                                      java.lang.Long classId,
                                                      S_LibraryObjectDefinition sdef)
                                               throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetObjectReferenceAttribute

    protected ObjectReferenceAttributeValue DMGetObjectReferenceAttribute(java.lang.Long id,
                                                                          java.lang.Long classId,
                                                                          java.lang.String attrName)
                                                                   throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMConvertToPrivateACL

    protected S_LibraryObjectData DMConvertToPrivateACL(java.lang.Long id,
                                                        java.lang.Long classId,
                                                        S_LibraryObjectDefinition sdef)
                                                 throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMNewPublicObject

    protected S_LibraryObjectData DMNewPublicObject(S_LibraryObjectDefinition def)
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMNewSystemObject

    protected S_LibraryObjectData DMNewSystemObject(S_LibraryObjectDefinition def)
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMNewSchemaObject

    protected S_LibraryObjectData DMNewSchemaObject(S_LibraryObjectDefinition def)
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMSetAttributes

    protected S_LibraryObjectDefinition DMSetAttributes(java.lang.Long id,
                                                        java.lang.Long classId,
                                                        S_LibraryObjectDefinition def)
                                                 throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMLockRows

    protected void DMLockRows(java.lang.Long id,
                              java.lang.Long classId)
                       throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMInvokeServerMethod

    protected java.io.Serializable DMInvokeServerMethod(java.lang.Long id,
                                                        java.lang.Long classId,
                                                        java.lang.String methodName,
                                                        java.io.Serializable payload)
                                                 throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMInvokeOperation

    protected java.lang.Object DMInvokeOperation(java.lang.Long id,
                                                 java.lang.Long classId,
                                                 OperationContext op)
                                          throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMDelete

    protected void DMDelete(java.lang.Long id,
                            java.lang.Long classId,
                            S_LibraryObjectDefinition def)
                     throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMUndelete

    protected void DMUndelete(java.lang.Long id,
                              java.lang.Long classId,
                              S_LibraryObjectDefinition def)
                       throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMFree

    protected void DMFree(java.lang.Long id,
                          java.lang.Long classId,
                          S_LibraryObjectDefinition def)
                   throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMAddAttributeToClassObject

    public java.lang.Long DMAddAttributeToClassObject(java.lang.Long id,
                                                      S_LibraryObjectDefinition def)
                                               throws IfsException

  Description copied from class: `LibrarySession`
  Adds an Attribute to an existing ClassObject.

  Parameters:
    `id` - the ClassObject id
    `def` - the Attribute definition
  Returns:
    the new Attribute id
  Throws:
    `IfsException` - (IFS-30820) if the operation fails
  (Unpublished)

### DMRemoveAttributeFromClassObject

    public void DMRemoveAttributeFromClassObject(java.lang.Long id,
                                                 S_LibraryObjectDefinition def)
                                          throws IfsException

  Description copied from class: `LibrarySession`
  Removes an Attribute from an existing ClassObject.

  Parameters:
    `id` - the Attribute id
    `def` - a definition that influences how the attribute is removed, or null for default behavior
  Throws:
    `IfsException` - (IFS-30821) if the operation fails
  (Unpublished)

### DMfetchACEs

    protected java.lang.Long[] DMfetchACEs(java.lang.Long id,
                                           java.lang.Long classId)
                                    throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMaddAccessControlEntry

    protected S_LibraryObjectData DMaddAccessControlEntry(java.lang.Long id,
                                                          java.lang.Long classId,
                                                          S_LibraryObjectDefinition sdef)
                                                   throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRemoveAccessControlEntry

    protected void DMRemoveAccessControlEntry(java.lang.Long id,
                                              java.lang.Long classId,
                                              java.lang.Long aceId,
                                              java.lang.Long aceClassId)
                                       throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMupdateAccessControlEntry

    protected void DMupdateAccessControlEntry(java.lang.Long id,
                                              java.lang.Long classId,
                                              java.lang.Long aceId,
                                              java.lang.Long aceClassId,
                                              S_LibraryObjectDefinition sdef)
                                       throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMremoveAllAccessControlEntries

    protected void DMremoveAllAccessControlEntries(java.lang.Long id,
                                                   java.lang.Long classId)
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetAccessLevel

    protected AccessLevel DMGetAccessLevel(java.lang.Long id,
                                           java.lang.Long classId,
                                           java.lang.Long userId)
                                    throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetDiscoverabilityOfPublicObjectsIds

    protected java.lang.Long[] DMGetDiscoverabilityOfPublicObjectsIds(java.lang.Long[] ids)
                                                               throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMApplyFolderIndexDeferredUpdate

    protected void DMApplyFolderIndexDeferredUpdate(FolderIndexDeferredUpdate entry)
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetFolderIndexDeferredUpdates

    protected java.util.Vector DMGetFolderIndexDeferredUpdates(int maxItems)
                                                        throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMIsAclIndexUpdateModeSynchronous

    protected boolean DMIsAclIndexUpdateModeSynchronous()
                                                 throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMApplyAclIndexDeferredUpdate

    protected void DMApplyAclIndexDeferredUpdate(AccessControlListDeferredUpdate entry,
                                                 boolean deleteAfterProcessing)
                                          throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetAclIndexDeferredUpdates

    protected java.util.Vector DMGetAclIndexDeferredUpdates(int maxItems)
                                                     throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMDeleteAclIndexDeferredUpdates

    protected void DMDeleteAclIndexDeferredUpdates(java.lang.Long[] ids)
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetExpiredTimedLocks

    protected java.util.Vector DMGetExpiredTimedLocks(int maxItems,
                                                      int offset)
                                               throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMReleaseExpiredLockObject

    protected int DMReleaseExpiredLockObject(java.lang.Long id,
                                             java.lang.Long classId)
                                      throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMResolveObjects

    protected void DMResolveObjects(java.lang.Long[] ids,
                                    java.lang.Long[] classIds,
                                    ObjectResolverSpecification spec)
                             throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMFetchProperties

    protected java.util.Vector DMFetchProperties(java.lang.Long propertyBundleId,
                                                 java.lang.Long propertyBundleClassId)
                                          throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetProperty

    protected AttributeValue DMGetProperty(java.lang.Long propertyBundleId,
                                           java.lang.Long propertyBundleClassId,
                                           java.lang.String propertyName)
                                    throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMFetchPolicyListElements

    protected java.util.Vector DMFetchPolicyListElements(java.lang.Long policyListId,
                                                         java.lang.Long policyListClassId)
                                                  throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetEffectiveClassPolicyListElements

    protected java.util.Vector DMGetEffectiveClassPolicyListElements(java.lang.Long id,
                                                                     java.lang.Long classId,
                                                                     java.lang.String operation)
                                                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetEffectivePolicyListElements

    protected java.util.Vector DMGetEffectivePolicyListElements(java.lang.Long id,
                                                                java.lang.Long classId,
                                                                java.lang.String operation)
                                                         throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetFolderReferences

    protected java.lang.Long[] DMGetFolderReferences(java.lang.Long publicObject_id,
                                                     java.lang.Long classid,
                                                     SortSpecification sort)
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMListItems

    protected java.util.Vector DMListItems(java.lang.Long folder_id,
                                           java.lang.Long classid,
                                           java.lang.String folderRelClassname,
                                           SortSpecification sort)
                                    throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMAddToFolder

    protected void DMAddToFolder(java.lang.Long folder_id,
                                 java.lang.Long classid,
                                 java.lang.Long rightObj,
                                 java.lang.Long rightObjClassid)
                          throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMAddFolderRelationship

    protected void DMAddFolderRelationship(java.lang.Long id,
                                           java.lang.Long classId,
                                           S_LibraryObjectDefinition def)
                                    throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRemoveFromFolder

    protected void DMRemoveFromFolder(java.lang.Long folder_id,
                                      java.lang.Long classid,
                                      java.lang.Long rightObj,
                                      java.lang.Long rightObjClassid,
                                      S_LibraryObjectDefinition def)
                               throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMFindPublicObjectByPath

    protected S_LibraryObjectData DMFindPublicObjectByPath(java.lang.Long folder_id,
                                                           java.lang.Long classid,
                                                           java.lang.String path)
                                                    throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMCheckExistenceOfPublicObjectByPath

    protected boolean DMCheckExistenceOfPublicObjectByPath(java.lang.Long folder_id,
                                                           java.lang.Long classid,
                                                           java.lang.String path)
                                                    throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetAnyFolderPath

    protected java.lang.String DMGetAnyFolderPath(java.lang.Long id,
                                                  java.lang.Long classid,
                                                  java.lang.Long folderRefId,
                                                  java.lang.Long folderRefClassid,
                                                  FolderPathOptions fpo,
                                                  SortSpecification sort)
                                           throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetAllFolderPaths

    protected java.lang.String[] DMGetAllFolderPaths(java.lang.Long id,
                                                     java.lang.Long classid,
                                                     java.lang.Long folderRefId,
                                                     java.lang.Long folderRefClassid,
                                                     FolderPathOptions fpo,
                                                     SortSpecification sort)
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetFolderItemCount

    protected long DMGetFolderItemCount(java.lang.Long folder_id,
                                        java.lang.Long classId,
                                        java.lang.String folderRelClassname)
                                 throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMFolderHasSubFolders

    public boolean DMFolderHasSubFolders(java.lang.Long folder_id,
                                         java.lang.Long classId)
                                  throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetSubfolderCount

    protected long DMGetSubfolderCount(java.lang.Long folder_id,
                                       java.lang.Long classId,
                                       java.lang.String folderRelClassname)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMOpenFolder

    protected void DMOpenFolder(java.lang.Long folder_id,
                                java.lang.Long classid,
                                java.lang.String folderRelClassname,
                                SortSpecification sort)
                         throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMNextFolderItem

    protected S_LibraryObjectData DMNextFolderItem(java.lang.Long folder_id,
                                                   java.lang.Long classid)
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMCloseFolder

    protected void DMCloseFolder(java.lang.Long folder_id,
                                 java.lang.Long classid)
                          throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetFolderItemList

    protected java.lang.Long[] DMGetFolderItemList(java.lang.Long folder_id,
                                                   java.lang.Long classid,
                                                   SortSpecification sort)
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetTotalFolderItemCount

    protected int DMGetTotalFolderItemCount(java.lang.Long folder_id,
                                            java.lang.Long classid)
                                     throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMListSelectorItems

    protected java.util.Vector DMListSelectorItems(java.lang.String searchClass,
                                                   java.lang.String searchDefinition,
                                                   boolean recursive,
                                                   int maxItemCount,
                                                   SortSpecification sort)
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMListPreparedSelectorItems

    protected java.util.Vector DMListPreparedSelectorItems(java.lang.String statementKey,
                                                           boolean distinct,
                                                           AttributeValue searchTarget,
                                                           AttributeValue[] auxSearchTargets,
                                                           java.lang.String searchDefinition,
                                                           boolean recursive,
                                                           java.lang.String language,
                                                           int maxItemCount,
                                                           int rowNumber,
                                                           java.lang.String hint,
                                                           SortSpecification sort,
                                                           AttributeValue[] bindValues)
                                                    throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetPreparedSelectorItemCount

    protected int DMGetPreparedSelectorItemCount(java.lang.String statementKey,
                                                 boolean distinct,
                                                 AttributeValue searchTarget,
                                                 AttributeValue[] auxSearchTargets,
                                                 java.lang.String searchDefinition,
                                                 boolean recursive,
                                                 java.lang.String hint,
                                                 AttributeValue[] bindValues)
                                          throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetSelectorItemCount

    protected long DMGetSelectorItemCount(java.lang.String searchClass,
                                          java.lang.String searchDefinition,
                                          boolean recursive)
                                   throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMOpenSelector

    protected long DMOpenSelector(java.lang.String searchClass,
                                  java.lang.String searchDefinition,
                                  boolean recursive,
                                  SortSpecification sort)
                           throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMNextSelectorItem

    protected S_LibraryObjectData DMNextSelectorItem(long cursorId)
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMNextSelectorBatch

    protected java.util.Vector DMNextSelectorBatch(long cursorId,
                                                   int batchSize)
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMCloseSelector

    protected void DMCloseSelector(long cursorId)
                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMNewSearch

    protected java.lang.Long DMNewSearch()
                                  throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMNewSearchFromObject

    protected java.lang.Long DMNewSearchFromObject(java.lang.Long srchObjId)
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetSearchSpecification

    protected SearchSpecification DMGetSearchSpecification(java.lang.Long srchId)
                                                    throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMSetSearchSpecification

    protected void DMSetSearchSpecification(java.lang.Long srchId,
                                            SearchSpecification sp)
                                     throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMOpenSearch

    protected void DMOpenSearch(java.lang.Long id,
                                java.util.Vector bindValues,
                                java.lang.String language,
                                int timeout)
                         throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMgetSearchItemCount

    protected int DMgetSearchItemCount(java.lang.Long id,
                                       java.util.Vector bindValues,
                                       java.lang.String language,
                                       int timeout)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMgetSearchSQLString

    protected java.lang.String DMgetSearchSQLString(java.lang.Long id)
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMNextSearchItems

    protected java.util.Vector DMNextSearchItems(java.lang.Long id,
                                                 int batchCount)
                                          throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMCloseSearch

    protected void DMCloseSearch(java.lang.Long id)
                          throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMDisposeSearch

    protected void DMDisposeSearch(java.lang.Long id)
                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMCreateView

    protected void DMCreateView(ViewSpecification vsp)
                         throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetPartitionValue

    public java.lang.Long DMGetPartitionValue(java.lang.Long id,
                                              java.lang.Long classId)
                                       throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetLastAccessDate

    public java.util.Date DMGetLastAccessDate(java.lang.Long id,
                                              java.lang.Long classId)
                                       throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetContentStream

    protected ContentStreamSerializer DMGetContentStream(java.lang.Long id,
                                                         java.lang.Long classId,
                                                         java.lang.Long refObjId,
                                                         java.lang.Long refObjClassId)
                                                  throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetContentReader

    protected ContentStreamSerializer DMGetContentReader(java.lang.Long id,
                                                         java.lang.Long classId,
                                                         java.lang.Long refObjId,
                                                         java.lang.Long refObjClassId)
                                                  throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### clearRaciSessionContext

    public void clearRaciSessionContext(RandomAccessContentInterface raci)
                                 throws IfsException

  Deprecated. CMSDK 10gR2: use RandomAccessor

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### reestablishRaciSessionContext

    public void reestablishRaciSessionContext(RandomAccessContentInterface raci)
                                       throws IfsException

  Deprecated. CMSDK 10gR2: use RandomAccessor

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetContentByRandomAccess

    protected RandomAccessor DMGetContentByRandomAccess(java.lang.Long coId,
                                                        java.lang.Long coClassId,
                                                        java.lang.Long refObjId,
                                                        java.lang.Long refObjClassId)
                                                 throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMUpdateContentByRandomAccess

    protected RandomAccessor DMUpdateContentByRandomAccess(java.lang.Long docId,
                                                           java.lang.Long docClassId,
                                                           S_LibraryObjectDefinition sdocdef,
                                                           java.lang.Long expirationPeriod)
                                                    throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRandomAccessorGetDocumentId

    protected java.lang.Long DMRandomAccessorGetDocumentId(S_RandomAccessorImpl ra)
                                                    throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRandomAccessorGetContentObjectId

    protected java.lang.Long DMRandomAccessorGetContentObjectId(S_RandomAccessorImpl ra)
                                                         throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRandomAccessorSetSession

    protected void DMRandomAccessorSetSession(S_RandomAccessorImpl ra)
                                       throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRandomAccessorRead

    protected int DMRandomAccessorRead(S_RandomAccessorImpl ra,
                                       long pos,
                                       byte[] b,
                                       int off,
                                       int len)
                                throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRandomAccessorIsWriteable

    protected boolean DMRandomAccessorIsWriteable(S_RandomAccessorImpl ra)
                                           throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRandomAccessorWrite

    protected void DMRandomAccessorWrite(S_RandomAccessorImpl ra,
                                         long pos,
                                         byte[] b,
                                         int off,
                                         int len)
                                  throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRandomAccessorTruncate

    protected void DMRandomAccessorTruncate(S_RandomAccessorImpl ra,
                                            long len)
                                     throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRandomAccessorLength

    protected long DMRandomAccessorLength(S_RandomAccessorImpl ra)
                                   throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRandomAccessorDispose

    protected void DMRandomAccessorDispose(S_RandomAccessorImpl ra)
                                    throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRandomAccessorClose

    protected void DMRandomAccessorClose(S_RandomAccessorImpl ra)
                                  throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMNewContentStreamSerializer

    protected ContentStreamSerializer DMNewContentStreamSerializer()
                                                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMIsContentReadByUser

    protected boolean DMIsContentReadByUser(java.lang.Long id,
                                            java.lang.Long classId)
                                     throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMIsContextIndexEnabled

    protected boolean DMIsContextIndexEnabled()
                                       throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMSetContentReadByUser

    protected void DMSetContentReadByUser(java.lang.Long id,
                                          java.lang.Long classId,
                                          boolean readState,
                                          java.lang.Long refObjId,
                                          java.lang.Long refObjClassId)
                                   throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRender

    protected ContentStreamSerializer DMRender(java.lang.Long id,
                                               java.lang.Long classId,
                                               java.lang.String rendererType,
                                               java.lang.String rendererName,
                                               java.util.Hashtable options,
                                               boolean reader)
                                        throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMIsVersionable

    protected boolean DMIsVersionable(java.lang.Long id,
                                      java.lang.Long classId)
                               throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMIsInstanceOfClassVersionable

    protected boolean DMIsInstanceOfClassVersionable(java.lang.Long classId)
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMUnReserve

    protected void DMUnReserve(java.lang.Long id,
                               java.lang.Long classId)
                        throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMNewRevision

    protected S_LibraryObjectData DMNewRevision(java.lang.Long id,
                                                java.lang.Long classId,
                                                S_LibraryObjectDefinition def)
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMReserveNext

    protected void DMReserveNext(java.lang.Long id,
                                 java.lang.Long classId,
                                 java.lang.String contentPath,
                                 java.lang.String comment)
                          throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMNewVersionSeries

    protected S_LibraryObjectData DMNewVersionSeries(java.lang.Long id,
                                                     java.lang.Long classId,
                                                     S_LibraryObjectDefinition def)
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMNewBranchedVersionSeries

    protected S_LibraryObjectData DMNewBranchedVersionSeries(java.lang.Long id,
                                                             java.lang.Long classId,
                                                             S_LibraryObjectDefinition def)
                                                      throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMIntegrateIntoVersionSeries

    protected void DMIntegrateIntoVersionSeries(java.lang.Long sid,
                                                java.lang.Long sclassId,
                                                java.lang.Long tid,
                                                java.lang.Long tclassId)
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMfetchRevisions

    protected java.lang.Long[] DMfetchRevisions(java.lang.Long id,
                                                java.lang.Long classId)
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMfetchVersionSerieses

    protected java.lang.Long[] DMfetchVersionSerieses(java.lang.Long id,
                                                      java.lang.Long classId)
                                               throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetLinks

    protected java.lang.Long[] DMGetLinks(java.lang.Long id,
                                          java.lang.Long classId)
                                   throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMReassociateLinks

    protected void DMReassociateLinks(java.lang.Long oldId,
                                      java.lang.Long oldClassId,
                                      java.lang.Long newId,
                                      java.lang.Long newClassId)
                               throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMAddRelationship

    protected S_LibraryObjectData DMAddRelationship(java.lang.Long id,
                                                    java.lang.Long classId,
                                                    S_LibraryObjectDefinition def)
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRemoveRelationship

    protected void DMRemoveRelationship(java.lang.Long id,
                                        java.lang.Long classId,
                                        java.lang.Long relId,
                                        java.lang.Long relClassId)
                                 throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetRightwardRelationshipObjects

    protected java.util.Vector DMGetRightwardRelationshipObjects(java.lang.Long id,
                                                                 java.lang.Long classId,
                                                                 java.lang.Long relClassId,
                                                                 SortSpecification sort)
                                                          throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetLeftwardRelationshipObjects

    protected java.util.Vector DMGetLeftwardRelationshipObjects(java.lang.Long id,
                                                                java.lang.Long classId,
                                                                java.lang.Long relClassId,
                                                                SortSpecification sort)
                                                         throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetRightwardRelationships

    protected java.util.Vector DMGetRightwardRelationships(java.lang.Long id,
                                                           java.lang.Long classId,
                                                           java.lang.Long relClassId,
                                                           SortSpecification sort)
                                                    throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetLeftwardRelationships

    protected java.util.Vector DMGetLeftwardRelationships(java.lang.Long id,
                                                          java.lang.Long classId,
                                                          java.lang.Long relClassId,
                                                          SortSpecification sort)
                                                   throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetLeftwardRelationshipsCount

    protected long DMGetLeftwardRelationshipsCount(java.lang.Long id,
                                                   java.lang.Long classId,
                                                   java.lang.Long relClassId)
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMBeginTransaction

    protected Transaction DMBeginTransaction(boolean writeable)
                                      throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMCompleteTransaction

    protected void DMCompleteTransaction(Transaction transaction)
                                  throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMAbortTransaction

    protected void DMAbortTransaction(Transaction transaction)
                               throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMCommit

    protected void DMCommit()
                     throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMRollback

    protected void DMRollback()
                       throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMIsTransactionInProgress

    protected boolean DMIsTransactionInProgress()
                                         throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMgetLibraryObjectData

    protected S_LibraryObjectData DMgetLibraryObjectData(java.lang.Long id,
                                                         java.lang.Long classId,
                                                         java.lang.String attributeName,
                                                         boolean selectFully)
                                                  throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetPublicObjectData

    protected S_LibraryObjectData DMGetPublicObjectData(java.lang.Long id,
                                                        java.lang.Long classId)
                                                 throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetSystemObjectData

    protected S_LibraryObjectData DMGetSystemObjectData(java.lang.Long id,
                                                        java.lang.Long classId)
                                                 throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetSchemaObjectData

    protected S_LibraryObjectData DMGetSchemaObjectData(java.lang.Long id,
                                                        java.lang.Long classId)
                                                 throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGenerateThemes

    protected void DMGenerateThemes(java.lang.Long contentId,
                                    java.lang.Long contentClassId,
                                    boolean fullThemes,
                                    java.lang.Long refObjId,
                                    java.lang.Long refObjClassId)
                             throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMEnqueueMessage

    protected void DMEnqueueMessage(java.lang.Long id,
                                    java.lang.Long classId,
                                    oracle.sql.ORAData message)
                             throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Parameters:
    `id` - id of the Queue
    `classId` - classId of the Queue
    `message` - message to be enqueued
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMEnqueueMessage

    protected void DMEnqueueMessage(java.lang.Long id,
                                    java.lang.Long classId,
                                    oracle.sql.ORAData message,
                                    java.lang.String correlation)
                             throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Parameters:
    `id` - id of the Queue
    `classId` - classId of the Queue
    `message` - message to be enqueued
    `correlation` - correlation for the message
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetConsumedStorage

    protected long DMGetConsumedStorage(java.lang.Long id,
                                        java.lang.Long classId)
                                 throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Parameters:
    `id` - id of the object
    `classId` - classId of the object
  Returns:
    storage consumed by the object
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMDequeueMessage

    protected oracle.sql.ORAData DMDequeueMessage(java.lang.Long id,
                                                  java.lang.Long classId,
                                                  java.lang.String subscriberName)
                                           throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Parameters:
    `id` - id of the Queue
    `classId` - classId of the Queue
    `subscriberName` - name of the subscriber dequeueing the message
  Returns:
    message if one is available; NULL otherwise.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMDequeueMessageFromExceptionQueue

    protected oracle.sql.ORAData DMDequeueMessageFromExceptionQueue(java.lang.Long id,
                                                                    java.lang.Long classId)
                                                             throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Parameters:
    `id` - id of the Queue
    `classId` - classId of the Queue
  Returns:
    message if one is available; NULL otherwise.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetThemes

    protected ContextTheme[] DMGetThemes(java.lang.Long contentId,
                                         java.lang.Long contentClassId,
                                         java.lang.Long refObjId,
                                         java.lang.Long refObjClassId)
                                  throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGenerateSummary

    protected void DMGenerateSummary(java.lang.Long contentId,
                                     java.lang.Long contentClassId,
                                     java.lang.String pointOfView,
                                     long sizeAsPercent,
                                     long sizeAsNumParagraphs,
                                     java.lang.String summaryLevel,
                                     java.lang.Long refObjId,
                                     java.lang.Long refObjClassId)
                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetSummary

    protected ContentStreamSerializer DMGetSummary(java.lang.Long contentId,
                                                   java.lang.Long contentClassId,
                                                   java.lang.String pointOfView,
                                                   java.lang.Long refObjId,
                                                   java.lang.Long refObjClassId)
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMFilterContent

    protected void DMFilterContent(java.lang.Long contentId,
                                   java.lang.Long contentClassId,
                                   boolean plaintext,
                                   java.lang.Long refObjId,
                                   java.lang.Long refObjClassId)
                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetSLibraryObjectDefinition

    protected S_LibraryObjectDefinition DMGetSLibraryObjectDefinition(java.lang.Long id,
                                                                      java.lang.Long classId)
                                                               throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetIdsForNewObjects

    protected java.lang.Long[] DMGetIdsForNewObjects(int length)
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetFilteredContent

    protected ContentStreamSerializer DMGetFilteredContent(java.lang.Long contentId,
                                                           java.lang.Long contentClassId,
                                                           java.lang.Long refObjId,
                                                           java.lang.Long refObjClassId)
                                                    throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetNLSDatabaseParameterValue

    protected java.lang.String DMGetNLSDatabaseParameterValue(java.lang.String parameter)
                                                       throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMCreateDefaultPropertyBundle

    protected S_LibraryObjectData DMCreateDefaultPropertyBundle(java.lang.Long id,
                                                                java.lang.Long classId)
                                                         throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMCreateDefaultPolicyPropertyBundle

    protected S_LibraryObjectData DMCreateDefaultPolicyPropertyBundle(java.lang.Long id,
                                                                      java.lang.Long classId)
                                                               throws IfsException

  Deprecated. CM SDK 10gR2: see release notes for changes to Policy framework

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMIsAttributeValueInValueDomain

    protected boolean DMIsAttributeValueInValueDomain(java.lang.Long id,
                                                      java.lang.Long classId,
                                                      AttributeValue av)
                                               throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMCreateRetainedEventDatabaseObjects

    public void DMCreateRetainedEventDatabaseObjects(RetainedEvent event)
                                              throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMDropRetainedEventDatabaseObjects

    public void DMDropRetainedEventDatabaseObjects(RetainedEvent event)
                                            throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMInsertRetainedEvent

    public void DMInsertRetainedEvent(RetainedEvent event)
                               throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMDeleteRetainedEvent

    protected void DMDeleteRetainedEvent(RetainedEvent event)
                                  throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### DMGetRetainedEvents

    protected RetainedEvent[] DMGetRetainedEvents(RetainedEvent event,
                                                  int maxItems)
                                           throws IfsException

  Description copied from class: `LibrarySession`
  Invokes the identically-named remote S_LibrarySession method.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getServerProperty

    public final java.lang.String getServerProperty(java.lang.String key,
                                                    java.lang.String defaultValue)
                                             throws IfsException

  Description copied from class: `LibrarySession`
  Gets the String value for the specified key in the server properties file.

  Parameters:
    `key` - the key
    `defaultValue` - the default value if the key is invalid
  Returns:
    the value
  Throws:
    `IfsException` - if an error occurs
  (Published)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD